import formatRender from "../compoment/formPlugin/formatters/formatRender";
import {Replace} from 'sasp-base';
import axios from "axios/index";
import {AjaxUtil} from "sasp-base";
import {platValidator} from "sasp-base";
import PlDataCurrency from "../../../mix/plDataCurrecy";
import buttonRecord from "../../../js/buttonRecord";
import CacheGlobal from "../../../../assets/js/global/cacheGlobal";


const formMixins = {
    /**
     * 列表视图预览
     */
    props: {
        listViewId: {type: String},//列表视图id
        sourceId: {type: String},//共享的数据源ID，可以通过此数据源ID设置为实际使用的数据源ID
        conditionId: {type: String, default: ""},//条件定义id, 数据权限中多条件用逗号分隔
        linkTreeViewId: {type: String, default: ""},//关联列表树定义
        extraCondition: {type: String, default: ""},//额外的条件
        equilibriumData: {
            type: Object, default: () => {
                return {};
            }
        },//条件外部参数的值，如在条件中定义了值为${aa}，那么我们传递{aa:11}替换

        isEjectTable: {type: String, default: "0"},//是否是弹出数据表
        isEjectTableShowSelect: {type: Boolean, default: false},//弹出数据表显示选择框
        isEjectTableShowTopButton: {type: Boolean, default: false},//弹出数据表显示顶部按钮
        isEjectTableShowRowButton: {type: Boolean, default: true},//弹出数据表显示行选择按钮
        isEditTable: {type: String, default: "0"},//是否是编辑列表
        editParamSet: {
            type: Object, default: () => {
                return {}
            }
        },//编辑列表配置参数
        isViewTable: {type: String, default: "0"},//是否是查看列表
        isNeedPage: {type: String, default: "0"},//查看列表是否需要分页
        isTablePreview: {type: String, default: "0"},//是否是表单预览
        callfillFieldArr: {
            type: Array, default: () => {
                return [];
            }
        },//查看列表选择按钮的回填字段
        relationId: {type: String, default: ""},
        onlyData: {type: String, default: "0"},//仅能添加一条数据
        optOwnData: {type: String, default: "0"},//仅能维护自身数据
        linkDetele: {type: String, default: "0"},//是否关联删除数据
        isEditData: {type: Boolean, default: false},//是否可编辑数据
        isTempEdit: {type: Boolean, default: false},//是否是临时编辑列表
        conditionFormArr: {
            type: Array, default: () => {
                return [];
            }
        },//弹出数据表查询参数
        mainFormData: {
            type: Object, default: () => {
                return {};
            }
        },//主表单数据
        listOutParam: {
            type: Object, default: () => {
                return {};
            }
        },// 外部传入参数

        operateAuthority: {
            type: Object, default: () => {
                return {}
            }
        },//操作权限
        diyPageIsInit: {type: Boolean, default: false},//自定义按钮弹出页面是否需要开启初始化
        beforeAddEvent: {type: Function, default: null},//外部引用传入的添加前执行自定义方法
        beforeUpdateEvent: {type: Function, default: null},//外部引用传入的修改前执行自定义方法
        beforeViewEvent: {type: Function, default: null},//外部引用传入的查看前执行自定义方法
        execteAfterSave: {type: Function, default: null}, // 表单保存成功后回调方法
        searchCallback: {type: Function, default: null}, // 列表查询后回调方法
        diyFunctionEvent: {type: Function, default: null}, // 外部传入自定义事件

        updateFormdataBeforeSave: {
            type: Object, default: () => {
                return {}
            }, required: false
        },//保存数据前修改字段信息
        checkIdArr: {
            type: Array, default: () => {
                return [];
            }
        },//表格选中的数据
        diyButtonShow: {
            type: Object, default: () => {
                return {};
            }
        },//自定义显示按钮 按钮Id + 0隐藏 1显示
        isHideenOptBtn: {type: String, default: "0"},//查看列表是否隐藏操作栏
        isShowDiyButton: {type: String, default: "0"},//编辑列表是否显示自定义按钮
        hidenDeleteBtn: {type: String, default: "0"},//编辑列表是否隐藏删除按钮
        hidenHeadBtn: {type: String, default: "0"},//编辑列表是否隐藏头部按钮
        hidenAddBtn: {type: String, default: "0"},//编辑列表是否仅隐藏添加按钮
        parentOptFormData: {
            type: Object, default: () => {
                return {};
            }
        },//编辑列表父表单对象
        hidenViewBtn: {type: String, default: "0"},//编辑列表是否隐藏查看按钮
        hidenUpdateBtn: {type: String, default: "0"},//编辑列表是否隐藏修改按钮
        hidenAllBtn: {type: String, default: "0"},//编辑列表是否隐藏操作栏
        isPreview: {type: Boolean, default: false}, // 是否预览
        autoOpenHeight: {type: Boolean, default: false}, //（编辑列表和查看列表）是否自动撑开高度
        minHeight: {type: String, default: '200px'},
        pRefs: {type: String, default: ""},//父页面refs
        parentFormData: {
            type: Object, default: () => {
                return {};
            }
        }, // 来源于复合视图中的表单对象
        compositeObj: {
            type: Object, default: () => {
                return {};
            }
        },//来源于复合视图中表单字段变化
        isCompositeView: {type: Boolean, default: false}, // 是否为表单复合视图
        compositeFormOperate: {type: String, default: ''}, //表单复合视图操作状态
        refreshPreview: {type: String, default: ''},
    },
    components: {formatRender, PlDataCurrency},

    computed: {
        formalParams() {
            return [
                'formData',//行数据
                'CTX',
                'vm',
                'axios',
                'Ajax',
                // 'eventListener'
            ];
        },
    },
    data() {
        return {
            formId: "",
            multipleSelection: [],//列表选中数据
            loadSuccess: false,
            loadAfterCompSuccess: true,
            pageLoadSuccess: false,
            loginUser: {},//登录用户信息
            userDept: {},//登录用户信息
            formBaseObj: {},//智能建表基础信息
            formDefineKey: "",//智能建表表defineKey
            sourceKey: "", // 所属数据源key
            searchBoxArr: [],//搜索框
            headButtonObj: {},
            headButtonArr: [],//顶部按钮
            optButtonObj: {},
            optButtonArr: [],//操作栏按钮
            optDiyButtonArr: [],//操作栏自定义按钮
            topDiyButtonArr: [], //头部自定义按钮
            showFieldArr: [],//显示字段
            isShowRedact: [],//显示编辑框
            isShowTableTest: true,//控制table显示
            isSaveUpdate: true,//控制新增条件
            updateIndex: -1,
            isShowSaveBtn: [],//是否显示保存按钮
            checkboxValue: {},//复选框值
            cardClickArr: [],//点击卡片保存的数据  用于卡片删除
            mycardclass: "myelcard3",
            showContentField: {},//字段配置
            isEditSelf: "0",
            showFieldType: {},//字段类型
            timeSpecialSet: {},//时间字段格式  SpecialSet  字段内容配置
            listFields: [],//级联多需要的配置
            switchTable: false,//切换表单
            refreshMoudel: "",//编辑时记录当前行数据
            namberTreeLoad: "0",
            dataTreeLoad: [],
            tmpObj: {},
            //isFlow:{type:Boolean,default:false},//
            metadata: [],//获取元数据
            fieldIdArr: [],//显示列的ID
            valueArr: [],//显示列的值
            fieldColumn: {},//字段对column数据
            columnFormatObj: {},//列格式化
            reqBeforeComps: [],// 请求前加载组件
            reqAfterComps: [],// 请求后加载组件
            loadBeforeComp: false, // 开始加载请求前组件
            loadAfterComp: false, // 开始加载请求后组件
            viewDefinData: {},//配置数据
            multiTableViewId: "", // 多表查看id
            tableViewData: {},//表单数据
            oldTableViewData: {}, //原表单数据
            tableViewMultiData: {},// 多表查看表单数据
            tableViewButtonArr: [],//表单视图按钮
            tviewBtnConditionObj: {}, //表单视图按钮隐藏条件配置
            formBtnVisbleObj: {}, //表单视图按钮隐藏情况
            buttonReminderObj: {},//按钮提示语
            searchForm: {},
            dataOptions: {},
            allowDeleteParam: "",
            dataPickerType: {
                'yyyy': 'year',
                'yyyy-MM': 'month',
                'yyyy-MM-dd': 'date',
                'yyyy-MM-dd HH:mm:ss': 'datetime'
            },
            dataPickerRangeType: {
                'yyyy': 'monthrange',
                'yyyy-MM': 'monthrange',
                'yyyy-MM-dd': 'daterange',
                'yyyy-MM-dd HH:mm:ss': 'datetimerange'
            },
            buttonType: {
                "add": "primary",
                "delete": "danger",
                "import": "primary",
                "export": "warning",
                "update": "primary",
                "view": "primary",
                "dotLocation": "primary",
                "regionalContour": "primary",
                // "location": "primary",
                // "dot": "primary"
            },
            defaultButtonTypeArr: ["primary", "success", "success", "info", "warning", "danger"],
            dataRows: [],
            currentPage: 1,
            pageSize: 10,
            pageSizes: [10, 30, 50, 100],
            total: 0,
            searchParams: "",
            showFieldObj: {},
            fieldNameMap: {},
            formFieldObj: {},//字段信息
            contentArr: [],//表单视图控件信息数组
            contentAllObj: {},//表单视图控件信息对象
            renderArr: [],//表单视图form表单实例化信息
            optDataDialog: false,//新增、修改、查看弹出框
            formOperate: "add",//表单是否可编辑
            dialogTitle: "",//弹出框标题
            dialogWidth: "90%",//弹出框宽度
            dialogHeight: "90%",//弹出框高度
            dialogTop: "5vh",//弹出框顶部间距
            currentButtonType: "",
            contentForm: {},
            dataId: "",
            SYSTIME: {
                "time": "",//年-月-日 时：分：秒
                "yearMoNday": "",//年-月-日
                "hourMinSec": "",//时:分:秒
                "yearMon": "",//年-月
                "onlyYear": "",//年
                "onlyMon": "",//月
                "onlyDay": "",//日
                "hourMin": "",//时:分
                "onlyHour": "",//时
                "onlyMin": "",//分
                "onlySec": ""//秒
            },
            tableviewsData: {'dialog-title-style': ''},//预览时新增标题样式
            logicOpenDialogVisible: false, //自定义按钮动作(弹出框)
            openDialogData: {}, //自定义按钮弹出对话框数据
            componentIndex: '', //自定义页面路径
            formListFiledObj: {}, //列表字段
            actResultFlag: 'is false', //动作执行返回值
            loginDept: {}, //当前用户组织信息
            currentPageDataObj: {}, //当前行数据
            relationMap:{},
            optColumnLength: 0,
            columnTotalLength: 0,
            //弹出数据表按钮
            ejectTableButton: [
                {buttonType: "view", icon: "el-icon-view", type: "primary", buttonName: "查看"},
                {buttonType: "choose", icon: "el-icon-thumb", type: "warning", buttonName: "选择"}
            ],
            //弹出数据表按钮-不显示行选择按钮
            ejectTableButton2: [
                {buttonType: "view", icon: "el-icon-view", type: "primary", buttonName: "查看"},
            ],
            //编辑列表按钮
            editTableButton: {
                head: [
                    {buttonType: "add", icon: "el-icon-circle-plus", type: "primary", buttonName: "新增"},
                    {buttonType: "delete", icon: "el-icon-delete", type: "danger", buttonName: "删除"}
                ],
                opt: [
                    {buttonType: "update", icon: "el-icon-edit", type: "primary", buttonName: "修改"},
                    {buttonType: "view", icon: "el-icon-view", type: "primary", buttonName: "查看"}
                ]
            },
            //查看列表按钮
            viewTableButton: [
                {buttonType: "view", icon: "el-icon-view", type: "primary", buttonName: "查看"}
            ],

            //数据是否更新
            isUpdateData: false,
            fileList: [],
            importDataVisible: false,
            impXlsDialog: false, //导入dialog
            impUrl: this.api.plCommonmethod.importData,
            impXlsData: {}, //导入数据
            impModelId: "",//模板配置id
            acceptImportFileType: ".xls,.xlsx",//数据导入允许传入文件类型
            impotFileCount: 0,

            onlyDataHasExist: false,
            editTableIdArr: [],//列表视图中编辑列表的id
            formatterEventDialog: false,
            formatEvetDilogObj: {
                url: '', //外部地址
                title: '', //标题
                height: '', //高度
                width: '', //宽度
                top: '5vh', //顶部
                componentIndex: '', //地址
                param: {},//传递参数
                type: '', //地址类型，外部地址和内部页面
            },
            dataTreeArr: [], //数据字典arr
            defaultProps: {children: 'children', label: 'dataName', id: 'value'}, // 树组件的配置信息
            sysDataObj: {},
            diyExpFieldArr: [],
            expDialogObj: {
                showDialog: false,
                title: '导出设置',
                activeColName: "showCol",
                activeRowName: "showRow",
                checkedAll: false,
                isLegend: false,
                defineColArr: [],
                legendColArr: [],
            },
            expTitle: "",
            expLoading: false,
            headerRowStyle: {},
            rowStyle: {},
            setInitFunc: new Set([
                "getSearchBox",
                "getTableTopButton",
                "getTableSelfButton",
                "getTableViewData",
                "getTableViewMultiData",
                "getViewsButton"
            ]),
            dataLenth: "",//数据条数
            listModel: {}, // 所有此列表视图相关数据
            isShowAllSearchBox: false,
            shrinkSearchBox: '1',
            treeDefineObj: {}, //实际渲染树视图
            treeData: [], //格式化后的树数据
            treeProps: {
                children: 'children',
                label: 'label'
            },
            treeDefaultExpandedKeys: [], //树默认展开的节点的id数组
            filterTreeText: "", //搜索
            treeClickNode: {}, //当前树点击对象(树点击条件查询)
            defaultFieldArr: ['ID', 'RELATION_ID', 'CREATED', 'CREATETIME', 'CREATE_TIME', 'UPDATED', 'UPDATETIME', 'UPDATE_TIME'],
            editParamObj: {},//编辑列表默认参数
            columnFormatDialogObj: { // 列格式化调用自定义弹出表单查看
                visible: false,
                listOutParam: {},
                equilibriumData: {}
            },
            allFiledObj: {},//表单所有字段对象
            treeUnfold: true,//当前树是否展开
            treeWidth: '250px',
            specialTypeWidth: this.isViewTable == '1' ? '100' : '200', //弹出数据表、编辑列表、查看列表按钮 宽度
            cacheFormatVal: {}, // 列格式化缓存数据

            scriptDataArr: [], //脚本定义arr(行可编辑)
            scriptData: {
                add: {beforeOpen: null, afterOpen: null},
                update: {beforeOpen: null, afterOpen: null},
                view: {beforeOpen: null, afterOpen: null},
                save: {beforeSubmit: null, afterSubmit: null},
                close: {beforeClose: null, afterClose: null},
                all: {
                    beforeOpen: null,
                    afterOpen: null,
                    beforeSubmit: null,
                    afterSubmit: null,
                    beforeClose: null,
                    afterClose: null
                }
            },
            multiFormId: '',//关联的多表formId
            columnFormatDialogRef: "columnFormat" + this.COMMON_FUNC.getUuidByParams(32),
            clickRowData: {}, //点击的行数据
            clickRowIndex: 0, //点击的行序号
            isCopyOperate: false,//是否为复制
            noCopyArr: [],
            allCheckedArr: [],//所有行选中的数据
            allCheckedDataArr: [], // 选中行的完整数据
            showColumnFieldArr: [],//列表自定义显示列字段数据
            showOpenTotalColumnFieldArr: [],//列表自定义显示列字段数据
            checkAll: false,
            openTotalCheckAll: false,
            diyColunmVisible: false,
            openTotalVisible: false,
            SingleLineSearchWidth: 0,//收缩时单行搜索栏宽度
            isPullDown: false,//是否有下拉按钮
            isCountAll: false,//是否显示合计
            countAllCol: [],
            hasSortOrder: '',
            isUpZindex: false,
            loadSysDataSuccess: true,
            operateFixPos: null,
            indexFixPos: null,
            showSearchBtn: true,
            listSearchConditionObj: {}, //列表配置搜索框已有的条件定义
            openTotalTagParams: [],
            ejectSelectChooseRowIds: new Set(), // 弹出数据表多选时选择的全部分页ids
            buttonRecord: [],
            clickTime: null, // 点击时间防止短时间发起多次重复点击
            headBtnIsHasDelete: true, //列表头部按钮是否含有删除按钮
            dataSourceArr: [], //数据源
            tempObj: {},
            loadingSwitch: {}, // 遮罩层对象
            tempEditObj: {},
            // plMapModuleMap: {},
            dotLocationDialog: false,//点位弹出框
            dotLocationInfo: {}, // 打点定位信息
            regionalContourDialog: false, // 区域轮廓弹出状态
            regionalContourInfo: "", // 获取区域轮廓信息
            currentRowDataAndSpecialSet: {
                rowData: {}, // 当前点击打点定位的行数据
                specialSet: {} // 打点定位配置
            }, // 当前点击打点定位的行数据和配置
            dotLocationDialogObj: {
                title: '', //标题
                dotLocationInfo: {},
                type: "spot",
            },
            regionalContourDialogObj: {
                title: '', //标题
                ptArea: "",
                type: "regionalContour",
                color: "",
                fillColor: "",
                operate: "add",
            },
        }
    },
    created() {
    },
    watch: {

        filterTreeText(val) {
            this.$refs.tree.filter(val);
        },

        /**
         * 监听弹出数据表、查看列表、编辑列表传参变换
         */
        mainFormData: {
            deep: true,
            handler: function () {
                if ((this.isViewTable == "1") && this.conditionFormArr && this.conditionFormArr.length > 0 && this.pageLoadSuccess) {
                    //重新加载数据
                    this.getDataRows();
                    //重新计算
                }
            }
        },

        /**
         * 关闭列格式化弹窗
         */
        "columnFormatDialogObj.visible"() {
            if (!this.columnFormatDialogObj.visible) {
                this.$set(this.columnFormatDialogObj, 'type', '');
            } else {
                //自动生成唯一表示 ref
                this.columnFormatDialogRef = "columnFormat" + this.COMMON_FUNC.getUuidByParams(32);
            }
        },

        // showColumnFieldArr: {
        //     handler() {
        //         if (this.showColumnFieldArr.every(item => item.checked)) {
        //             this.checkAll = true;
        //         } else {
        //             this.checkAll = false;
        //         }
        //     },
        //     deep: true
        // },
        showOpenTotalColumnFieldArr: {
            handler() {
                if (this.showOpenTotalColumnFieldArr.every(item => item.openTotalChecked)) {
                    this.openTotalCheckAll = true;
                } else {
                    this.openTotalCheckAll = false;
                }
            },
            deep: true
        },
    },
    methods: {
        getNumber(num,length) {
            let changenum = (parseInt(num * Math.pow( 10, length ) + 0.5) / Math.pow( 10, length )).toString()
            let index = changenum.indexOf(".")
            if(index < 0 && length > 0){
                changenum = changenum+"."
                for(let i = 0; i < length; i++){
                    changenum = changenum + "0"
                }
            } else {
                index = changenum.length - index;
                for(let i = 0; i < (length - index) + 1; i++){
                    changenum = changenum + "0"
                }
            }
            return Number(changenum).toFixed(length);
        },
        /**
         * 加法运算，预防精度丢失
         * @param num1 数字1
         * @param num2 数字2
         */
        numAdd(num1, num2) {
            let baseNum, baseNum1, baseNum2;
            try {
                baseNum1 = num1.toString().split('.')[1].length;
            } catch (e) {
                baseNum1 = 0;
            }
            try {
                baseNum2 = num2.toString().split('.')[1].length;
            } catch (e) {
                baseNum2 = 0;
            }
            baseNum = Math.pow(10, Math.max(baseNum1, baseNum2));
            return (num1 * baseNum + num2 * baseNum) / baseNum;
        },
        getSummaries(param) {
            const {columns, data} = param;
            const sums = [];
            this.$nextTick(() => {
                let viewsTable = document.getElementById('changeTableTotal');
                let footer_table = viewsTable.getElementsByClassName('el-table__footer-wrapper')[0];
                let footer_fixed_table = viewsTable.getElementsByClassName('el-table__fixed-footer-wrapper')[0];
                let footer_right_table = viewsTable.getElementsByClassName('el-table__fixed-right')[0];
                let footer_fixed_right_table,child_fixed_tr_right;
                try {
                    footer_fixed_right_table = footer_right_table.getElementsByClassName('el-table__fixed-footer-wrapper')[0];
                    child_fixed_tr_right = footer_fixed_right_table.getElementsByTagName('tr')[0];
                }catch (e) {
                    console.log(e.message);
                }
                let child_tr = footer_table.getElementsByTagName('tr')[0];
                let child_fixed_tr = footer_fixed_table.getElementsByTagName('tr')[0];
                let countAllColCss = '';
                if (this.viewDefinData['bgColor']) {
                    countAllColCss += ('background-color:' + this.viewDefinData['bgColor'] + ';');
                }
                if (this.viewDefinData['fontColor']) {
                    countAllColCss += ('color:' + this.viewDefinData['fontColor'] + ';');
                }
                if (this.viewDefinData['fontSize']) {
                    countAllColCss += ('font-size:' + this.viewDefinData['fontSize'] + 'px;');
                }
                if (this.viewDefinData['isFontWeight']) {
                    countAllColCss += ('font-weight:' + this.viewDefinData['isFontWeight'] + ';');
                }
                child_tr.childNodes.forEach(item => {
                    item.setAttribute('style', countAllColCss);
                })
                child_fixed_tr.childNodes.forEach(item => {
                    item.setAttribute('style', countAllColCss);
                })
                child_fixed_tr_right && child_fixed_tr_right.childNodes.forEach(item => {
                    item.setAttribute('style', countAllColCss);
                })
            })
            columns.forEach((column, index) => {
                if (column.label === '序号') {
                    sums[index] = '合计';
                } else {
                    let countAllData = this.countAllCol.find(countAll => column.label === countAll.showName);
                    if (countAllData !== undefined) {
                        const values = data.map(item => Number(item[countAllData.fieldName + "_" + countAllData.formDefineKey]));
                        if (!values.every(value => isNaN(value))) {
                            sums[index] = values.reduce((prev, curr) => {
                                const value = Number(curr);
                                if (!isNaN(value)) {
                                    return this.numAdd(Number(prev),Number(value));
                                    // return (Number(prev) + Number(value));
                                } else {
                                    return prev;
                                }
                            }, 0);
                            sums[index] = this.getNumber(Number(sums[index]),2);
                            sums[index] = Number(sums[index]).toFixed(2) + '';
                        } else {
                            sums[index] = '';
                        }
                    } else {
                        sums[index] = '';
                    }

                }
            });
            return sums;
        },
        //自定义列设置 全选/取消全选
        handleCheckAllChange(evt) {
            this.checkAll = !this.checkAll;
            if (this.checkAll) {
                this.showColumnFieldArr.forEach((item, index) => {
                    if(item.diyColumns=='1'){
                        this.$set(item, "checked", true);
                    }
                })
                let target = evt.target
                // console.log('target',target,evt);
                if (target.nodeName === 'SPAN') {
                    target = evt.target.parentNode
                }
                target.blur();
            } else {
                this.showColumnFieldArr.forEach((item, index) => {
                    if(item.diyColumns=='1'){
                        this.$set(item, "checked", false);
                    }
                })
            }
        },
        //统计分析设置 全选/取消全选
        handleOpenTotalCheckAllChange(evt) {
            this.openTotalCheckAll = !this.openTotalCheckAll;
            if (this.openTotalCheckAll) {
                this.showOpenTotalColumnFieldArr.forEach((item, index) => {
                    this.$set(item, "openTotalChecked", true);
                })
                let target = evt.target
                // console.log('target',target,evt);
                if (target.nodeName === 'SPAN') {
                    target = evt.target.parentNode
                }
                target.blur();
            } else {
                this.showOpenTotalColumnFieldArr.forEach((item, index) => {
                    this.$set(item, "openTotalChecked", false);
                })
            }
        },
        /**
         * 处理数据
         */
        async initData() {
            this.getLoginData(); //获取系统登陆用户信息
            this.loadSuccess = false;
            await this.getConfigInfo();
            this.initSearchForm();
            await this.getDataRows();
            this.$nextTick(() => {
                this.loadSuccess = true;
            })
        },
        initSuccess(key) {
            this.setInitFunc.delete(key);
            if (this.setInitFunc.size == 0) {
                if (this.isEjectTable != '1') {
                    this.loadSuccess = true;
                }
                this.pageLoadSuccess = true;
                this.cacheFormatVal = {};
            }
        },
        initData2() {
            this.getLoginData(); //获取系统登陆用户信息
            this.initAllUserChecked();
            this.loadSuccess = false;
            if (this.conditionId) {
                this.getConditionInfo();
            }
            this.getAllListModel().then(res => {
                if (this.listModel.listViews.isShowAllSearchBox == "1") {
                    this.isShowAllSearchBox = true;
                    this.getIsShrink().then(res => {
                        if (res && res.data.length > 0) {
                            let hasShrink = res.data.some(item => {
                                return JSON.parse(item.preJson).id == this.listModel.listViews.id;
                            })
                            if (!hasShrink) {
                                this.initIsShrink()
                            } else {
                                res.data.forEach(key => {
                                    if (JSON.parse(key.preJson).id == this.listModel.listViews.id) {
                                        this.shrinkSearchBox = JSON.parse(key.preJson).isShrink;
                                    }
                                })
                            }
                        } else {
                            this.initIsShrink()
                        }
                    })
                } else {
                    this.isShowAllSearchBox = false;
                }
                this.getFormBase();
                this.setInitFunc = new Set([
                    "getSearchBox",
                    "getTableTopButton",
                    "getTableSelfButton",
                    "getTableViewData",
                    "getTableViewMultiData",
                    "getViewsButton",
                    "getFormField",
                    "loadBeforeComp",
                ]);
                this.getSearchBox().then(() => {//初始化时获取单行宽度
                    this.showSearchBtn = false;
                    // setTimeout(() => {
                    // }, 50)
                });
                this.getTableTopButton();
                this.getListField().then(() => {
                    this.showColumnFieldArr.forEach((item, index) => {
                        if(item.diyColumns=='2'){
                            this.$set(item, "checked", true);
                        }else{
                            this.$set(item, "checked", false);
                        }
                    })
                    this.saveDiyCloumn();
                    this.getFormField().then(() => {
                        this.getFormFields();
                        this.getViewDefine().then(() => {
                            this.getTableViewData().then(() => {
                                setTimeout(() => {
                                    this.initSuccess("getTableViewData");
                                }, 5);
                                //树视图判断
                                this.initAllDataArr().then(() => {
                                    this.getTreeDefine();
                                }); //加载数据字典
                                this.getControlConfigDatas().then(() => {
                                    this.getDataRows().then(() => {
                                        this.getTableSelfButton().then(() => {
                                            setTimeout(() => {
                                                if (this.isShowAllSearchBox) {
                                                    this.getSearchBoxWidth();
                                                }
                                            })
                                        })
                                        this.getEditTable();
                                    });
                                })
                            });
                            this.getTableViewMultiData();
                            this.getViewsButton();

                            //如果是行可编辑加载脚本定义
                            if (this.viewDefinData.isLineRedact == '1') {
                                this.loadScriptData();
                            }
                            this.getDataSourceArr();
                        });
                    });
                });
            })
        },

        getIsShrink() { //查询后是否收缩
            let queryParam = {"userId": this.loginUser.id, "preKey": "IS_SHRINK_SEARCH_BOX"};
            return new Promise(resolve => {
                this.spcpFormAxios.post(this.api.plFormUserPreferences.find, queryParam).then(res => {
                    resolve(res);
                })
            })
        },
        initIsShrink() {
            this.shrinkSearchBox = '1';
            let formObj = {};
            formObj['isShrink'] = '1';
            formObj['id'] = this.listModel.listViews.id;
            let addParamUser = {
                "userId": this.loginUser.id,
                "preKey": "IS_SHRINK_SEARCH_BOX",
                "preJson": JSON.stringify(formObj)
            };
            this.spcpFormAxios.post(this.api.plFormUserPreferences.add, addParamUser).then(res => {
                if (res && res.data && !res.data.operateSuccess) {
                    // if (!res.data.operateSuccess) {
                    this.$message.error("查询收缩设置失败！");
                    // }
                }
            });
        },

        /**
         * 根据表单id获取所有配置数据
         */
        getAllListModel() {
            return new Promise(resolve => {
                this.FORM_GLOBAL.getAllListModel(this.listViewId, this.loginUser.userType).then(datas => {
                    this.listModel = datas;
                    resolve();
                })
            })
        },

        loadReqBeforeComps() {
            if (this.reqBeforeComps.length == 0) {
                this.initSuccess('loadBeforeComp');
            } else {
                this.loadBeforeComp = true;
                this.$nextTick(() => {
                    let set = new Set();
                    this.reqBeforeComps.forEach(item => {
                        set.add(item.name);
                    })
                    this.reqBeforeComps.forEach(item => {
                        let component = this.$refs[item.name + "_beforeRef"][0];
                        if (!component.loadSuccess) {
                            console.error("组件“" + item.name + "”必须设置loadSuccess方法，" +
                                "若是同步return true,若是异步则使用promise返回!");
                        } else {
                            let value = component.loadSuccess();
                            if (typeof (value) == "object" && typeof (value.then) == "function") {
                                value.then(() => {
                                    this.loadCompFinish("loadBeforeComp", set, item.name);
                                })
                            } else {
                                this.loadCompFinish("loadBeforeComp", set, item.name);
                            }
                        }
                    })
                })
            }
        },

        loadCompFinish(type, set, key) {
            set.delete(key);
            if (set.size == 0) {
                if (type == "loadAfterComp") {
                    this.loadAfterCompSuccess = true;
                }
                this.initSuccess(type);
            }
        },

        loadReqAfterComps() {
            if (this.reqAfterComps.length == 0) {
                this.initSuccess('loadAfterComp');
                this.loadAfterCompSuccess = true;
            } else {
                this.loadAfterComp = true;
                this.loadAfterCompSuccess = false;
                this.$nextTick(() => {
                    let set = new Set();
                    this.reqAfterComps.forEach(item => {
                        set.add(item.name);
                    })
                    this.loadAfterCompSuccess = false;
                    this.reqAfterComps.forEach(item => {
                        let component = null;
                        if(this.$refs[item.name + "_afterRef"]){
                            component = this.$refs[item.name + "_afterRef"][0];
                        }
                        if (!component) {
                            console.log("远程请求组件未加载！");
                            return;
                        }
                        if (!component.loadSuccess) {
                            console.error("组件“" + item.name + "”必须设置loadSuccess方法，" +
                                "若是同步return true,若是异步则使用promise返回!");
                        } else {
                            let value = component.loadSuccess();
                            if (typeof (value) == "object" && typeof (value.then) == "function") {
                                value.then(() => {
                                    this.loadCompFinish("loadAfterComp", set, item.name);
                                })
                            } else {
                                this.loadCompFinish("loadAfterComp", set, item.name);
                            }
                        }
                    })
                })
            }
        },

        /**
         * 页面初始化加载
         */
        initAllDataArr() {
            return new Promise(resolve => {
                this.loadSysDataSuccess = false;
                if(window.spcpDataObj && window.spcpDataObj[this.sourceKey]){
                    this.sysDataObj = window.spcpDataObj[this.sourceKey];
                    this.loadSysDataSuccess = true;
                    this.cacheFormatVal = {};
                    resolve();
                }else{
                    if(!window.spcpDataObj){
                        window.spcpDataObj = {};
                    }
                    CacheGlobal.getDataToLocalForage(this.sourceKey).then(datas => {
                        let sysDataObj = {};
                        datas.forEach(item => {
                            let data = {
                                id: item.id,
                                dataName: item.dataName,
                            }
                            sysDataObj[item.id] = data;
                        })
                        this.sysDataObj = sysDataObj;
                        window.spcpDataObj[this.sourceKey] = sysDataObj;
                        this.loadSysDataSuccess = true;
                        this.cacheFormatVal = {};
                        resolve();
                    })
                }
            })
        },


        // initAllDataArr() {
        //     // setTimeout(() => {
        //     this.dataTreeArr = [];
        //     // let res = await  this.spcpFormAxios.post(this.api.mixDataTool.findAllTypeAndData);
        //     if (window.sysDataObj) {
        //         Object.assign(this.sysDataObj, window.sysDataObj);
        //     } else {
        //         Object.assign(this.sysDataObj, this.CACHE_GLOBAL.getSysDataObj(this.sourceKey));
        //     }
        //     if (this.sysDataObj == null || Object.keys(this.sysDataObj).length === 0) {
        //         this.loadSysDataSuccess = false;
        //         this.spcpFormAxios.post(this.api.mixDataTool.findAllTypeAndData, {'sourceKey': this.sourceKey}).then(res => {
        //             let sysDataObj = {};
        //             (res.data || []).forEach(item => {
        //                 sysDataObj[item.id] = item;
        //             });
        //             this.CACHE_GLOBAL.setSysDataObj(sysDataObj);
        //             this.sysDataObj = sysDataObj;
        //             console.log(this.sysDataObj)
        //             this.loadSysDataSuccess = true;
        //             this.cacheFormatVal = {};
        //         })
        //     }
        //     // },0);
        // },
        explegendCheck(val) {
            //解决循环中部分checkbox点击无法选中情况
            this.$forceUpdate();
        },

        /**
         * 初始化搜索框form表单
         */
        initSearchForm() {
            let searchConditionObj = {};
            this.searchBoxArr.forEach(searchBox => {
                //搜索框是级联下拉框时，是由多个fieldId拼接的
                // if ((searchBox.fieldId).includes(',')){
                //     let searchConditionArr = [];
                //     (searchBox.fieldId.split(',')).forEach(fieldId => {
                //         searchConditionArr.push(this.listSearchConditionObj[fieldId] || "");
                //     })
                // }else {
                //     searchConditionObj = this.listSearchConditionObj[searchBox.fieldId];
                // }
                searchConditionObj = this.listSearchConditionObj[searchBox.fieldId];
                // console.log('初始化',searchBox,searchConditionObj,this.listSearchConditionObj);
                //搜索框id
                let id = searchBox.id;
                this.$set(this.searchForm, id, "");
                //默认值
                let defaultVal = searchBox.defaultVal;
                if (defaultVal) {
                    //赋默认值
                    this.searchForm[id] = defaultVal;
                }
                //下拉框
                if (searchBox.controlType == "select") {
                    //若搜索框类型是下拉框且允许多选，处理默认和格式
                    if (searchBox.multiple == '1') {
                        if (defaultVal) {
                            this.searchForm[id] = defaultVal.split(",");
                        } else {
                            this.searchForm[id] = [];
                        }
                    }
                    //解析扩展信息
                    this.$set(searchBox, "extendObj", JSON.parse(searchBox.extend));
                    //数据字典
                    if (searchBox.dataOrigin == "sysdata") {
                        //获取下拉框的值
                        this.DATA_GLOBAL.getDatas(searchBox.dataDic).then(res => {
                            this.$set(searchBox, "selectSysData", res);
                        });
                        //远程数据来源
                    } else if (searchBox.dataOrigin == "remote") {
                        //获取数据
                        let CTX = window.FORM_RENDER_URL + "/";
                        // if (searchBox.extendObj.reqUrl.indexOf("http:") == -1) {
                        //     searchBox.extendObj.reqUrl = CTX + searchBox.extendObj.reqUrl;
                        // }
                        let paramObj = {};
                        if (searchBox.extendObj.reqUrl.indexOf("?") > -1) { //截取后面get请求的参数
                            let paramStr = searchBox.extendObj.reqUrl.split("?")[1] || '';
                            if (paramStr) {
                                let getParamArr = paramStr.split("&") || [];
                                getParamArr.forEach(param => {
                                    if (param.indexOf("=") > -1) {
                                        paramObj[param.split("=")[0]] = param.split("=")[1];
                                    }
                                    if(param.indexOf("=") > -1 && param.indexOf(":listOutParam.") > -1){
                                        paramObj[param.split("=")[0]] = (param.split("=")[1].split(":listOutParam.")[0] + "= '" + (this.listOutParam[param.split("=")[1].split(":listOutParam.")[1] || ''] || '') + "'");
                                    }
                                })
                            }
                            searchBox.extendObj.reqUrl = searchBox.extendObj.reqUrl.split("?")[0] || '';
                        }
                        //解析参数
                        let optionSettingArr = searchBox.extendObj.optionSetting || [];
                        optionSettingArr.forEach(param => {
                            if (param.paramKey) {
                                if (param.paramType == 'diy' || param.paramType == 'sysData') {
                                    paramObj[param.paramKey] = param.paramVal || '';
                                    let outPramKeyStart = "${listOutParam.";
                                    if (paramObj[param.paramKey].indexOf(outPramKeyStart) > -1) { //存在外部参数
                                        let replaceStr = "";
                                        let outPramKeyEnd = "}";
                                        let startIndex = paramObj[param.paramKey].indexOf(outPramKeyStart); //获取下表
                                        let endIndex = paramObj[param.paramKey].indexOf(outPramKeyEnd);
                                        //获取外部参数值
                                        let outParam = paramObj[param.paramKey].substring(startIndex + outPramKeyStart.length, endIndex) || ''; // 去除}
                                        replaceStr = outPramKeyStart + outParam + outPramKeyEnd;
                                        //获取外部参数值
                                        let outParamVal = this.listOutParam[outParam] || '';
                                        paramObj[param.paramKey] = paramObj[param.paramKey].replace(replaceStr, outParamVal); // 去除${listOutParam.
                                    }
                                } else if (param.paramType == 'default') { //缺省值
                                    let value = param.paramVal || '';
                                    if (value.indexOf("LOGINUSERDEPT") > -1) {
                                        value = Replace.def(this.userDept, value) || "";
                                    } else if (value.indexOf("LOGINUSER") > -1) {
                                        value = Replace.def(this.loginUser, value) || "";
                                    }
                                    paramObj[param.paramKey] = value;
                                } else if (param.paramType == 'external') {//外部参数
                                    let value = this.listOutParam[param.paramVal || ''] || '';
                                    paramObj[param.paramKey] = value;
                                }
                            }
                        });
                        let value = searchBox.extendObj.reqUrl;
                        // let serviceName = (window.SERVICE_NAME || {});
                        // let adminServeName = serviceName.admin || "/admin/";
                        // let formServeName = serviceName.form || "/form/";
                        // let flowServeName = serviceName.flow || "/flow/";
                        // let oaServeName = serviceName.oa || "/oaproject/";
                        // value = this.platStringUtil.replaceAll(value, "/admin/", adminServeName);
                        // value = this.platStringUtil.replaceAll(value, "/form/", formServeName);
                        // value = this.platStringUtil.replaceAll(value, "/flow/", flowServeName);
                        // value = this.platStringUtil.replaceAll(value, "/oaproject/", oaServeName);
                        // value = this.platStringUtil.replaceAll(value, "/oaadmin/", adminServeName);
                        // value = this.platStringUtil.replaceAll(value, "/oaform/", formServeName);
                        // value = this.platStringUtil.replaceAll(value, "/oaflow/", flowServeName);

                        value = this.replaceUrl(value);

                        searchBox.extendObj.reqUrl = value;

                        this.spcpFormAxios.post(searchBox.extendObj.reqUrl, paramObj).then(res => {
                            if (res && res.data) {
                                if (res.data.operateObj) {
                                    this.$set(this.dataOptions, id, res.data.operateObj || []);
                                } else {
                                    this.$set(this.dataOptions, id, res.data || []);
                                }

                            }
                        });

                        //若有下级数据，整理格式
                        if (searchBox.extendObj.juniorData == '1') {
                            let props = {
                                value: searchBox.extendObj.valueField,
                                label: searchBox.extendObj.textField,
                                children: 'children',
                                checkStrictly: true,
                                multiple: searchBox.multiple == '1'
                            };
                            this.$set(searchBox, "props", props);
                        }
                    }
                    //时间类型的搜索框
                } else if (searchBox.controlType == "time") {
                    //获取时间控件类型
                    this.getDataPickerType(searchBox);
                    //赋初始值，是时间区间时，处理默认值
                    if (searchBox.dateRange == "1") {
                        //扩展信息
                        let extendObj = JSON.parse(searchBox.extend || {});
                        let valArr = [];
                        //开始日期的默认值
                        if (extendObj.defaultValTypeStart == 'sysTime') {
                            valArr.push(this.DATE_UTIL.formaterDateOrTime(new Date(), searchBox.datePattern))
                        } else {
                            valArr.push(extendObj.defaultValStart);
                        }
                        //结束日期的默认值
                        if (extendObj.defaultValTypeEnd == 'sysTime') {
                            valArr.push(this.DATE_UTIL.formaterDateOrTime(new Date(), searchBox.datePattern))
                        } else {
                            valArr.push(extendObj.defaultValEnd);
                        }
                        this.$set(this.searchForm, id, valArr);
                    } else {
                        if (searchBox.defaultValType == 'sysTime') {
                            this.searchForm[id] = this.DATE_UTIL.formaterDateOrTime(new Date(), searchBox.datePattern);
                        }
                    }
                } else if (searchBox.controlType == "cascadeSelect") {
                    this.$set(this.searchForm, id, {});
                    this.$set(searchBox, "isTreeClick", false);
                    //扩展信息
                    let extendObj = JSON.parse(searchBox.extend || {});
                    searchBox.parentId = extendObj.parentId;
                    if (extendObj.cascadeSetArr && extendObj.cascadeSetArr.length > 0) {
                        let disabled = "";
                        let isHidden = "";
                        extendObj.cascadeSetArr.forEach(item => {
                            if (item.defaultValue) {
                                this.$set(this.searchForm[id], item.fieldId, item.defaultValue);
                                disabled += "," + (item.readOnly === "1");
                                isHidden += "," + (item.isHidden === "1");
                            } else {
                                if (this.listSearchConditionObj[item.fieldId]) {
                                    this.$set(this.searchForm[id], item.fieldId, this.listSearchConditionObj[item.fieldId].value);
                                    disabled += "," + "true";
                                } else {
                                    this.$set(this.searchForm[id], item.fieldId, "");
                                    disabled += "," + "false";
                                }
                                isHidden += "," + "false";
                            }
                        });
                        this.$set(searchBox, 'disabled', disabled.substring(1));
                        this.$set(searchBox, 'isHidden', isHidden.substring(1));
                    }
                    if (Object.keys(this.treeClickNode).length > 0) {
                        // console.log('进左侧树');
                        //给this.searchForm[searchBox.id]对象中key赋值（前提this.treeClickNode对象中有值）
                        //根据this.treeClickNode中的parentId判断当前点击的是第几级 parentId == -1 为最顶级不处理 parentId == all 为第一级 parentId == 为id时（有一个id为第二级以此类推）
                        let disabled = "";
                        if (this.treeClickNode.id == "all") {
                            for (let i = 0; i < searchBox.fieldId.split(",").length; i++) {
                                disabled += "," + false;
                            }
                            this.$set(searchBox, "disabled", disabled.slice(1));
                            this.$set(searchBox, "isTreeClick", false);
                            this.$set(searchBox, "parentId", '-1');
                        } else {
                            //点击一二三级处理逻辑
                            for (let i = 0; i < this.treeClickNode.id.split("_").length; i++) {
                                let key = this.treeClickNode.id.split("_")[i];
                                disabled += "," + true;
                                this.$set(this.searchForm[id], searchBox.fieldId.split(",")[i], key);

                                if (this.listSearchConditionObj[searchBox.fieldId.split(",")[i]]){
                                    this.$set(this.searchForm[id], searchBox.fieldId.split(",")[i], this.listSearchConditionObj[searchBox.fieldId.split(",")[i]].value);
                                    // this.$set(this.searchForm[id], searchBox.fieldId.split(",")[i], searchConditionObj.value);
                                }
                            }
                            this.$set(searchBox, "disabled", disabled.slice(1));
                            this.$set(searchBox, "isTreeClick", true);
                            this.$set(searchBox, "parentId", this.treeClickNode.parentId.split('_')[this.treeClickNode.parentId.split('_').length - 1]);
                        }
                        // console.log('this.treeClickNode',this.treeClickNode);
                        // console.log('this.searchForm',this.searchForm);
                    }
                } else if (searchBox.controlType == "inputInterval") {
                    this.$set(this.searchForm, id, {start: "", end: ""});
                } else if (searchBox.controlType == "groupCondition") {
                    if (typeof searchBox.extend == 'string') {
                        searchBox.extend = JSON.parse(searchBox.extend || []);
                    }
                    if (searchBox.multiple == "1") {
                        if (searchBox.defaultVal) {
                            this.$set(this.searchForm, searchBox.id, searchBox.defaultVal.split(","));
                        } else {
                            this.$set(this.searchForm, searchBox.id, []);
                        }
                    }
                } else if (searchBox.controlType === "cascadeSelectOne") {
                    this.$set(this.searchForm, id, "");
                    //扩展信息
                    let extendObj = JSON.parse(searchBox.extend || "{}");
                    this.$set(searchBox, 'optionSetting', extendObj.optionSetting);
                }
                // if (searchConditionObj && searchBox.controlType !== "cascadeSelect") {
                //     // console.log('searchBox.controlType',searchBox.controlType);
                //     this.$set(this.searchForm, id, searchConditionObj.value);
                //     if (searchConditionObj.value === "LOGINUSER.userId") {
                //         this.$set(this.searchForm, id, this.loginUser.id);
                //     }
                //     if (searchConditionObj.value === "LOGINUSER.userName") {
                //         this.$set(this.searchForm, id, this.loginUser.userName);
                //     }
                //     this.$set(searchBox, "disabled", true);
                // }
            });
        },

        replaceUrl(value) {
            if (value.indexOf("http://") == -1 && value.indexOf("https://") == -1) {
                value = value.startsWith("/") ? value : ("/" + value);
                if (window.ADMIN_URL && (value.startsWith("/admin/") || value.startsWith("/oaadmin/"))) {
                    value = this.platStringUtil.replaceAll(value, "/oaadmin/", "/");
                    value = this.platStringUtil.replaceAll(value, "/admin/", "/");
                    value = window.ADMIN_URL + value;
                } else if (window.FLOW_URL && (value.startsWith("/flow/") || value.startsWith("/oaflow/"))) {
                    value = this.platStringUtil.replaceAll(value, "/oaflow/", "/");
                    value = this.platStringUtil.replaceAll(value, "/flow/", "/");
                    value = window.FLOW_URL + value;
                } else if (window.FORM_RENDER_URL && (value.startsWith("/form/") || value.startsWith("/oaform/"))) {
                    value = this.platStringUtil.replaceAll(value, "/oaform/", "/");
                    value = this.platStringUtil.replaceAll(value, "/form/", "/");
                    value = window.FORM_RENDER_URL + value;
                } else if (window.OA_URL && (value.startsWith("/project/") || value.startsWith("/oaproject/"))) {
                    value = this.platStringUtil.replaceAll(value, "/oaproject/", "/");
                    value = this.platStringUtil.replaceAll(value, "/project/", "/");
                    value = window.OA_URL + value;
                } else {
                    value = window.FORM_RENDER_URL + "/" + value;
                }

            }
            return value;
        },

        replaceUrlPrefix(value) {
            if (window.ADMIN_URL && (value.indexOf("/admin/") > -1 || value.indexOf("/oaadmin/") > -1)) {
                if (value.indexOf("/admin/") > -1) {
                    value = this.platStringUtil.replaceAll(value, "/admin/", window.ADMIN_URL + "/");
                } else {
                    value = this.platStringUtil.replaceAll(value, "/oaadmin/", window.ADMIN_URL + "/");
                }
            }
            if (window.FLOW_URL && (value.indexOf("/flow/") > -1 || value.indexOf("/oaflow/") > -1)) {
                if (value.indexOf("/flow/") > -1) {
                    value = this.platStringUtil.replaceAll(value, "/flow/", window.FLOW_URL + "/");
                } else {
                    value = this.platStringUtil.replaceAll(value, "/oaflow/", window.FLOW_URL + "/");
                }
            }
            if (window.FORM_RENDER_URL && (value.indexOf("/form/") > -1 || value.indexOf("/oaform/") > -1)) {
                if (value.indexOf("/form/") > -1) {
                    value = this.platStringUtil.replaceAll(value, "/form/", window.FORM_RENDER_URL + "/");
                } else {
                    value = this.platStringUtil.replaceAll(value, "/oaform/", window.FORM_RENDER_URL + "/");
                }
            }
            if (window.OA_URL && (value.indexOf("/project/") > -1 || value.indexOf("/oaproject/") > -1)) {
                if (value.indexOf("/project/") > -1) {
                    value = this.platStringUtil.replaceAll(value, "/project/", window.OA_URL + "/");
                } else {
                    value = this.platStringUtil.replaceAll(value, "/oaproject/", window.OA_URL + "/");
                }
            }

            value = this.platStringUtil.replaceAll(value, "window.JAVA_URL", "''");
            value = this.platStringUtil.replaceAll(value, "JAVA_URL", "''");
            value = this.platStringUtil.replaceAll(value, "window.baseUrl", "''");
            value = this.platStringUtil.replaceAll(value, "baseUrl", "''");

            return value;
        },

        getDataSourceArr() {
            if(this.loginUser.userAccount !== "developer") {
                this.dataSourceArr = [];
                return;
            }
            this.spcpFormAxios.post(this.api.mixDataTool.getDataSoucreArr).then(res => {
                let sourceArr = res.data || [];
                let shareSources = this.listModel.formBase.shareSources;
                let currentSource = this.listModel.formBase.sourceKey;
                if(shareSources) {
                    shareSources += "," + currentSource;
                    this.dataSourceArr = sourceArr.filter(arr => {
                        return shareSources.includes(arr.value);
                    })
                }
            })
        },

        dataSourceChange(value) {
            this.sourceKey = value;
            window.currentDataSourceKey = value;
            this.getDataRows();
        },

        getFormBase() {
            this.formBaseObj = this.listModel.formBase;
            if (this.formBaseObj) {
                this.formDefineKey = this.formBaseObj.defineKey;
                this.formId = this.formBaseObj.id;
                this.sourceKey = this.formBaseObj.sourceKey;
                let shareSources = this.formBaseObj.shareSources;
                if(this.sourceId && (shareSources || "").indexOf(this.sourceId) > -1){
                    this.sourceKey = this.sourceId;
                }else if(this.sourceId){
                    this.$message.error("无效的数据源ID，已自动调整为默认数据源！");
                }
                window.currentDataSourceKey = this.sourceKey;
            }
        },

        getControlConfigDatas() {
            return new Promise(resolve => {
                let vm = this;
                //查询字段配置
                this.FORM_GLOBAL.getControlConfig(this.tableViewData.id, this.loginUser.userType).then(resData => {
                    (resData || []).forEach(item => {
                        vm.$set(vm.showContentField, item.fieldId, item);
                        vm.$set(vm.showFieldType, item.fieldId, item.controlType);
                        try {
                            vm.$set(vm.timeSpecialSet, item.fieldId, JSON.parse(item.specialSet));
                        } catch (e) {
                            vm.$set(vm.timeSpecialSet, item.fieldId, item.specialSet);
                        }
                    });
                    resolve();
                });
            })
        },

        getFormFields() {
            return new Promise(resolve => {
                let datas = this.listModel.formFields;
                (datas || []).forEach(item => {
                    this.formFieldObj[item.id] = item;
                });
                this.initSuccess("getFormFields");
                resolve(this.formFieldObj);
            })
        },

        getTableTopButton() {
            return new Promise(resolve => {
                if (((this.isEjectTable != "1" || this.isEjectTable == "1" && this.isEjectTableShowTopButton) && this.isEditTable != "1" && this.isViewTable != "1" && this.compositeFormOperate != 'view') || this.isEjectTableShowTopButton) {
                    // 顶部按钮
                    this.headButtonArr = this.listModel.viewsTopButton || [];

                    //如果存在操作权限则
                    if (!this.isEmptyObject(this.operateAuthority)) {
                        this.headButtonArr = this.headButtonArr.filter(item => {
                            return this.operateAuthority[item.defineKey] || this.operateAuthority[item.code]; //根据 defineKey 过滤
                        })
                    } else {
                        if (!this.isPreview) {
                            this.headButtonArr = [];
                        }
                    }
                    this.headButtonArr.forEach(item => {
                        this.headButtonObj[item.id] = item;
                        this.buttonReminderObj[item.buttonType] = item;
                        if (item.buttonType == "downloadModel") {
                            this.impModelId = item.param;
                        } else if (item.buttonType == "export") {
                            this.expTitle = item.saveMessage || ((this.listModel.listViews || {}).viewName);
                        }
                    });
                    if(this.isEjectTable == "1" && this.isEjectTableShowTopButton){
                        this.headButtonArr = this.headButtonArr.filter(item => ["add","delete","diy"].includes(item.buttonType))
                    }
                    if (this.isEjectTableShowSelect) {
                        this.headButtonArr.push({
                            buttonType: "choose",
                            icon: "el-icon-thumb",
                            buttonColor: "warning",
                            showName: "选择"
                        });
                        this.headButtonObj["ejectChoose"] = {
                            buttonType: "choose",
                            icon: "el-icon-thumb",
                            buttonColor: "warning",
                            showName: "选择"
                        };
                    }
                    let needArr = ["delete","diy","export"];
                    this.headBtnIsHasDelete = this.headButtonArr.some(item => needArr.includes(item.buttonType));
                    this.initSuccess("getTableTopButton");
                    resolve(this.headButtonObj);
                } else {
                    if (this.isEditTable == "1" && this.isShowDiyButton == '1' && this.isEditData) { //解析自定义按钮
                        //行自定义按钮
                        this.topDiyButtonArr = [];
                        let topBtnArr = this.listModel.viewsTopButton || [];
                        // 如果存在操作权限则
                        if (!this.isEmptyObject(this.operateAuthority)) {
                            topBtnArr = topBtnArr.filter(item => {
                                return this.operateAuthority[item.defineKey] || this.operateAuthority[item.code];
                            })
                        } else {
                            if (!this.isPreview) {
                                topBtnArr = [];
                            }
                        }
                        topBtnArr.forEach(item => {
                            if (item.buttonType == 'diy') {
                                this.topDiyButtonArr.push(item);
                            }
                        });
                    }
                    if (this.isEjectTableShowSelect) {
                        this.headButtonArr.push({
                            buttonType: "choose",
                            icon: "el-icon-thumb",
                            buttonColor: "warning",
                            showName: "选择"
                        });
                        this.headButtonObj["ejectChoose"] = {
                            buttonType: "choose",
                            icon: "el-icon-thumb",
                            buttonColor: "warning",
                            showName: "选择"
                        };
                    }
                    this.initSuccess("getTableTopButton");
                    resolve();
                }
            });
        },

        setOptColumnLength() {
            if (!this.viewDefinData.operateBtnWidth){
                this.optColumnLength = 22;
            }
            // 当前多少行，一行显示几个按钮，过滤出行最多按钮的那一行数据，operateBtnWidth列表配置固定操作栏宽度属性
            // if (this.viewDefinData.pagination === '1') { //分页
                let currPageDataRows = Object.values(this.currentPageDataObj) || [];
                let btnArr = [];
                let getOperationLength = [];
                let showNameMaxLength = 0;
                currPageDataRows.forEach((rowData, index) => { //行数据
                    let showNameLength = 0;
                    let isShowBtnArr = [];
                    this.optButtonArr.forEach((item, optButtonIndex) => { //行按钮数据
                        let isShowBtn = this.showButtonConfigtion(item, rowData);
                        isShowBtn && isShowBtnArr.push(item);
                        if (isShowBtn) {
                            showNameLength = showNameLength < item.showName.length ? item.showName.length : showNameLength;
                        }
                    });
                    // 当按钮数量相同时，取按钮名称最长的
                    if (getOperationLength.length === isShowBtnArr.length) {
                        if (showNameLength > showNameMaxLength) {
                            // 获取按钮名称最大长度
                            showNameMaxLength = showNameLength;
                            getOperationLength = isShowBtnArr;
                        }
                    } else if (getOperationLength.length < isShowBtnArr.length) { // 按钮数量不同时，取按钮数量最多的
                        // 获取按钮名称最大长度
                        showNameMaxLength = showNameLength;
                        getOperationLength = isShowBtnArr;
                    }
                    btnArr.push(isShowBtnArr);
                });
                btnArr.sort((a, b) => b.length - a.length);
                // console.log('btnArr', btnArr);
                // console.log('currPageDataRows', currPageDataRows, this.viewDefinData);

                if (currPageDataRows.length === 0 && !this.viewDefinData.operateBtnWidth){
                    this.optColumnLength = 200;
                }
                (getOperationLength || []).forEach((item, index) => {
                    // 按钮是几个，按钮本身宽度+外边距（按钮个数-1）*10+内边距22
                    let nameLength = item.showName.length;
                    if (!this.viewDefinData.operateBtnWidth) {
                        if (this.viewDefinData.hideOperateBtnText === '1') {
                            this.optColumnLength += 44;
                        } else {
                            this.optColumnLength += 49 + nameLength * 15;
                        }
                        if (index > 0) {
                            this.optColumnLength += 10; //按钮左外边距宽度
                        }
                    }
                });
            // } else {
            //     // console.log('没有分页');
            //     this.optButtonArr.forEach(item => {
            //         let nameLength = item.showName.length;
            //
            //         if (!this.viewDefinData.operateBtnWidth) {
            //             if (nameLength > 2) {
            //                 this.optColumnLength += 100 + (nameLength - 2) * 12;
            //             } else {
            //                 this.optColumnLength += 100;
            //             }
            //         }
            //     });
            // }

            this.optButtonArr.forEach(item => {
                this.optButtonObj[item.id] = item;
                this.buttonReminderObj[item.buttonType] = item;
            });
        },

        getTableSelfButton() {
            return new Promise(resolve => {
                if (this.isEjectTable != "1" && this.isEditTable != "1" && this.isViewTable != "1") {
                    // 行按钮
                    this.optButtonArr = this.listModel.viewsSelfButton || [];
                    // 如果存在操作权限则
                    if (!this.isEmptyObject(this.operateAuthority)) {
                        this.optButtonArr = this.optButtonArr.filter(item => {
                            return this.operateAuthority[item.defineKey] || this.operateAuthority[item.code];
                        })
                    } else {
                        if (!this.isPreview) {
                            this.optButtonArr = [];
                        }
                    }

                    this.setOptColumnLength();
                    this.initSuccess("getTableSelfButton");
                    resolve(this.optButtonObj);
                } else {
                    if (this.isEditTable == "1" && this.isShowDiyButton == '1' && this.isEditData) { //解析自定义按钮
                        //行自定义按钮
                        this.optDiyButtonArr = [];
                        let selfBtnArr = this.listModel.viewsSelfButton || [];
                        // 如果存在操作权限则
                        if (!this.isEmptyObject(this.operateAuthority)) {
                            selfBtnArr = selfBtnArr.filter(item => {
                                return this.operateAuthority[item.defineKey] || this.operateAuthority[item.code];
                            })
                        } else {
                            if (!this.isPreview) {
                                selfBtnArr = [];
                            }
                        }
                        let specialTypeWidth = Number(this.specialTypeWidth);
                        selfBtnArr.forEach(item => {
                            if (item.buttonType == 'diy') {
                                //计算宽度
                                let nameLength = item.showName.length;
                                if (nameLength > 2) {
                                    specialTypeWidth += 100 + (nameLength - 2) * 12;
                                } else {
                                    specialTypeWidth += 100;
                                }
                                this.optDiyButtonArr.push(item);
                            }
                        });
                        this.specialTypeWidth = specialTypeWidth + "";
                    }
                    this.initSuccess("getTableSelfButton");
                    resolve();
                }
            })
        },

        getSearchBox() {
            return new Promise(resolve => {
                this.searchBoxArr = this.listModel.searchBox || [];
                resolve(this.searchBoxArr);
                this.initSuccess("getSearchBox");
                this.initSearchForm();
            });
        },
        getSearchBoxWidth() {
            let newWidth = this.$refs.hqgd ? (parseInt(this.$refs.hqgd.offsetWidth) - 200) : 0;
            let singleLineWidth = 0;//收缩时搜索栏宽度
            this.searchBoxArr.forEach(item => {
                this.$set(item, 'isShowDom', false)
            })
            this.isPullDown = false;
            for (let i = 0; i < this.searchBoxArr.length; i++) {
                let refNum = 'searchFormItem' + i;
                let surpassNewWidth = singleLineWidth + (this.$refs[refNum] ? this.$refs[refNum][0].$el.clientWidth : 0) + 10;
                if (surpassNewWidth < newWidth) {
                    this.$set(this.searchBoxArr[i], 'isShowDom', true)
                    singleLineWidth += ((this.$refs[refNum] ? this.$refs[refNum][0].$el.clientWidth : 0) + 10);
                } else {
                    this.isPullDown = true;
                    break;
                }
            }
            this.SingleLineSearchWidth = singleLineWidth + 'px';
            this.showSearchBtn = true;
        },

        getListField() {
            return new Promise(resolve => {
                this.showColumnFieldArr = [];
                this.showFieldArr = [];
                this.countAllCol = [];
                if (this.listViewId) {
                    let datas = this.listModel.listFields || [];
                    this.allFiledObj = {};
                    datas.forEach(item => {
                        if(item.diyColumns ==''){
                            item.diyColumns='2';
                        }
                        if (item["countAll"] === "1") {
                            this.isCountAll = true;
                            this.countAllCol.push(item);
                        }
                        this.showFieldObj[item.fieldId] = item;
                        if(item.specialField){
                            item.fieldName = item.fieldId;
                        }
                        //处理合并列
                        if (item.combine == "1" && item.combineType == "1") {
                            let allFields = item.fieldId + "," + item.combineCols;
                            this.$set(item, "allFieldIdArr", allFields.split(","));
                        }
                        if (item.combine == '0' || item.combineType == '1') {
                            this.showFieldArr.push(item);
                        }
                        if (item.diyColumns === '1' || item.diyColumns === '2') {
                            this.showColumnFieldArr.push(JSON.parse(JSON.stringify(item)));
                        }
                        if (item.openTotal === '1') {
                            this.showOpenTotalColumnFieldArr.push(item);
                        }
                        if (item.fixed != "1" && item.locked != "1" && item.forbidden != "1" && item.hiddenCol != "-1") {
                            this.columnTotalLength += Number(item.width);
                        }
                        // 赋值所有字段对象方便后面调用
                        this.$set(this.allFiledObj, item.fieldId, item);
                    });
                    resolve();
                } else {
                    resolve("");
                }
            });
        },

        getFormField() {
            this.reqAfterComps = [];
            this.reqBeforeComps = [];
            return new Promise(resolve => {
                let datas = this.listModel.showFields || [];
                datas.forEach(item => {
                    if (item.id) {
                        this.$set(this.showFieldObj[item.id], "fieldName", item.phyfieldName.toUpperCase());
                        this.fieldNameMap[item.phyfieldName] = item.id;
                    }
                });
                let columnFormat = this.listModel.columnFormat || [];
                let columnObj = {};
                let compArr = [];
                columnFormat.forEach(item => {
                    if(!Number(item.open)){
                        return;
                    }
                    if (typeof item["configData"] == 'string') {
                        item["configData"] = JSON.parse(item["configData"] || "{}");
                    } else {
                        item["configData"] = item["configData"] || {};
                    }
                    if (typeof item["eventSetData"] == 'string') {
                        item["eventSetData"] = JSON.parse(item["eventSetData"] || "{}");
                    } else {
                        item["eventSetData"] = item["eventSetData"] || {};
                    }
                    if (typeof item["paramData"] == 'string') {
                        item["paramData"] = JSON.parse(item["paramData"] || "[]");
                    } else {
                        item["paramData"] = item["paramData"] || [];
                    }
                    let paramObj = {};
                    item["paramData"].forEach(param => {
                        // 牵扯到行数据的替换在formatRender里面进行，这里还没获取到数据
                        if (param.paramType == "default") {
                            paramObj[param.paramKey] = Replace.def(this.loginUser, param.paramVal);
                        }
                        if (param.paramType == "diy") {
                            paramObj[param.paramKey] = param.paramVal;
                        }
                        if (param.paramType == "sysData" && (param.paramVal || []).length > 1) {
                            paramObj[param.paramKey] = (this.sysDataObj[param.paramVal[param.paramVal.length - 1]] || {}).id || "";
                        }
                    })
                    item["paramObj"] = paramObj;
                    columnObj[item.id] = item;
                    this.columnFormatObj[item.fieldId] = item;
                    let setting = this.FORM_PLUGIN.listColumnFormatters[item.chooseFunc];
                    if (item.isNewData == '1') {
                        setting = this.EVENT_PLUGIN.allEventObj[item.chooseFunc];
                    }
                    // 由于在使用事件规则生效后转为自定义脚本没有删除配置，所以这里需要判定是否使用的是事件规则
                    if (setting && compArr.indexOf(setting.id) == -1 && item.resource == 'event') {
                        setting.reqBefore && (this.reqBeforeComps.push({
                            'name': setting.id,
                            'component': setting.reqBefore,
                            'formatObj': item
                        }));
                        setting.reqAfter && (this.reqAfterComps.push({
                            'name': setting.id,
                            'component': setting.reqAfter,
                            'formatObj': item
                        }));
                        compArr.push(setting.id);
                    }
                });
                this.loadReqBeforeComps();
                columnFormat.forEach(item => {
                    if (Number(item.open)) {
                        if (item.isNewData == '1' && item.resource == "diyScript" && item.leadFunc == '1') { //新数据且为引用状态
                            this.columnFormatObj[item.fieldId] = columnObj[item.leadFuncId];
                        } else if (item.resource == "lead") {
                            this.columnFormatObj[item.fieldId] = columnObj[item.leadFuncId];
                        }
                    }
                })
                this.initSuccess("getFormField");
                resolve(this.columnFormatObj);
            });
        },

        getViewDefine() {
            return new Promise(resolve => {
                this.viewDefinData = this.listModel.listViews;
                if (this.viewDefinData === undefined) {
                    this.$message.error("列表视图不存在！");
                    return;
                }
                // 如果是多表表单视图设置多表查看
                this.multiTableViewId = "";
                if (Number(this.viewDefinData.viewMulti)) { // 如果是多表查看表单id不一样
                    this.multiTableViewId = this.viewDefinData.tableViewMultiId;
                }
                this.multiFormId = this.viewDefinData.multiFormId || '';
                //设置分页信息
                this.pageSize = this.viewDefinData.paginationSize;
                //表头样式
                if (this.viewDefinData.headerRowStyle) {
                    let styleArr = this.viewDefinData.headerRowStyle.split(";") || [];
                    styleArr.forEach(style => {
                        let arr = style.split(":");
                        this.$set(this.headerRowStyle, arr[0], arr[1]);
                    });
                }
                //行样式
                if (this.viewDefinData.rowStyle) {
                    let styleArr = this.viewDefinData.rowStyle.split(";") || [];
                    styleArr.forEach(style => {
                        let arr = style.split(":");
                        this.$set(this.rowStyle, arr[0], arr[1]);
                    });
                    if (!this.rowStyle.hasOwnProperty('height')) {
                        this.$set(this.rowStyle, "height", '10px');
                    }
                } else {
                    this.rowStyle = {height: '10px'};
                }
                resolve(this.viewDefinData);

                if (this.viewDefinData.operateBtnWidth) {
                    this.optColumnLength = this.viewDefinData.operateBtnWidth;
                }
            })
        },

        getTableViewData() {
            return new Promise(resolve => {
                this.tableViewData = this.listModel.tableViews;
                resolve(this.tableViewData);
            });
        },

        getTableViewMultiData() {
            return new Promise(resolve => {
                if (this.multiTableViewId) {
                    this.tableViewMultiData = this.listModel.multiTableViews;
                    this.initSuccess("getTableViewMultiData");
                    resolve(this.tableViewMultiData);
                } else {
                    this.initSuccess("getTableViewMultiData");
                    resolve();
                }
            });
        },

        getEditTable() {
            return new Promise(resolve => {
                //获取表单中的编辑列表
                let datas = this.listModel.editList || [];
                datas.forEach(item => {
                    let specialSet = JSON.parse(item.specialSet || "{}");
                    if (specialSet.mainTableLink == "1") {
                        this.editTableIdArr.push(specialSet.linkFormId);
                    }
                });

                resolve(this.editTableIdArr);
            });
        },

        getViewsButton() {
            return new Promise(resolve => {
                let datas = this.listModel.viewsButton || [];
                (datas || []).forEach(item => {
                    if (item.visible != "false") {
                        this.tableViewButtonArr.push(item);
                        if (item.hiddenCondition) {
                            this.tviewBtnConditionObj[item.id] = JSON.parse(item.hiddenCondition);
                        }
                    }
                });
                this.tableViewButtonArr.sort((a, b) => (a['buttonSort'] - b['buttonSort']));
                resolve(this.tableViewButtonArr);
                this.initSuccess("getViewsButton");
            });
        },

        /**
         * 行可编辑加载脚本定义
         */
        loadScriptData() {
            return new Promise(resolve => {
                const vm = this;
                vm.scriptDataArr = []; //脚本arr
                vm.FORM_GLOBAL.getFormScripts(vm.tableViewData.viewScript).then(scriptDatas => {
                    if (scriptDatas) {
                        const scripts = scriptDatas || [];
                        if (!!scripts && scripts.constructor === Array && scripts.length > 0) {
                            let serviceName = (window.SERVICE_NAME || {});
                            let adminServeName = serviceName.admin || "/admin/";
                            let formServeName = serviceName.form || "/form/";
                            let flowServeName = serviceName.flow || "/flow/";
                            let oaServeName = serviceName.oa || "/oaproject/";
                            scripts.forEach(script => {
                                if (!!script) {
                                    vm.clearScriptData(); //初始化scriptData对象
                                    if (script.scriptContent) {
                                        let value = script.scriptContent;
                                        // value = vm.platStringUtil.replaceAll(value, "/admin/", adminServeName);
                                        // value = vm.platStringUtil.replaceAll(value, "/form/", formServeName);
                                        // value = vm.platStringUtil.replaceAll(value, "/flow/", flowServeName);
                                        // value = vm.platStringUtil.replaceAll(value, "/oaproject/", oaServeName);
                                        // value = vm.platStringUtil.replaceAll(value, "/oaadmin/", adminServeName);
                                        // value = vm.platStringUtil.replaceAll(value, "/oaform/", formServeName);
                                        // value = vm.platStringUtil.replaceAll(value, "/oaflow/", flowServeName);
                                        value = this.replaceUrlPrefix(value);

                                        script.scriptContent = value;
                                    }
                                    vm.scriptData[script.scriptUseType][script.scriptPosition] = new Function(...vm.formalParams, script.scriptContent);
                                    vm.scriptDataArr.push(vm.scriptData);
                                }
                            });
                        }


                    }
                    resolve();
                });
            });
        },

        clearScriptData() {
            this.scriptData = {
                add: {beforeOpen: null, afterOpen: null},
                update: {beforeOpen: null, afterOpen: null},
                view: {beforeOpen: null, afterOpen: null},
                save: {beforeSubmit: null, afterSubmit: null},
                close: {beforeClose: null, afterClose: null},
                all: {
                    beforeOpen: null,
                    afterOpen: null,
                    beforeSubmit: null,
                    afterSubmit: null,
                    beforeClose: null,
                    afterClose: null
                }
            };
        },

        /**
         * 执行操作前脚本
         * scriptData 脚本数据
         * type 使用类型
         * operator 表单操作类型
         * argumens 脚本中的参数(以及系统方法)
         * paramArr 参数
         */
        execBeforeScripts(scriptData, type, operator, paramArr) {
            let retOp = null;
            let retAll = null;
            if (!!scriptData[type]['before' + operator] &&
                scriptData[type]['before' + operator].constructor === Function) {
                retOp = scriptData[type]['before' + operator](...paramArr);
            }
            if (!!scriptData['all']['before' + operator] &&
                scriptData['all']['before' + operator].constructor === Function) {
                retAll = scriptData['all']['before' + operator](...paramArr);
            }
            return {retOp, retAll};
        },
        /**
         * 执行操作后脚本
         * scriptData 脚本数据
         * type 使用类型
         * operator 表单操作类型
         * argumens 脚本中的参数(以及系统方法)
         * paramArr 参数
         */
        execAfterScripts(scriptData, type, operator, paramArr) {
            if (!!scriptData[type]['after' + operator] &&
                scriptData[type]['after' + operator].constructor === Function) {
                scriptData[type]['after' + operator](...paramArr);
            }
            if (!!scriptData['all']['after' + operator] &&
                scriptData['all']['after' + operator].constructor === Function) {
                scriptData['all']['after' + operator](...paramArr);
            }
        },


        //树视图定义
        getTreeDefine() {
            return new Promise(async resolve => {
                this.treeDefineObj = {};
                let datas = this.listModel.treeDefines || [];
                let treeDefineArr = [];
                if ((this.isEditTable == '1' || this.isViewTable == '1' || this.isEjectTable == '1') && this.linkTreeViewId) { //如果是编辑列表或者查看列表根据配置获取
                    treeDefineArr = datas.filter(item => {
                        return this.linkTreeViewId == item.defineKey;//根据 defineKey 过滤
                    })
                } else if (!this.isEmptyObject(this.operateAuthority)) {
                    treeDefineArr = datas.filter(item => {
                        return this.operateAuthority[item.defineKey + "_tree"]; //根据 defineKey 过滤
                    })
                } else {
                    if (!this.isPreview) {
                        treeDefineArr = [];
                    } else {
                        treeDefineArr = datas;
                    }
                }

                if (treeDefineArr.length > 0) {
                    this.treeDefineObj = treeDefineArr[0];
                    let paramArr = this.dealSearchParam();
                    if (this.extraCondition) {
                        let paramObj = {controlType: "auto", value: this.extraCondition};
                        paramArr.push(paramObj);
                    }
                    //编辑列表根据RELATION_ID查询数据
                    if (this.isEditTable == "1") {
                        let paramObj = {
                            controlType: "defaultField",
                            key: "RELATION_ID",
                            operate: "=",
                            value: (this.relationId || "$")
                        };
                        paramArr.push(paramObj);
                    }
                    if ((this.isViewTable == "1" || this.isEjectTable == "1" || this.isEditTable == '1') &&
                        this.conditionFormArr && this.conditionFormArr.length > 0) {
                        let conditionFormSql = this.getConditionSql() || "";
                        let paramObj = {controlType: "auto", value: conditionFormSql};
                        paramArr.push(paramObj);
                    }
                    let equilibriumStr = "";
                    equilibriumStr = JSON.stringify(this.equilibriumData || {});
                    //查询所有的分类
                    this.spcpFormAxios.post(this.api.plCommonmethod.findDataByTree,
                        {
                            listViewId: this.listViewId,
                            conditionId: this.conditionId,
                            queryParams: JSON.stringify(paramArr),
                            treeDefineId: this.treeDefineObj.id,
                            equilibriumData: equilibriumStr
                        }).then(res => {
                        if (res && res.data && res.data.operateObj) {
                            let treeArr = [];
                            treeArr.push({"id": "all", "label": "全部", "value": "全部", "parentId": "-1"});
                            let treeData = res.data.operateObj || [];
                            let treeDefineArr = this.treeDefineObj.treeName.split("-->"); //
                            let treeSort = JSON.parse(this.treeDefineObj.treeSort);
                            let treeFieldArr = [];
                            let dataCodeArr = [];
                            (treeDefineArr || []).forEach((field, index) => {
                                if (treeSort[index]) {
                                    let treeFiledId = (treeSort[index] || {}).id;
                                    //let useFormId = treeSort[index].useForm;
                                    let useFormId = this.formId;
                                    // 元数据
                                    if (this.showFieldObj[treeFiledId] && this.showFieldObj[treeFiledId].dataCode == "1") {
                                        dataCodeArr.push(field + "_" + useFormId);
                                    }
                                    treeFieldArr.push(field + "_" + useFormId);
                                }
                            });
                            //排序
                            this.sortTreeData(treeData, treeFieldArr[0]);

                            let dataMap = {};
                            let fieldDataMap = {};
                            let fieldDataMapTemp = {};
                            for (let i = 0; i < treeFieldArr.length; i++) {
                                let cjmap = new Map();
                                for (let j = 0; j < treeData.length; j++) {
                                    let label = "空";
                                    let value = "eq(null)";
                                    if (treeData[j] && treeData[j][treeFieldArr[i]]) {
                                        let val = treeData[j][treeFieldArr[i]];
                                        if (val.indexOf("nocombo") > -1) {
                                            value = val.split(":")[2];
                                            label = val.split(":")[1];
                                        } else if (val.indexOf("combo") > -1) {
                                            value = val;
                                            label = val.split(":")[1];
                                        } else {
                                            label = val;
                                            value = val;
                                        }
                                        if (dataCodeArr.indexOf(treeFieldArr[i]) > -1 && this.sysDataObj[label]) { // 元数据
                                            label = this.sysDataObj[label].dataName;
                                        }
                                    }

                                    let fieldmap = {};
                                    fieldmap[treeFieldArr[i]] = value;
                                    //第一轮，上级是all
                                    if (i == 0) {
                                        dataMap[j] = value;
                                        fieldDataMap[j] = Object.assign({}, fieldmap);
                                        if ((i == 0 && !cjmap.has(value) || (i > 0 && !cjmap.has(dataMap[j] + "_" + value)))) {
                                            cjmap.set(value, j);
                                            treeArr.push({
                                                "id": value,
                                                "parentId": "all",
                                                "label": label,
                                                "value": value,
                                                "field": treeFieldArr[i],
                                                "fielddata": fieldmap
                                            });
                                        }

                                    } else {
                                        fieldDataMap[j] = Object.assign(fieldDataMap[j], fieldmap);
                                        fieldDataMapTemp[j] = Object.assign({}, fieldDataMap[j]);

                                        if ((i == 0 && !cjmap.has(value) || (i > 0 && !cjmap.has(dataMap[j] + "_" + value)))) {
                                            cjmap.set(dataMap[j] + "_" + value, j);
                                            if (label == "空") {
                                                continue;
                                            }
                                            treeArr.push({
                                                "id": dataMap[j] + "_" + value,
                                                "parentId": dataMap[j],
                                                "label": label,
                                                "value": value,
                                                "field": treeFieldArr[i],
                                                "fielddata": fieldDataMapTemp[j]
                                            });
                                        }
                                        dataMap[j] = dataMap[j] + "_" + value;
                                    }
                                }
                            }
                            if (this.namberTreeLoad == '0') {
                                this.treeData = this.COMMON_FUNC.buildElTree(treeArr);
                                this.dataTreeLoad = this.treeData;
                                this.namberTreeLoad = "1";
                            } else {
                                this.treeData = [];
                                this.treeData = this.dataTreeLoad;
                            }
                            /*this.treeData = this.COMMON_FUNC.buildElTree(treeArr);*/
                            //默认展开根节点
                            this.treeDefaultExpandedKeys.push(this.treeData[0].id);
                        }

                        resolve();
                    });
                } else {
                    resolve();
                }

            });
        },

        /**
         * 树数据排序，空值放最后
         * @param treeData
         * @param key
         */
        sortTreeData(treeData, key) {
            treeData.sort((a, b) => {
                if (!a && b) {
                    return 1;
                } else if (a && !b) {
                    return -1;
                } else if (!a && !b) {
                    return 0;
                } else if (a && b && key) {
                    if (!a[key] && b[key]) {
                        return 1;
                    } else if (a[key] && !b[key]) {
                        return -1;
                    } else if (!a[key] && !b[key]) {
                        return 0;
                    }
                }
            });
        },


        /**
         * 获取配置信息
         */
        async getConfigInfo() {
            this.tableViewButtonArr = [];
            this.showFieldArr = [];
            this.columnTotalLength = 0;

            //字段信息
            let formFieldRes = await this.spcpFormAxios.post(this.api.plFormField.find, {formId: this.formId});
            if (formFieldRes && formFieldRes.data) {
                formFieldRes.data.forEach(item => {
                    this.formFieldObj[item.id] = item;
                });
            }

            //搜索框
            let searchBoxRes = await this.spcpFormAxios.post(this.api.plSearchbox.find,
                {formId: this.formId, "listViewId": this.listViewId, order: "SEARCH_ORDER"});
            if (searchBoxRes && searchBoxRes.data) {
                this.searchBoxArr = searchBoxRes.data || [];
            }

            if (this.isEjectTable != "1" && this.isEditTable != "1" && this.isViewTable != "1") {
                //顶部按钮
                let buttonTopRes = await this.spcpFormAxios.post(this.api.plListViewsButton.findButton,
                    {formId: this.formId, listViewId: this.listViewId, openMode: "top", order: "BUTTON_ORDER"});
                if (buttonTopRes && buttonTopRes.data) {
                    this.headButtonArr = buttonTopRes.data.operateObj || [];
                    //如果存在操作权限则
                    if (!this.isEmptyObject(this.operateAuthority)) {
                        this.headButtonArr = this.headButtonArr.filter(item => {
                            return this.operateAuthority[item.id];
                        })
                    } else {
                        if (!this.isPreview) {
                            this.headButtonArr = [];
                        }
                    }
                    this.headButtonArr.forEach(item => {
                        this.headButtonObj[item.id] = item;
                        this.buttonReminderObj[item.buttonType] = item;
                        if (item.buttonType == "downloadModel") {
                            this.impModelId = item.param;
                        } else if (item.buttonType == "export") {
                            this.expTitle = item.saveMessage || ((this.listModel.listViews || {}).viewName);
                        }
                    });
                }
                //行按钮
                let buttonSelfRes = await this.spcpFormAxios.post(this.api.plListViewsButton.findButton,
                    {formId: this.formId, listViewId: this.listViewId, openMode: "self", order: "BUTTON_ORDER"});
                if (buttonSelfRes && buttonSelfRes.data) {
                    this.optButtonArr = buttonSelfRes.data.operateObj || [];
                    //如果存在操作权限则
                    if (!this.isEmptyObject(this.operateAuthority)) {
                        this.optButtonArr = this.optButtonArr.filter(item => {
                            return this.operateAuthority[item.id];
                        })
                    } else {
                        if (!this.isPreview) {
                            this.optButtonArr = [];
                        }
                    }

                    this.optButtonArr.forEach(item => {
                        this.optButtonObj[item.id] = item;
                        this.buttonReminderObj[item.buttonType] = item;
                        let nameLength = item.showName.length;
                        if (!this.viewDefinData.operateBtnWidth) {
                            if (nameLength > 2) {
                                this.optColumnLength += 100 + (nameLength - 2) * 12;
                            } else {
                                this.optColumnLength += 100;
                            }
                        }
                    });
                }
            }

            //显示字段
            let fieldIds = "";
            let listFieldRes = await this.spcpFormAxios.post(this.api.plListField.find, {
                listViewId: this.listViewId,
                order: "FIELD_ORDER"
            });
            if (listFieldRes && listFieldRes.data) {
                listFieldRes.data.forEach(item => {
                    this.showFieldObj[item.fieldId] = item;
                    fieldIds += "," + item.fieldId;
                    //处理合并列
                    if (item.combine == "1" && item.combineType == "1") {
                        let allFields = item.fieldId + "," + item.combineCols;
                        this.$set(item, "allFieldIdArr", allFields.split(","));
                    }
                    if (item.combine == '0' || item.combineType == '1') {
                        this.showFieldArr.push(item);
                        if (item.locked == "1") {
                            this.operateFixPos = "right";
                            this.indexFixPos = true;
                        }
                    }

                    if (item.fixed != "1" && item.locked != "1" && item.forbidden != "1" && item.hiddenCol != "-1") {
                        this.columnTotalLength += Number(item.width);
                    }
                });
                if (fieldIds) {
                    //字段物理名
                    let fieldInfoRes = await this.spcpFormAxios.post(this.api.plFormField.find, {id: fieldIds.substring(1)});
                    fieldInfoRes.data.forEach(item => {
                        this.$set(this.showFieldObj[item.id], "fieldName", item.phyfieldName.toUpperCase());
                    });
                    //列格式化方法
                    let columnFormatRes = await this.spcpFormAxios.post(this.api.plColumnFormat.findByViewIdAndFieldIds,
                        {listViewId: this.listViewId, fieldIds: fieldIds.substring(1)});
                    if (columnFormatRes && columnFormatRes.data) {
                        let columnObj = {};
                        columnFormatRes.data.forEach(item => {
                            item["configData"] = JSON.parse(item["configData"] || "{}");
                            item["eventSetData"] = JSON.parse(item["eventSetData"] || "{}");
                            item["paramData"] = JSON.parse(item["paramData"] || "[]");
                            let paramObj = {};
                            item["paramData"].forEach(param => {
                                if (param.paramType == "default") {
                                    paramObj[param.paramKey] = Replace.def(this.loginUser, param.paramVal);
                                }
                                if (param.paramType == "sysData" && (param.paramVal || []).length > 1) {
                                    paramObj[param.paramKey] = (this.sysDataObj[param.paramVal[param.paramVal.length - 1]] || {}).id || "";
                                }
                            })
                            item["paramObj"] = paramObj;
                            this.columnFormatObj[item.fieldId] = item;
                            columnObj[item.id] = item;
                        });
                        columnFormatRes.data.forEach(item => {
                            if (item.resource == "lead") {
                                this.columnFormatObj[item.fieldId] = columnObj[item.leadFuncId];
                            }
                        })
                    }
                }
            }

            //列表视图配置信息
            let viewDefineRes = await this.spcpFormAxios.post(this.api.plListViews.getById, {id: this.listViewId});
            if (viewDefineRes && viewDefineRes.data) {
                this.viewDefinData = viewDefineRes.data;
                // 如果是多表表单视图设置多表查看
                this.multiTableViewId = "";
                if (Number(this.viewDefinData.viewMulti)) { // 如果是多表查看表单id不一样
                    this.multiTableViewId = this.viewDefinData.tableViewMultiId;
                }
                //设置分页信息
                this.pageSize = this.viewDefinData.paginationSize;
                //表头样式
                if (this.viewDefinData.headerRowStyle) {
                    let styleArr = this.viewDefinData.headerRowStyle.split(";") || [];
                    styleArr.forEach(style => {
                        let arr = style.split(":");
                        this.$set(this.headerRowStyle, arr[0], arr[1]);
                    });
                }
                //行样式
                if (this.viewDefinData.rowStyle) {
                    let styleArr = this.viewDefinData.rowStyle.split(";") || [];
                    styleArr.forEach(style => {
                        let arr = style.split(":");
                        this.$set(this.rowStyle, arr[0], arr[1]);
                    });
                    if (!this.rowStyle.hasOwnProperty('height')) {
                        this.$set(this.rowStyle, "height", '10px');
                    }
                } else {
                    this.rowStyle = {height: '10px'};
                }
            }
            if (this.viewDefinData.tableViewId) {
                //表单视图配置信息
                let tableViewRef = await this.spcpFormAxios.post(this.api.plTableviews.getById, {id: this.viewDefinData.tableViewId});
                if (tableViewRef && tableViewRef.data) {
                    this.tableViewData = tableViewRef.data;
                }
                if (this.multiTableViewId) {
                    let tableViewMultiRes = await this.spcpFormAxios.post(this.api.plTableviews.getById, {id: this.multiTableViewId});
                    if (tableViewMultiRes && tableViewMultiRes.data) {
                        this.tableViewMultiData = tableViewMultiRes.data;
                    }
                }
                //获取表单中的编辑列表
                let currentViewId = this.tableViewData.id || this.multiTableViewId || "";
                if (currentViewId) {
                    this.spcpFormAxios.post(this.api.plControlConfig.find, {
                        "tviewId": currentViewId,
                        "controlType": "editList"
                    }).then(res => {
                        if (res && res.data) {
                            (res.data || []).forEach(item => {
                                let specialSet = JSON.parse(item.specialSet || "{}");
                                if (specialSet.mainTableLink == "1") {
                                    this.editTableIdArr.push(specialSet.linkFormId);
                                }
                            });
                        }
                    });
                }

                //表单视图按钮
                let tviewButRef = await this.spcpFormAxios.post(this.api.plViewsButton.find, {tviewId: this.viewDefinData.tableViewId});
                (tviewButRef.data || []).forEach(item => {
                    if (item.visible != "false") {
                        this.tableViewButtonArr.push(item);
                    }
                });
            }
        },

        //打开列表时请求条件定义数据
        getConditionInfo() {
            this.FORM_GLOBAL.getCondition(this.conditionId, this.loginUser.userType).then(resArr => {
                // console.log('resArr-condition',resArr,this.loginUser);
                if (resArr.length > 0) {
                    resArr.forEach(item => {
                        if ((item.operaSign === "=" || item.operaSign === "LIKE CONCAT") && item.value) {
                            this.listSearchConditionObj[item.fieldId] = item;
                        }
                    });
                    // this.setSearchBoxByConditionId();
                }
            })
        },

        setSearchBoxByConditionId() {
            // console.log('this.searchForm',this.searchForm);
            let searchConditionObj = {};
            this.searchBoxArr.forEach((searchBox, index) => {
                //搜索框是级联下拉框时，是由多个fieldId拼接的
                let id = searchBox.id;
                searchConditionObj = this.listSearchConditionObj[searchBox.fieldId];
                // console.log('searchBox',searchBox,searchConditionObj);

                if (searchBox.controlType === "cascadeSelect") {
                    //扩展信息
                    let extendObj = JSON.parse(searchBox.extend || {});
                    searchBox.parentId = extendObj.parentId;
                    if (extendObj.cascadeSetArr && extendObj.cascadeSetArr.length > 0) {
                        let disabled = "";
                        let isHidden = "";
                        extendObj.cascadeSetArr.forEach(item => {
                            if (this.listSearchConditionObj[item.fieldId]) {
                                this.$set(this.searchForm[id], item.fieldId, this.listSearchConditionObj[item.fieldId].value);
                                disabled += "," + "true";
                            } else {
                                this.$set(this.searchForm[id], item.fieldId, "");
                                disabled += "," + "false";
                            }
                            // isHidden += "," + "false";
                            isHidden += "," + (item.isHidden === "1");
                        });
                        this.$set(searchBox, 'disabled', disabled.substring(1));
                        this.$set(searchBox, 'isHidden', isHidden.substring(1));
                        // console.log('$refs',this.$refs['cascadeSelect_' + index]);
                        this.$refs[('cascadeSelect_' + index)] && this.$refs[('cascadeSelect_' + index)][0].initCascadeSelect();
                    }
                }
                if (searchConditionObj && searchBox.controlType !== "cascadeSelect") {
                    // console.log('searchBox.controlType', searchBox.controlType);
                    // let arr = ['loginUser.id'];
                    this.$set(this.searchForm, id, searchConditionObj.value);
                    if (searchConditionObj.value === "LOGINUSER.userId") {
                        this.$set(this.searchForm, id, this.loginUser.id);
                    }
                    if (searchConditionObj.value === "LOGINUSER.userName") {
                        this.$set(this.searchForm, id, this.loginUser.userName);
                    }
                    this.$set(searchBox, "disabled", true);
                }
            });
        },

        /**
         * 获取列表数据
         */
        getDataRows(loading, sortOrder) {

            //表单视图预览中的编辑列表、弹出数据表、查看列表，不需要查询数据
            if (this.isTablePreview == "1") {
                return new Promise(resolve => {
                    this.$nextTick(() => {
                        this.cacheFormatVal = {};
                        this.loadSuccess = true;
                        resolve();
                    });
                });
            }
            let paramArr = this.dealSearchParam();
            if (this.extraCondition) {
                let paramObj = {controlType: "auto", value: this.extraCondition};
                paramArr.push(paramObj);
            }
            if (this.openTotalTagParams) {
                paramArr = paramArr.concat(this.openTotalTagParams);
            }
            //编辑列表根据RELATION_ID查询数据
            if (this.isEditTable == "1") {
                let paramObj = {
                    controlType: "defaultField",
                    key: "RELATION_ID",
                    operate: "=",
                    value: (this.relationId || "$")
                };
                paramArr.push(paramObj);
            }
            if ((this.isViewTable == "1" || this.isEjectTable == "1" || this.isEditTable == '1') &&
                this.conditionFormArr && this.conditionFormArr.length > 0) {
                let conditionFormSql = this.getConditionSql() || "";
                let paramObj = {controlType: "auto", value: conditionFormSql};
                paramArr.push(paramObj);
            }
            //是否需要分页
            if (!this.isShowPage()) {
                this.currentPage = 0;
            }
            if (sortOrder) {
                this.hasSortOrder = sortOrder;
            }
            if (this.openTotalTagParams) {
                paramArr = paramArr.concat();
            }
            if(Object.keys(this.tempEditObj).length > 0 && this.isTempEdit) {
                this.dataRows = [];
                Object.values(this.tempEditObj).forEach((item) => {
                    this.dataRows.unshift(item);
                })
                this.dataRows = Array.from(new Set(this.dataRows));
                this.currentPageDataObj = {};
                this.dataRows.forEach((item, index) => {
                    this.currentPageDataObj[index] = item;
                });
                return;
            }
            let equilibriumStr = "";
            equilibriumStr = JSON.stringify(this.equilibriumData || {});
            return new Promise(resolve => {
                this.spcpFormAxios.post(this.api.plCommonmethod.findDataAndDetailsNewTwo,
                    {
                        formId: this.formId,
                        listViewId: this.listViewId,
                        conditionId: this.conditionId,
                        queryParams: JSON.stringify(paramArr),
                        currentPage: this.currentPage,
                        rows: this.pageSize,
                        order: this.hasSortOrder,
                        equilibriumData: equilibriumStr
                    }).then(res => {
                    if (res && res.data) {
                        // console.log(res.data);
                        loading && loading.close();
                        this.relationMap = res.data.relations;
                        this.isUpZindex = false;
                        this.cacheFormatVal = {};
                        let rows;
                        if (this.currentPage) {
                            rows = (res.data.datas || {}).records || [];
                        } else {
                            rows  = res.data.datas || [];
                        }
                        // let newRows = rows;
                        let newRows = [];
                        rows.forEach(item=>{
                            let newObj =new Object();
                            Object.keys(item).forEach(key=>{
                                let number = key.lastIndexOf("_");
                                let lastName='';
                                let beforName ='';
                                if (number!==-1){
                                    beforName = key.slice(0,number);
                                    lastName = key.slice(number+1,key.length);
                                }
                                let oldLast = this.relationMap[lastName]?this.relationMap[lastName]:'';
                                let newKey = beforName +"_"+ oldLast;
                                newObj[newKey] = item[key];
                            })
                            newRows.push(newObj);
                        })
                        if (this.currentPage) {
                            res.data.datas.records = newRows;
                            let dataObj = res.data.datas;
                            this.dataRows = (dataObj || {}).records || [];
                            this.total = (dataObj || {}).total;
                        } else {
                            res.data.datas = newRows;
                            let dataObj = res.data.datas;
                            this.dataRows = dataObj || [];
                        }
                        let sysFieldArr = ["ID", "CREATED", "CREATE_ORG", "CREATE_POS", "CREATE_TIME",
                            "UPDATED", "UPDATE_TIME", "STATUS", "RELATION_ID", "OTHER_ITEM"];
                        // 生成details数据
                        this.currentPageDataObj = {}; // 获取当前列页的值
                        this.dataRows.forEach((item, index) => {
                            this.isShowRedact[index] = true;   //编辑框是否显示
                            this.isShowSaveBtn[index] = false; //保存框是否显示

                            let dataMap = {};
                            this.currentPageDataObj[index] = dataMap;
                            Object.keys(item).forEach(key => {
                                // let lastName = key.split("_")[key.split("_").length-1];
                                // let oldLast = this.relationMap[lastName];
                                // let newKey = key.split("_")[0]+"_"+oldLast;
                                //let fieldName = key.split("_" + this.formId)[0];
                                let fieldName = '';
                                if (key.indexOf(this.formDefineKey) > -1) {
                                    fieldName = key.split("_" + this.formDefineKey)[0];
                                } else if (this.multiFormId && key.indexOf(this.multiFormId) > -1) {
                                    fieldName = key.split("_" + this.multiFormId)[0];
                                }
                                if (sysFieldArr.indexOf(fieldName) > -1) {
                                    dataMap[fieldName] = item[key];
                                } else {
                                    dataMap[this.fieldNameMap[fieldName]] = item[key];
                                }
                            })
                            //选中数据


                        });
                        this.loadReqAfterComps();
                        this.setOptColumnLength();

                    }
                    if (this.isEjectTable == '1') {
                        this.loadSuccess = true;
                    }
                    // 选中数据
                    if (this.checkIdArr && this.checkIdArr.length > 0) {
                        this.checkTableDatas();
                    }
                    if(this.isTempEdit && Object.values(this.currentPageDataObj).length > 0) {
                        this.tempEditObj = {};
                        (Object.values(this.currentPageDataObj) || []).forEach(item => {
                            this.$set(this.parentOptFormData,'tempEdit_' + item['ID'], item);
                            this.$set(this.tempEditObj,'tempEdit_' + item['ID'], item);
                        });
                    }
                    // (data.records || []).forEach(function (elem) {
                    //     for(let posUser of vm.checkedUser){
                    //         if(elem["id"] == posUser["id"]){
                    //             arr.push(elem);
                    //             break;
                    //         }
                    //     }
                    // });


                    let resultArr = this.dataRows.filter(item => {
                        //著作权和专利证书
                        let rowId = item["ID_" + this.formDefineKey];
                        if (this.allCheckedArr.indexOf(rowId) > -1) { //著作权和专利证书
                            //当前行选中
                            return item;
                        }
                    });
                    this.$nextTick(() => {
                        resultArr.forEach(data => {
                            this.$refs['listViewPreViewRef'].toggleRowSelection(data, true);
                        })
                    })

                    this.checkEjectSelectionRows(); // 选中弹出数据表已选择数据

                    this.searchCallback && this.searchCallback(res.data, this);

                    //获取当前默认选中

                    resolve();
                });
                if (!this.viewDefinData.isShowCard) {
                    this.viewDefinData.isShowCard = '0'; //给显示模式默认值
                    this.viewDefinData.isLineRedact = '0'; //行不可编辑
                }
                if (this.viewDefinData.isShowCard == '1') {  //卡片模式分页
                    this.pageSizes = [9, 30, 60, 90];
                }
                this.listFields = this.listModel.listFields;  // 获取多级联配置
                // let vm = this;
                // //查询字段配置
                // // console.log('this.tableViewData', this.tableViewData);
                // this.FORM_GLOBAL.getControlConfig(this.tableViewData.id, this.loginUser.userType).then(resData => {
                //     console.log("resData = ", resData);
                //     (resData || []).forEach(item => {
                //         vm.$set(vm.showContentField, item.fieldId, item);
                //         vm.$set(vm.showFieldType, item.fieldId, item.controlType);
                //         try {
                //             vm.$set(vm.timeSpecialSet, item.fieldId, JSON.parse(item.specialSet));
                //         } catch (e) {
                //             vm.$set(vm.timeSpecialSet, item.fieldId, item.specialSet);
                //         }
                //     });
                //     resolve();
                // });

            })
        },

        /**
         * 清空
         */
        clearSearchBox() {
            this.isUpZindex = true;
            const loading = this.$loading({
                target: this.$refs["listViewPreViewRef"].$el,
                lock: true,
                text: '正在加载，请稍后....',
                spinner: 'el-icon-loading',
                background: 'rgba(0, 0, 0, 0.7)'
            });
            this.dealEjectSelectCache();
            //是否需要分页
            if (!this.isShowPage()) {
                this.currentPage = 0;
            } else {
                this.currentPage = 1;
            }
            this.initSearchForm();
            this.getDataRows(loading, this.hasSortOrder);
            // loading.close();
        },


        /**
         * 获取登陆用户信息
         */
        getLoginData() {
            this.loginUser = this.CACHE_GLOBAL.getLoginUser();//当前用户
            if(!this.loginUser.id){
                this.loginUser = this.FORM_USER_GLOBAL.getLoginUser();
            }
            this.loginDept = this.CACHE_GLOBAL.getLoginDept(); //当前组织
        },

        /**
         * 处理搜索框查询参数
         */
        dealSearchParam() {
            let paramArr = [];
            this.searchBoxArr.forEach(searchBoxObj => {
                let value = this.searchForm[searchBoxObj.id] || "";
                if (!value) {
                    return;
                }
                let controlType = searchBoxObj.controlType;
                let key = searchBoxObj.fieldId;
                let searchType = searchBoxObj.searchType;
                //自定义
                if (searchBoxObj.sfDiy == "1") {
                    controlType = "diy";
                    //操作符
                    let diySql = JSON.parse(searchBoxObj.extend).diySql;
                    if (value && value.length > 0) {
                        if (searchBoxObj.multiple == '1' && searchType == 'in') {//多选条件需要走特殊的方法
                            let valueArrStr = "";
                            value.forEach(data => {//in条件下参数需要引号
                                valueArrStr = valueArrStr + "'" + data + "'" + ',';
                            })
                            value = this.platStringUtil.replaceAll(diySql, "-" + key, "(" + valueArrStr.substring(0, valueArrStr.length - 1) + ")");
                        } else {
                            value = this.platStringUtil.replaceAll(diySql, "-" + key, "'" + value + "'");
                        }
                        let paramObj = {controlType: controlType, key: key, operate: searchType, value: value};
                        paramArr.push(paramObj);
                    }

                } else if (controlType == "cascadeSelect") { //级联下拉框
                    Object.keys(value).forEach(field => {
                        if (value[field]) {
                            let paramObj = {
                                controlType: controlType,
                                key: field,
                                operate: searchType,
                                value: value[field]
                            };
                            paramArr.push(paramObj);
                        }
                    });
                    //数字区间
                } else if (controlType == "inputInterval") {
                    let searchTypeArr = searchType.split(",");
                    //开始数字
                    if (value["start"]) {
                        let paramStart = {
                            controlType: controlType,
                            key: key,
                            operate: searchTypeArr[0],
                            value: value["start"]
                        };
                        paramArr.push(paramStart);
                    }
                    //结束数字
                    if (value["end"]) {
                        let paramEnd = {
                            controlType: controlType,
                            key: key,
                            operate: searchTypeArr[1],
                            value: value["end"]
                        };
                        paramArr.push(paramEnd);
                    }
                } else if (controlType == "time") {
                    //时间区间
                    if (searchBoxObj.dateRange == "1") {
                        let searchTypeArr = searchType.split(",");
                        if (value[0]) {//开始时间
                            let paramStart = {
                                controlType: controlType,
                                key: key,
                                operate: searchTypeArr[0],
                                value: value[0]
                            };
                            paramArr.push(paramStart);
                        }
                        if (value[1]) {//结束时间
                            let paramEnd = {
                                controlType: controlType,
                                key: key,
                                operate: searchTypeArr[1],
                                value: value[1]
                            };
                            paramArr.push(paramEnd);
                        }
                    } else {
                        let paramObj = {controlType: controlType, key: key, operate: searchType, value: value};
                        paramArr.push(paramObj);
                    }
                } else if (controlType == "select") {
                    //操作符
                    let operaType = searchType;
                    //若多选,循环值
                    if (searchBoxObj.multiple == '1') {
                        if (value && value.length > 0) {
                            if (operaType == 'in') {//多选条件需要走特殊的方法
                                let checkAlls = {
                                    controlType: controlType,
                                    key: key,
                                    operate: operaType,
                                    value: value.join(',')
                                };
                                paramArr.push(checkAlls);
                            } else {
                                value.forEach(item => {
                                    let paramObj = {
                                        controlType: controlType,
                                        key: key,
                                        operate: operaType,
                                        value: item
                                    };
                                    if (searchBoxObj.dataOrigin == "remote") {
                                        paramObj["value"] = item[item.length - 1]
                                    }
                                    paramArr.push(paramObj);
                                });
                            }
                        }
                    } else {
                        let paramObj = {controlType: controlType, key: key, operate: operaType, value: value};
                        if (searchBoxObj.dataOrigin == "remote") {
                            if (typeof value == 'string') {
                                paramObj["value"] = value;
                            } else {
                                paramObj["value"] = value[value.length - 1];
                            }

                        }
                        paramArr.push(paramObj);
                    }
                } else if (controlType == "groupCondition") {
                    let groupValue = value;
                    if (searchBoxObj.multiple == "1") {
                        groupValue = groupValue.join(",");
                    }
                    if (groupValue) {
                        let paramObj = {
                            controlType: controlType,
                            key: searchBoxObj.id,
                            operate: "=",
                            value: groupValue
                        };
                        paramArr.push(paramObj);
                    }
                } else if (controlType === "cascadeSelectOne" && value.length > 0 && value.every(item => item)) {
                    let paramObj = {
                        controlType: controlType,
                        key: key,
                        operate: searchType,
                        value: value.join(",")
                    };
                    paramArr.push(paramObj);
                }

                if (controlType != "cascadeSelect" && controlType != "inputInterval" && controlType != "time"
                    && controlType != "select" && controlType != "diy" && controlType != "groupCondition" && controlType !== "cascadeSelectOne") {
                    let paramObj = {controlType: controlType, key: key, operate: searchType, value: value};
                    paramArr.push(paramObj);
                }
            });

            //如果当前点击了树定义
            if (this.treeClickNode.id && this.treeClickNode.id != 'all') {
                this.getTreeParam(paramArr, this.treeClickNode);
            }
            return paramArr;
        },

        /**
         * 获取树定义拼接的条件
         * @param paramArr
         * @param node
         */
        getTreeParam(paramArr, node) {
            let field = node.field;
            let value = node.value;
            let fieldId = "";
            let showFieldIdArr = Object.keys(this.showFieldObj);
            showFieldIdArr.some(key => {
                let fieldObj = this.showFieldObj[key];
                //if(field == fieldObj.fieldName +"_" +fieldObj.formDefineKey){
                if (field == fieldObj.fieldName + "_" + fieldObj.formId) {
                    fieldId = key;
                    return false;
                }
            });
            if (value.indexOf("combo") > -1) { //来源于数据字典
                value = value.split(":")[2];
            }
            let paramObj = {controlType: "input", key: fieldId, operate: "=", value: value};
            paramArr.push(paramObj);
            if (node.parentId != 'all' && node.parentId != '-1') {
                let parentNode = this.$refs.tree.getNode(node.parentId);
                return this.getTreeParam(paramArr, parentNode.data);
            } else {
                return paramArr;
            }
        },


        /**
         * 获取时间格式
         */
        getDataPickerType(data) {
            /*let type = 'timePicker';
            if(data.dateRange == '0'){
                type = this.dataPickerType[data.datePattern] || 'timePicker';
            }else{
                type = this.dataPickerRangeType[data.datePattern] || 'timePicker';
            }*/
            data.type = this.dataPickerType[data.datePattern] || 'timePicker';
        },

        /**
         * 设置样式
         * @returns {string}
         */
        getTableStyle() {
            let style = "";
            if (this.isEditTable == '1' || this.isViewTable == '1') {
                let headButLength = (this.editTableButton.head || []).length;
                if (!this.isEditData) {
                    headButLength = 0;
                }
                if (headButLength > 0 && this.isNeedPage == '1') {
                    style = "height:calc(100% - 110px);padding:0;";
                } else if (headButLength > 0 && this.isNeedPage == '0') {
                    style = "height:calc(100% - 50px);padding:0;";
                } else if (headButLength == 0 && this.isNeedPage == '1') {
                    style = "height:calc(100% - 60px);padding:0;";
                } else {
                    style = "height:100%;padding:0;";
                }
                if (this.autoOpenHeight) {
                    style = "min-height:" + this.minHeight + ";padding:0;"; //开启自动撑开高度，（最小高度为200）
                }
            } else {
                let headButLength = Object.keys(this.headButtonObj).length || 0;
                if (headButLength > 0 && this.viewDefinData.pagination == '1') {
                    style = "height:calc(100% - 102px);padding:0;";
                } else if (headButLength > 0 && this.viewDefinData.pagination == '0') {
                    style = "height:calc(100% - 42px);padding:0;";
                } else if (headButLength == 0 && this.viewDefinData.pagination == '1') {
                    if (Number(this.viewDefinData.isOpenTotal) || Number(this.viewDefinData.isDiyColumns)) {
                        style = "height:calc(100% - 102px);padding:0;";
                    } else {
                        style = "height:calc(100% - 60px);padding:0;";
                    }
                } else if (headButLength == 0 && this.viewDefinData.pagination == '0') {
                    if (Number(this.viewDefinData.isOpenTotal) || Number(this.viewDefinData.isDiyColumns)) {
                        style = "height:calc(100% - 42px);padding:0;";
                    } else {
                        style = "height:100%;padding:0;";
                    }
                } else {
                    style = "height:100%;padding:0;";
                }
            }
            return style;
        },
        /**
         * 卡片模式每页数据个数变更
         * @param val
         */
        handleSizeChangeCard(val) {
            const loading = this.$loading({
                lock: true,
                text: '正在加载，请稍后....',
                spinner: 'el-icon-loading',
                background: 'rgba(0, 0, 0, 0.7)'
            });
            this.pageSize = val;
            this.getDataRows();
            loading.close();
        },

        /**
         * 卡片模式当前页变更
         * @param val
         */
        handleCurrentChangeCard(val) {
            const loading = this.$loading({
                lock: true,
                text: '正在加载，请稍后....',
                spinner: 'el-icon-loading',
                background: 'rgba(0, 0, 0, 0.7)'
            });
            this.currentPage = val;
            this.getDataRows();
            loading.close();
        },

        /**
         * 每页数据个数变更
         * @param val
         */
        async handleSizeChange(val) {
            const loading = this.$loading({
                target: this.$refs["listViewPreViewRef"].$el,
                lock: true,
                text: '正在加载，请稍后....',
                spinner: 'el-icon-loading',
                background: 'rgba(0, 0, 0, 0.7)'
            });
            this.pageSize = val;
            await this.getDataRows();
            // this.setOptColumnLength();
            loading.close();
        },

        /**
         * 当前页变更
         * @param val
         */
        async handleCurrentChange(val) {
            const loading = this.$loading({
                target: this.$refs["listViewPreViewRef"].$el,
                lock: true,
                text: '正在加载，请稍后....',
                spinner: 'el-icon-loading',
                background: 'rgba(0, 0, 0, 0.7)'
            });
            this.currentPage = val;

            this.dealEjectSelectCache(); // 处理选择行缓存

            await this.getDataRows();
            // this.setOptColumnLength();
            loading.close();
        },
        // 处理弹出数据表行数据的缓存
        dealEjectSelectCache() {
            if (this.isEjectTableShowSelect) {
                let selection = this.$refs.listViewPreViewRef.selection || [];
                selection.forEach(item => {
                    this.ejectSelectChooseRowIds.add(item["ID_" + this.formDefineKey]); // 在分页变化时将所在行置入到选择项中
                })
            }
        },
        /**
         * 选中弹出数据表已选择项
         */
        checkEjectSelectionRows() {
            if (this.isEjectTableShowSelect) {
                let resultArr = this.dataRows.filter(item => {
                    let rowId = item["ID_" + this.formDefineKey];
                    if (this.ejectSelectChooseRowIds.has(rowId)) {
                        //当前行选中
                        return item;
                    }
                });
                this.$nextTick(() => {
                    resultArr.forEach(data => {
                        this.$refs['listViewPreViewRef'].toggleRowSelection(data, true);
                    })
                })
            }
        },

        /**
         * 列格式化方法-card
         */
        formatterColumnCard(row, column, index) {
            let showField = this.showFieldArr[column];
            this.fieldColumn[showField.fieldId] = column;
            let allFieldVal = [];//合并列
            //值
            let result = row[showField.fieldName + "_" + showField.formId];
            //let result = row[showField.fieldName];
            //合并列
            if (showField.combine == '1' && showField.combineType == '1' && showField.allFieldIdArr) {
                result = "";
                showField.allFieldIdArr.forEach((fieldId, idIndex) => {
                    let fieldObj = this.showFieldObj[fieldId];
                    if (row[fieldObj.fieldName + '_' + fieldObj.formId]) {
                        result += " " + row[fieldObj.fieldName + '_' + fieldObj.formId];
                        allFieldVal.push(row[fieldObj.fieldName + '_' + fieldObj.formId])
                    }
                });
                result = result.substring(1);
            }

            if (Number(showField.dataCode)) { // 是元数据，开始转换

                let templateValue = row[showField.fieldName + "_" + showField.formId];
                let templateArr = [];
                let valueArr = [];
                if (allFieldVal.length > 0) {//合并列
                    allFieldVal.forEach(value => {
                        if (!this.sysDataObj[value]) {
                            valueArr.push(value);
                        } else {
                            valueArr.push((this.sysDataObj[value] || {}).dataName);
                        }
                    });
                    result = valueArr.join("-");
                } else {
                    if (templateValue) {
                        if (templateValue.indexOf(",") > -1) {
                            templateArr = templateValue.split(",");
                        } else {
                            templateArr.push(templateValue);
                        }
                    }
                    templateArr.forEach(value => {
                        if (!this.sysDataObj[value]) {
                            valueArr.push(value);
                        } else {
                            valueArr.push((this.sysDataObj[value] || {}).dataName);
                        }
                    });
                    result = valueArr.join("-");
                }
            }

            //列格式化-自定义
            let formatObj = this.columnFormatObj[showField.fieldId] || {};

            if (formatObj && formatObj.formatType && Number(formatObj.formatType)) {
                let val = row[showField.fieldName + "_" + showField.formId];
                //let val = row[showField.fieldName];
                let labelName = showField.showName;
                result = this.executeSysColumnFormat(formatObj, val, index, labelName);
            }

            if (result) {
                if (result.data) {
                    return result.data.domProps.innerHTML;
                } else {
                    return result;
                }
            }
        },
        /**
         * 获取当前数月或者后数月
         */
        getPreOrNextMonth(type, monthNum, fmt) {
            let date = new Date();
            let year = date.getFullYear();//年
            let month = date.getMonth() + 1;//月
            let day = date.getDate(); //日
            let t2 = "";
            let monthNow = "";
            if (type == 'pre') {
                monthNow = month - parseInt(monthNum);
                if (monthNow >= 1 && monthNow <= 9) {
                    monthNow = "0" + monthNow;
                } else if (monthNow <= 0) {
                    monthNow = 12 + monthNow;
                    year = year - 1;
                }
            } else if (type == 'next') {
                monthNow = month + parseInt(monthNum);
                if (monthNow >= 1 && monthNow <= 9) {
                    monthNow = "0" + monthNow;
                } else if (monthNow >= 12) {
                    monthNow = monthNow - 12;
                    year = year + 1;
                }
            }
            if (day >= 1 && day <= 9) {
                day = "0" + day;
            }
            //获取目标月分的天数
            let tMonth = new Date(year, month, 0);
            let tDay = tMonth.getDate();
            if (parseInt(day) > tDay) {
                day = tDay;
            }
            t2 = year + '-' + monthNow + '-' + day;
            let houres = this.viewDateFormat(new Date(), 'HH:mm:ss');
            t2 += " " + houres;
            this.viewDateFormat(new Date(t2), fmt);
            return t2;
        },
        /*
        * 取消按钮
        * */
        closeBtn(row, rowIndex) {
            if (!this.isSaveUpdate) {//新增
                this.switchTable = false;//切换表单
                this.isSaveUpdate = true;//切换新增状态
                //删除
                this.dataRows.splice(rowIndex, 1);
                let vm = this;
                this.dataRows.forEach((item, index) => {
                    this.currentPageDataObj[index] = this.currentPageDataObj[index + 1];
                })
                vm.$delete(this.currentPageDataObj, this.dataRows.length);
                this.isShowSaveBtn.splice(rowIndex, 1);
                this.isShowRedact.splice(rowIndex, 1);
                return;
            }
            this.isShowTableTest = false;//控制表格显示  刷新显示
            this.isShowSaveBtn[rowIndex] = !this.isShowSaveBtn[rowIndex]; //更改保存按钮显示
            this.isShowRedact[rowIndex] = !this.isShowRedact[rowIndex];//更改编辑框以及按钮显示
            this.setGetfunction(this.dataRows[rowIndex], JSON.parse(JSON.stringify(this.refreshMoudel || {})));
            this.switchTable = false;//切换表单
            this.updateIndex = -1;
            let height = this.$refs["listViewPreViewRef2"].bodyWrapper.scrollTop;
            this.$nextTick(() => {//刷新表格
                this.isShowTableTest = true;
            })
            let vm = this;
            setTimeout(
                function () {
                    vm.$refs["listViewPreViewRef"].bodyWrapper.scrollTop = height;
                }, 10)
        },
        setGetfunction(target, obj) {
            Object.keys(obj).forEach(key => {
                this.$set(target, key, obj[key]);
            })
        },
        /*
        * 保存按钮事件
        * */
        saveBtn(row, rowIndex) {
            this.isShowTableTest = false;//控制表格显示  刷新显示
            let vm = this;
            let fieldArr = this.showFieldArr; //显示的列
            let value = [];            //列的值
            let formId = this.formId;  //视图id
            let contentForm = {};      //参数
            let DataObject = this.currentPageDataObj[rowIndex] //获取当前列页的值
            let required = this.showContentField;//字段配置
            if (this.relationId) {
                vm.$set(contentForm, "RELATION_ID", this.relationId);
            }
            fieldArr.forEach((item, index) => {
                let showListFields = this.listFields[index] || [];

                //获取多级联val
                if (this.showContentField[showListFields.fieldId + ',' + showListFields.combineCols]
                    && this.showContentField[showListFields.fieldId + ',' + showListFields.combineCols].controlType === 'cascadeSelect') {
                    item.allFieldIdArr.forEach(it => {
                        value[it] = DataObject[it]; //根据字段名和formId  取显示列的值
                        vm.$set(contentForm, it, value[it]);    //给参数对象添加参数
                    })

                    //获取单级联val
                } else if (this.showContentField[item.fieldId] && this.showContentField[item.fieldId].controlType === 'cascadeSelectOne') {

                    let fieldId = this.showContentField[item.fieldId].fieldId;
                    value[index] = DataObject[fieldId]; //根据formId  取显示列的值
                    vm.$set(contentForm, item.fieldId, value[index].toString());    //给参数对象添加参数

                    //获取复选框val
                } else if (this.showFieldType[item.fieldId] === 'checkbox') {//复选框

                    value[index] = this.checkboxValue[item.fieldId];
                    if (value[index] != null && value[index] != "") {
                        vm.$set(contentForm, item.fieldId, value[index].toString());    //给参数对象添加参数
                    } else {
                        vm.$set(contentForm, item.fieldId, "");    //给参数对象添加参数
                    }

                    //获取联系方val
                } else if (this.showFieldType[item.fieldId] === 'contactParty') {//联系方
                    value[index] = DataObject[item.fieldId];
                    if (value[index] != null && value[index] != "") {
                        vm.$set(contentForm, item.fieldId, value[index].toString());    //给参数对象添加参数
                        vm.$set(contentForm, "OTHER_ITEM", DataObject.OTHER_ITEM);
                    } else {
                        vm.$set(contentForm, item.fieldId, "");    //给参数对象添加参数
                    }
                    //获取组织、树岗位树val
                } else if (this.showContentField[item.fieldId] && this.showFieldType[item.fieldId] === 'userSelect'
                    && (this.timeSpecialSet[item.fieldId].selectType === 'orgTree' ||
                        this.timeSpecialSet[item.fieldId].selectType === 'posTree')) {//组织树
                    let fieldId = this.showContentField[item.fieldId].fieldId;
                    value[index] = DataObject[fieldId]; //根据formId  取显示列的值
                    vm.$set(contentForm, item.fieldId, value[index]);    //给参数对象添加参数

                } else {
                    if(row.hasOwnProperty(item.fieldName + "_" + formId)){
                        value[index] = row[item.fieldName + "_" + formId]; //根据字段名和formId  取显示列的值
                    }
                    if(row.hasOwnProperty(item.fieldId) &&　row[item.fieldId]){
                        value[index] = row[item.fieldId]; //根据字段名和formId  取显示列的值
                    }
                    if (value[index] == null) {
                        value[index] = "";
                    }
                    vm.$set(contentForm, item.fieldId, value[index].toString());    //给参数对象添加参数
                }

            })
            for (let i = 0; i < fieldArr.length; i++) {
                //是否是必填
                if (required[fieldArr[i].fieldId] && required[fieldArr[i].fieldId].isRequired == 1 && contentForm[fieldArr[i].fieldId] == "") {
                    let msg = fieldArr[i].showName + "不能为空!";
                    this.$message({message: msg});
                    this.isShowTableTest = true;
                    return;
                }

                //验证规则
                let obj = this.showContentField[fieldArr[i].fieldId];
                let number = this.timeSpecialSet[fieldArr[i].fieldId];
                if (obj && obj.controlType != "cascadeSelect" && obj.controlType != "cascadeSelectOne" && obj.controlType != "cascadeSelectOne" && obj.controlType != "contactParty" && obj.controlType != "userSelect") {
                    let flag = false;
                    let error = "";
                    let value = contentForm[fieldArr[i].fieldId];//控件值

                    //验证input、textarea长度
                    if (obj.editable != "false" && (obj.controlType == 'input' || obj.controlType == 'textarea')) {
                        let fieldInfo = this.formFieldObj[obj.fieldId] || {};
                        if (fieldInfo.fieldLength && Number(fieldInfo.fieldLength)) {
                            let verFalg = this.checkValueLength(fieldInfo.fieldLength, null, value, null, flag, error, fieldArr[i].showName);
                            if (!verFalg) {
                                this.isShowTableTest = true;
                                return;
                            }
                        }
                    }

                    let validFunChArr = obj.validRules.split(',') || [];
                    if (validFunChArr.length > 0 && validFunChArr != "") {//字段验证规则不为空时执行
                        let otherParam = {min: number.minNumValue, max: number.maxNumValue, regExp: obj["diyValidVal"]};//数字区间，自定义规则
                        let verFalg = this.mulOrValidator(validFunChArr, otherParam, null, value, null, flag, error, fieldArr[i].showName);//验证规则
                        if (!verFalg) {
                            this.isShowTableTest = true;
                            return;
                        }
                    }
                }
            }

            let url, paramObj;
            if (this.updateFormdataBeforeSave) {
                contentForm = Object.assign(contentForm, this.updateFormdataBeforeSave);
            }
            if (!this.isSaveUpdate && this.currentPageDataObj[rowIndex].ID != "") {//新增
                url = vm.api.plCommonmethod.insert;
                paramObj = {formId: this.formId, params: JSON.stringify(contentForm)};

            } else {//修改
                url = this.api.plCommonmethod.updateById;
                paramObj = {
                    formId: this.formId,
                    dataId: this.currentPageDataObj[rowIndex].ID,
                    updateParams: JSON.stringify(contentForm)
                };
            }

            //发送请求
            //执行提交前的代码
            let rowObj = row;
            /*if(this.currentPageDataObj[rowIndex].hasOwnProperty("ID")){
                 this.$set(rowObj,"ID",this.currentPageDataObj[rowIndex].ID);
             }*/
            let scriptReult = true;
            let paramArr = [rowObj, "", this, this.spcpFormAxios, AjaxUtil];
            // this.scriptDataArr.forEach(scriptData => { //提交前脚本执行
            //     let result = this.execBeforeScripts(scriptData, 'save', 'Submit', paramArr); //执行提交前脚本
            //     if (!result.retOp) {
            //         scriptReult = true;
            //     } else {
            //         scriptReult = result.retOp;
            //         if (result.retAll) {
            //             scriptReult = scriptReult && result.retAll;
            //         }
            //     }
            // });
            for (let ii = 0; ii < this.scriptDataArr.length; ii++){
                let result = this.execBeforeScripts( this.scriptDataArr[ii], 'save', 'Submit', paramArr); //执行提交前脚本
                if (!result.retOp) {
                    scriptReult = true;
                    if(result.retAll == false && (typeof result.retAll == "boolean")){
                        this.isShowTableTest = true;
                        return;
                    }
                } else {
                    scriptReult = result.retOp;
                    if (result.retAll) {
                        scriptReult = scriptReult && result.retAll;
                    }
                }
            }
            this.isShowSaveBtn[rowIndex] = !this.isShowSaveBtn[rowIndex]; //更改保存按钮显示
            this.isShowRedact[rowIndex] = !this.isShowRedact[rowIndex];//更改编辑框以及按钮显示
            this.switchTable = false;//切换表单
            this.updateIndex = -1;
            if (scriptReult) { //提交前脚本执行成功
                this.spcpFormAxios.post(url, paramObj).then(res => {
                    if (res && res.data) {
                        let type = "success";
                        let msg = "保存成功！";
                        if (!res.data.operateSuccess) {
                            type = "danger";
                            msg = "保存失败！";
                        }
                        //执行保存后脚本
                        let paramData = [rowObj, "", this, this.spcpFormAxios, AjaxUtil];
                        this.scriptDataArr.forEach(scriptData => { //提交前脚本执行
                            this.execAfterScripts(scriptData, 'save', 'Submit', paramData);
                        });
                        if (!this.isSaveUpdate && type == "success") {
                            this.isSaveUpdate = true;//状态切换为可新增
                        }
                        this.$message({message: msg, type: type});
                        this.getDataRows();//重新获取数据
                    }
                });

                let height = this.$refs["listViewPreViewRef2"].bodyWrapper.scrollTop;
                this.$nextTick(() => {//刷新表格
                    this.isShowTableTest = true;
                })
                setTimeout(
                    function () {
                        vm.$refs["listViewPreViewRef"].bodyWrapper.scrollTop = height;
                    }, 10)
            }
        },
        /**
         * 长度校验
         */
        checkValueLength(len, rule, value, callback, flag, error, showName) {
            if (!value) {
                flag = true;
                return flag;
            }
            value = value.toString();
            if (value.length <= len) {
                flag = true;
            } else {
                error = showName + '字段长度必须小于等于' + len + "个字符";
                this.$message({message: error});
                flag = false;
            }
            return flag;
        },
        /**
         * 多个验证规则或则的关系
         * @param valiType
         * @param rule
         * @param value
         * @param callback
         */
        mulOrValidator(valiTypeArr, otherParam, rule, value, callback, flag, error, showName) {

            if (!value || !valiTypeArr) {
                flag = true;
                return flag;
            } else {
                let rightWord = false;
                valiTypeArr.forEach(valiType => {
                    //数字
                    if (!flag && valiType == "checkNumber") {
                        error += "、数字";
                        // flag = /^\+?(0|([1-9]\d*))(\.\d+)?$/g.test(value);
                        flag = /^(\-|\+)?\d+(\.\d+)?$/.test(value);
                    }
                    //正整数或0
                    if (!flag && valiType == "positiveInt") {
                        error += "、正整数或0";
                        flag = /^\+?(0|[1-9][0-9]*)$/.test(value);
                    }
                    //正整数
                    if (!flag && valiType == "checkPositiveIntNotZero") {
                        error += "、正整数";
                        flag = /^\+?([1-9][0-9]*)$/.test(value);
                    }
                    //字母
                    if (!flag && valiType == "alpha") {
                        error += "、字母";
                        flag = /^[a-zA-Z]*$/.test(value);
                    }
                    //汉字
                    if (!flag && valiType == "chs") {
                        error += "、汉字";
                        flag = /^[\u0391-\uFFE5]+$/.test(value);
                    }
                    //电话
                    if (!flag && valiType == "phone") {
                        error += "、电话";
                        rightWord = true;
                        flag = /^((0[0-9]{2,3})\-)+(\d{7,8})$/.test(value);
                    }
                    //手机
                    if (!flag && valiType == "mobile") {
                        error += "、手机号码";
                        rightWord = true;
                        flag = /^((\(\d{2,3}\))|(\d{3}\-))?1\d{10}$/.test(value);
                    }
                    //传真
                    if (!flag && valiType == "fax") {
                        error += "、传真";
                        rightWord = true;
                        flag = /^(0?\d{2,3}\-)?[1-9]\d{6,7}(\-\d{1,4})?$/.test(value);
                    }
                    //密码
                    if (!flag && valiType == "safepass") {
                        error += "、密码（由字母、数字和符号组成，至少6位）";
                        flag = /^(?=[~!@#$%^&*\-+=_.0-9a-zA-Z]*[~!@#$%^&*\-+=_.])(?=[~!@#$%^&*\-+=_.0-9a-zA-Z]*[0-9])(?=[~!@#$%^&*\-+=_.0-9a-zA-Z]*[a-zA-Z])[~!@#$%^&*\-+=_.0-9a-zA-Z]{6,}$/.test(value);
                    }
                    //电子邮箱
                    if (!flag && valiType == "checkEmail") {
                        error += "、电子邮箱";
                        rightWord = true;
                        flag = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/.test(value);
                    }
                    //身份证
                    if (!flag && valiType == "idcard") {
                        error += "、身份证";
                        rightWord = true;
                        flag = /^\d{17}(\d|x)$/i.test(value);
                        if (flag) {
                            value = value.replace(/x$/i, "a");
                            flag = platValidator.aCity[parseInt(value.substr(0, 2))] != null;
                            if (flag) {
                                let sBirthday = value.substr(6, 4) + "-" + Number(value.substr(10, 2)) + "-" + Number(value.substr(12, 2));
                                let d = new Date(sBirthday.replace(/-/g, "/"));
                                flag = (sBirthday == (d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate()));
                                if (flag) {
                                    let iSum = 0;
                                    for (let i = 17; i >= 0; i--) {
                                        iSum += (Math.pow(2, i) % 11) * parseInt(value.charAt(17 - i), 11);
                                    }
                                    flag = (iSum % 11 == 1);
                                }
                            }
                        }
                    }
                    //登录名
                    if (!flag && valiType == "loginName") {
                        error += "、登录名（只允许汉字、英文字母、数字及下划线）";
                        flag = /^[\u0391-\uFFE5\w]+$/.test(value);
                    }
                    //邮政编码
                    if (!flag && valiType == "zip") {
                        error += "、邮政编码";
                        rightWord = true;
                        flag = /^[1-9]\d{5}$/.test(value);
                    }
                    //数字区间验证
                    if (!flag && valiType == "digitalInterval") {
                        const $min = Number(otherParam.min);
                        const $max = Number(otherParam.max);
                        const $value = Number(value);
                        error += "、值，必须在" + $min + "与" + $max + "之间";
                        if ($value >= $min && $value <= $max) {
                            flag = true;
                        } else {
                            flag = false;
                        }
                    }
                    //自定义
                    if (!flag && valiType == "diy") {
                        error += "、值，自定义规则校验不通过";
                        const reg = new RegExp(otherParam.regExp);
                        flag = reg.test(value);
                    }
                    //数字和字母
                    if (!flag && valiType == "numAndAlpha") {
                        error += "、数字和字母";
                        flag = /[A-Za-z].*[0-9]|[0-9].*[A-Za-z]/.test(value);
                    }
                    //数字和中文
                    if (!flag && valiType == "numAndChs") {
                        error += "、数字和中文";
                        flag = /[\u0391-\uFFE5].*[0-9]|[0-9].*[\u0391-\uFFE5]/.test(value);
                    }
                    //字母和中文
                    if (!flag && valiType == "alphaAndChs") {
                        error += "、字母和中文";
                        flag = /[A-Za-z].*[\u0391-\uFFE5]|[\u0391-\uFFE5].*[A-Za-z]/.test(value);
                    }
                    //数字、字母和中文
                    if (!flag && valiType == "numAndAlphaAndChs") {
                        error += "、数字和字母以及中文";
                        const reg = /[0-9].*[A-Za-z].*[\u0391-\uFFE5]|[0-9].*[\u0391-\uFFE5].*[A-Za-z]|[A-Za-z].*[0-9].*[\u0391-\uFFE5]|[A-Za-z].*[\u0391-\uFFE5].*[0-9]|[\u0391-\uFFE5].*[0-9].*[A-Za-z]|[\u0391-\uFFE5].*[A-Za-z].*[0-9]/;
                        flag = reg.test(value);
                    }

                });
                if (!flag && error) {
                    let errorCombine = "请输入";
                    if (rightWord) {
                        errorCombine = "请输入正确的";
                    }
                    error = showName + errorCombine + error.substring(1);
                    this.$message({message: error});
                }
                return flag;
            }
        },
        /**
         * 按钮事件
         * @param butttonInfo
         */
        async buttonOpt(buttonInfo, rowData, index, isCopy) {
            let time = new Date().getTime();
            if(!isCopy){ // 复制的时候在buttonopt中又调用了buttonopt一遍，所以不返回，继续
                if(this.clickTime && (time - this.clickTime) <= 300){
                    this.clickTime = time;
                    return;
                }else{
                    this.clickTime = time;
                }
            }
            if ("delete" == buttonInfo.buttonType) {
                let selection = this.$refs.listViewPreViewRef.selection || [];
                let delteIdArr = this.getSelectionIds(selection);
                if (delteIdArr.length == 0){
                    this.buttonPush(buttonInfo.buttonType, null);
                }else{
                    delteIdArr.forEach(item=>{
                        this.buttonPush(buttonInfo.buttonType, item);
                    })
                }
            } else {
                if (rowData) {
                    this.buttonPush(buttonInfo.buttonType, rowData["ID_" + this.formDefineKey] + "");
                } else {
                    this.buttonPush(buttonInfo.buttonType, null);
                }
            }
            //按钮统计
            let loading = null;
            if (!isCopy) {
                this.isCopyOperate = false;
            }
            //编辑按钮
            if (buttonInfo.buttonType == "update") {
                //获取视图配置  是否行可编辑
                let isLineRedact = this.viewDefinData.isLineRedact;
                //可编辑
                if (isLineRedact === "1") {
                    if (!this.isSaveUpdate || this.updateIndex != "-1") {//是否在添加行  如果在添加则不可编辑其他行
                        let msg = "请先完成当前的数据添加！";
                        this.$message({message: msg});
                        loading && loading.close();
                        return;
                    }
                    this.isShowTableTest = false;//控制表格显示  刷新显示
                    this.isShowSaveBtn[index] = !this.isShowSaveBtn[index]; //更改保存按钮显示
                    this.isShowRedact[index] = false;//更改编辑框显示
                    this.switchTable = true; //切换表单
                    this.updateIndex = index;
                    this.isShowRedact.forEach((item, i) => {
                        if (i != index) {
                            this.isShowSaveBtn[i] = false;//按钮显示
                            this.isShowRedact[i] = true;//文本框显示
                        }
                    });

                    //查询复选框值
                    let vm = this;
                    let rowValue = this.currentPageDataObj[index];
                    this.showFieldArr.forEach((showField, index) => {
                        if (vm.showFieldType[showField.fieldId] === 'checkbox') {
                            let strValue = rowValue[showField.fieldId];
                            let arrVakue = strValue.split(',');
                            vm.$set(vm.checkboxValue, showField.fieldId, arrVakue);
                        }
                    })
                    this.refreshMoudel = {};//编辑时记录当前行数据
                    // let shallowMerge = (target,source)=>Object.defineProperties(target,Object.getOwnPropertyDescriptors(source));
                    // shallowMerge(this.refreshMoudel,this.dataRows[index]);
                    // console.log(1,this.refreshMoudel);
                    this.refreshMoudel = JSON.parse(JSON.stringify(this.dataRows[index]));
                    let height = this.$refs["listViewPreViewRef"].bodyWrapper.scrollTop;
                    this.$nextTick(() => {//刷新表格
                        this.isShowTableTest = true;
                    });
                    setTimeout(
                        function () {
                            vm.$refs["listViewPreViewRef2"].bodyWrapper.scrollTop = height;
                        }, 10)
                    loading && loading.close();
                    return;
                }
            }

            //新增按钮
            if (buttonInfo.buttonType == "add") {
                //获取视图配置  是否行可编辑
                let isLineRedact = this.viewDefinData.isLineRedact;
                //可编辑
                if (isLineRedact === "1") {
                    if (this.isSaveUpdate) {   //判断是否可以新增
                        this.isSaveUpdate = false; //切换为不可新增
                        this.updateIndex = -1;
                        this.isShowTableTest = false;//控制表格显示  刷新显示
                        this.switchTable = true; //切换表单
                        let fieldArr = this.showFieldArr; //显示的列
                        let value = [];//列值
                        let contentForm = {};//行对象
                        let vm = this;

                        // Object.keys(this.editParamObj).forEach(fieldId =>{
                        //     this.$set(this.optFormData,fieldId,this.editParamObj[fieldId]);
                        // });
                        //根据显示的列赋值
                        fieldArr.forEach((item, index) => {
                            if (this.showContentField[item.fieldId] && this.showContentField[item.fieldId].controlType != "cascadeSelect") {
                                let defaultValue = this.timeSpecialSet[item.fieldId];//字段配置
                                let fieldDefaultVal = this.showContentField[item.fieldId].defaultVal;
                                value[index] = "";
                                if (this.showContentField[item.fieldId] && (this.showContentField[item.fieldId].controlType == 'input' || this.showContentField[item.fieldId].controlType == 'textarea')) {
                                    if (fieldDefaultVal == "" || fieldDefaultVal == null) {
                                        value[index] = "";
                                    } else if (fieldDefaultVal == 'diy') { // input 自定义默认值

                                        let templateDefaultVal = (defaultValue || {}).defaultValText || "";
                                        if (templateDefaultVal.indexOf("${listOutParam.") > -1) {
                                            templateDefaultVal = templateDefaultVal.replace("${listOutParam.", ""); // 去除${listOutParam.
                                            templateDefaultVal = templateDefaultVal.substring(0, templateDefaultVal.length - 1); // 去除}
                                            templateDefaultVal = (this.listOutParam || {})[templateDefaultVal] || "";
                                        }

                                        value[index] = templateDefaultVal;
                                    } else if (fieldDefaultVal.indexOf('SYSTIME.time') > -1) {//系统时间默认值
                                        value[index] = this.viewDateFormat(new Date(), 'yyyy-MM-dd HH:mm:ss');
                                    } else {//默认值
                                        if (fieldDefaultVal.indexOf("loginDept") > -1) {
                                            value[index] = Replace.def(this.userDept, fieldDefaultVal) || "";
                                        } else if (fieldDefaultVal.indexOf("loginuser") > -1) {
                                            value[index] = Replace.def(this.loginUser, fieldDefaultVal) || "";
                                        }
                                    }

                                } else if (this.showContentField[item.fieldId] && this.showContentField[item.fieldId].controlType == 'time') {
                                    if (defaultValue.defaultValueType == '系统时间') {
                                        value[index] = this.viewDateFormat(new Date(), defaultValue.displayFormatter || 'yyyy-MM-dd');
                                    } else if (defaultValue.defaultValueType == '向前数月') {
                                        value[index] = this.getPreOrNextMonth('pre', defaultValue.defaultBeforeMonth, defaultValue.displayFormatter || 'yyyy-MM-dd');
                                    } else if (defaultValue.defaultValueType == '向后数月') {
                                        value[index] = this.getPreOrNextMonth('next', defaultValue.defaultAfterMonth, defaultValue.displayFormatter || 'yyyy-MM-dd');
                                    } else if (defaultValue.diyDefaultVal) {
                                        value[index] = defaultValue.diyDefaultVal;
                                    }
                                } else {//其他控件
                                    this.checkboxValue[item.fieldId] = defaultValue ? defaultValue.spdefaultVal : ""; //取默认值
                                    value[index] = defaultValue ? defaultValue.spdefaultVal : ""; //取默认值
                                }

                            }
                            vm.$set(contentForm, item.fieldName + "_" + this.formId, value[index]);    //给参数对象添加默认值参数


                            //编辑列表参数
                            if (this.editParamSet[item.fieldId]) {
                                vm.$set(contentForm, item.fieldName + "_" + this.formId, this.editParamSet[item.fieldId]);
                            }
                        });

                        //有行数据   后移一位并在第一个添加
                        if (this.dataRows.length != 0) {

                            //追加按钮以及行可编辑状态
                            let btnFalg = true;
                            let redFalg = false;
                            this.isShowSaveBtn.unshift(btnFalg);//按钮显示为保存取消
                            this.isShowRedact.unshift(redFalg);//行为可编辑
                            this.dataRows.unshift(contentForm);//在最前追加
                            let len = this.dataRows.length - 1;
                            vm.$set(this.currentPageDataObj, len, {});

                            for (let i = this.dataRows.length - 1; i > 0; i--) {
                                this.currentPageDataObj[i] = this.currentPageDataObj[i - 1];
                            }
                            vm.$set(this.currentPageDataObj, 0, {});

                            //除此行外其他行为不可编辑  按钮为编辑状态
                            this.isShowRedact.forEach((item, i) => {
                                if (i != 0) {
                                    this.isShowSaveBtn[i] = false;//按钮显示
                                    this.isShowRedact[i] = true;//文本框显示
                                }
                            })
                        } else {//无行数据  在第一个添加
                            //重新获取多级联配置
                            this.listFields = this.listModel.listFields;
                            //追加按钮以及行可编辑状态
                            let btnFalg = true;
                            let redFalg = false;
                            this.isShowSaveBtn.unshift(btnFalg);//按钮显示为保存取消
                            this.isShowRedact.unshift(redFalg);//行为可编辑
                            this.dataRows.unshift(contentForm);//在最前追加
                            vm.$set(this.currentPageDataObj, 0, {});
                        }

                        this.$nextTick(() => {//刷新表格
                            this.isShowTableTest = true;
                        })
                    } else {
                        let msg = "请先完成当前的数据添加！";
                        this.$message({message: msg});
                    }
                    loading && loading.close();
                    return;
                }

            }

            //删除按钮
            if (buttonInfo.buttonType == "delete" && this.viewDefinData.isLineRedact === "1" && !this.isSaveUpdate) {
                this.$message({message: "请先完成当前的数据添加或取消！"});
                loading && loading.close();
                return;

            }


            this.editParamObj = {};
            this.contentForm = {};
            let dataId = "";
            this.dataId = "";

            if (rowData) {
                this.dataId = rowData["ID_" + this.formDefineKey] + "";
                dataId = this.dataId;
            }
            if(rowData && this.isTempEdit && buttonType !== 'add' && !rowData["ID_" + this.formDefineKey]) {
                this.dataId = rowData['ID'] || '';
                dataId = this.dataId;
            }
            let buttonType = buttonInfo.buttonType;
            if (!this.isEmptyObject(this.oldTableViewData)) {
                this.tableViewData = JSON.parse(JSON.stringify(this.oldTableViewData));
            }
            if (buttonType == "add" || buttonType == "update" || buttonType == "view") {
                //编辑列表仅允许添加一条数据
                if (buttonType == "add") {
                    await this.isAddOnlyData();
                    if (this.onlyDataHasExist) {
                        loading && loading.close();
                        this.$message({type: 'warning', message: "仅允许添加一条数据！"});
                        return;
                    }
                    if (this.isEditTable == "1") { //编辑列表
                        this.editParamObj = JSON.parse(JSON.stringify(this.editParamSet));
                    }
                } else if (buttonType == "update" && this.isEditTable == "1" && this.optOwnData == "1" &&
                    (rowData["CREATED_" + this.formDefineKey] != this.loginUser.id)) {
                    loading && loading.close();
                    this.$message({type: 'warning', message: "仅能维护自身数据！"});
                    return;
                }
                if (buttonType == "add") {
                    this.beforeAddEvent && this.beforeAddEvent();
                }

                if (buttonType == "update") {
                    this.beforeUpdateEvent && this.beforeUpdateEvent(rowData, index);
                }

                if (buttonType == "view") {
                    this.beforeViewEvent && this.beforeViewEvent(rowData, index);
                }

                //是否是可编辑
                this.isUpdateData = buttonType == "view" ? false : true;
                this.currentButtonType = buttonType;
                await this.defaultButtonFunc(buttonType);
                // if(dataId){
                //     let dataRes = await this.spcpFormAxios.post(this.api.plCommonmethod.getById,{formId:this.formId,listViewId:this.listViewId,dataId:dataId});
                //     if(dataRes && dataRes.data){
                //         dataRes.data.operateObj.forEach(obj =>{
                //             this.contentForm = { ...this.contentForm,...obj };
                //         });
                //     }
                // }
                this.optDataDialog = true;
                loading && loading.close();
            } else if (buttonType == 'delete') { //删除
                if (this.viewDefinData.isShowCard == '1') {
                    await this.cardDelete();
                } else {
                    await this.excutDelete();
                }
                loading && loading.close();
            } else if (buttonType == "save") {
                if(!this.$refs.formDataRef){ // 防止重复点击
                    loading && loading.close();
                    return;
                }
                let contentForm = this.$refs.formDataRef.optFormData || {};
                let optType = "add";
                if (contentForm.ID) {
                    optType = "update";
                }
                let formDataRef = this.$refs.formDataRef;
                let tableDataRefArr = Object.keys(this.$refs.formDataRef.$refs) || [];
                // formDataRef.validateMethod(validate => {
                //     if (validate) {//验证成功
                let saveMessage = (this.buttonReminderObj[optType] || {}).saveMessage;// 按钮保存提示语
                if (!this.loginUser) {
                    this.loginUser = {};
                }
                formDataRef.saveData(this.loginUser.id || "", saveMessage, this.isEditTable, this.relationId, this.isTempEdit).then(async data => {
                    if (data) {
                        if(tableDataRefArr.length > 0) {
                            // 先保存大表表单, 根据返回的dataId 关联小表表单
                            tableDataRefArr.forEach(arr => {
                                if(arr.includes("editTableRef_")) {
                                    formDataRef.$refs[arr].saveDataTableForm(this.loginUser.id || "","success",data.operateObj);
                                }
                                // tabs 选项卡多层ref
                                if(formDataRef.$refs[arr] && formDataRef.$refs[arr].$refs && formDataRef.$refs[arr].$refs.renderRef && formDataRef.$refs[arr].tableFormRefObj) {
                                    let tableFormNameArr = Object.keys(formDataRef.$refs[arr].tableFormRefObj) || [];
                                    if(tableFormNameArr.length > 0) {
                                        tableFormNameArr.forEach(item => {
                                            formDataRef.$refs[arr].tableFormRefObj[item].saveDataTableForm(this.loginUser.id || "","success",data.operateObj);
                                        })
                                    }
                                }
                            })
                        }
                        if(this.isTempEdit) {
                            this.$set(this.tempEditObj, 'tempEdit_' + data['ID'], data);
                        }
                        this.execteAfterSave && this.execteAfterSave(data.operateObj, formDataRef.optFormData);
                        await this.getDataRows();
                        this.optDataDialog = false;
                        this.getTreeDefine();
                        this.setOptColumnLength();
                    }
                    if (this.viewDefinData.isOpenTotal === '1') {
                        this.findOpenTotal();
                    }
                    this.$set(this.openDialogData,'paramObj',{});
                    loading && loading.close();
                });
                // } else {//验证失败
                //     this.$nextTick(() => {
                //         let isError = document.getElementsByClassName("is-error");
                //         let listViewPreviewDialog = document.getElementsByClassName("listViewPreviewDialog")[0];
                //         listViewPreviewDialog.getElementsByClassName("el-dialog__body")[0].scrollTop = isError[0].offsetParent.offsetTop;
                //         /*if(isError[0].querySelector('input')){
                //             isError[0].querySelector('input').focus();
                //         }else{
                //             isError[0].querySelector('textarea').focus();
                //         }*/
                //     });
                //     loading && loading.close();
                //     return false;
                // }
                // });
            } else if (buttonType == 'cancel') {
                let closeMessage = (this.buttonReminderObj[this.currentButtonType] || {}).closeMessage;
                this.$refs.formDataRef && this.$refs.formDataRef.closeDialog(closeMessage);
                this.$set(this.openDialogData,'paramObj',{});
                loading && loading.close();
            } else if (buttonType == 'downloadModel') {
                let modelId = buttonInfo.param;
                this.impModelId = modelId;
                this.spcpFormAxios.post(this.api.baseUploadUrl + "viewFile", {"fkId": modelId + "_plFormTmpDefine_mbsc"}).then(response => {
                    let arrFile = response.data;
                    if (arrFile.length > 0) {
                        let downloadUrl = this.api.baseUploadUrl + "downloadFile?id=" + arrFile[0].id;
                        let link = document.createElement('a');
                        link.setAttribute('href', downloadUrl);
                        link.click();
                        link = null;
                    } else {
                        // 直接下载
                      this.axios.post(this.api.baseUploadUrl + "exportDefaultFile", {"listViewId":buttonInfo.listViewId},{responseType: 'blob'}).then(res => {
                          const blob = new Blob([res.data], {type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'});
                          const link = document.createElement('a');
                          link.href = URL.createObjectURL(blob);
                          link.download = 'defaultModel.xlsx';
                          link.click();
                      })
                          .catch(error => {
                              // 处理错误
                              this.$message("下载模板异常！");
                          });
                    }
                    loading && loading.close();
                });
            } else if (buttonType == 'import') {
                //初始化导入数据
                this.impXlsData["fkId"] = this.formId + "_" + buttonInfo.id + "_" + "xls";
                loading && loading.close();
            } else if (buttonType == 'export') {
                //初始化导入数据
                //初始化 expDialogObj
                this.expDialogObj = {
                    showDialog: false,
                    title: '导出设置',
                    activeColName: "showCol",
                    activeRowName: "showRow",
                    checkedAll: false,
                    isLegend: false,
                    defineColArr: [],
                    legendColArr: [],
                };
                this.spcpFormAxios.post(this.api.plexportset.find, {
                    "formId": this.formId,
                    "listViewId": this.listViewId,
                    "order": "FIELD_ORDER"
                }).then(res => {
                    if (res && res.data) {
                        this.diyExpFieldArr = res.data;
                        this.expDialogObj.defineColArr = JSON.parse(JSON.stringify(this.diyExpFieldArr));
                        this.expDialogObj.showDialog = true;
                        this.expDialogObj.activeColName = 'defineCol';
                        let tmpObj = {};
                        this.diyExpFieldArr.forEach(item => {
                            if (tmpObj.hasOwnProperty(item.tableName)) {
                                tmpObj[item.tableName].push(item);
                            } else {
                                tmpObj[item.tableName] = [];
                                tmpObj[item.tableName].push(item);
                            }
                        });
                        if (Object.keys(tmpObj).length > 1) {
                            this.expDialogObj.isLegend = true;
                        }
                        Object.keys(tmpObj).forEach(titem => {
                            let atmp = {};
                            atmp["name"] = titem;
                            atmp["colArr"] = tmpObj[titem];
                            this.expDialogObj.legendColArr.push(atmp);
                        });
                    }
                    loading && loading.close();
                });
            } else if (buttonType == "self") {
                await this.executeJsStr(buttonInfo.buttonContent);
                loading && loading.close();
            } else if (buttonType == 'diy') {
                let rowDataInfo = {};
                this.clickRowData = rowData || {};
                this.clickRowIndex = index;
                rowDataInfo = this.currentPageDataObj[index];
                this.executeDiyButtonClick(buttonInfo, rowDataInfo); //自定义按钮事件
                loading && loading.close();
            } else if (buttonType == "choose") {
                //获取当前数据
                let requestIds = "";
                if (this.isEjectTableShowSelect) {
                    let selection = this.$refs.listViewPreViewRef.selection || [];
                    // let ejectSelectIdArr = [];
                    selection.forEach(eachSelection => {
                        this.ejectSelectChooseRowIds.add(eachSelection["ID_" + this.formDefineKey] + "");
                    })

                    let ejectSelectIdArr = Array.from(this.ejectSelectChooseRowIds);

                    if (ejectSelectIdArr.length === 0) {
                        this.$emit("ejectDataChoose", [], this.callfillFieldArr);
                        loading && loading.close();
                        return;
                    }

                    requestIds = ejectSelectIdArr.join(",");
                } else {
                    requestIds = dataId;
                }
                let dataRes = await this.spcpFormAxios.post(this.api.plCommonmethod.getByIds, {
                    formId: this.formId,
                    dataIds: requestIds
                });
                if (dataRes && dataRes.data) {
                    let dataArrs = dataRes.data.operateObj || [];
                    this.$emit("ejectDataChoose", dataArrs, this.callfillFieldArr);
                }
                loading && loading.close();
            } else if (buttonType === "dotLocation") {
                // 获取当前按钮关联的定位信息
                let dotLocationField = this.showContentField[buttonInfo['dotLocationFieldId']];
                await this.getLocationInfo(dotLocationField, rowData);
                this.dotLocationDialog = true;
            } else if (buttonType === "regionalContour") {
                // 获取当前按钮关联的定位信息
                let regionalContourFieldId = this.showContentField[buttonInfo['regionalContourFieldId']];
                await this.getLocationInfo(regionalContourFieldId, rowData);
                this.regionalContourDialog = true;
            }
        },
        async getLocationInfo(fieldId, rowData) {
            if (fieldId) {
                let specialSet = JSON.parse(fieldId.specialSet);
                let ptNameField = specialSet.ptName;
                let rowDataInfo = await this.spcpFormAxios.post(this.api.plCommonmethod.getById, {
                    formId: this.formId,
                    listViewId: this.listViewId,
                    dataId: rowData["ID_" + this.formId]
                });
                let ptName = "";
                if (rowDataInfo && rowDataInfo.data) {
                    rowDataInfo.data.operateObj.forEach(obj => {
                        if (obj.hasOwnProperty(ptNameField)) {
                            ptName = obj[ptNameField];
                        }
                        this.currentRowDataAndSpecialSet.rowData = Object.assign(this.currentRowDataAndSpecialSet.rowData, obj);
                    });
                }
                this.currentRowDataAndSpecialSet.specialSet = specialSet;
                if (ptName) {
                    let data = await this.spcpFormAxios.post(this.api.gisMapDoting.find, {
                        formId: this.formId,
                        ptName: ptName,
                        type: specialSet.type,
                        relationId: rowData["ID_" + this.formId],
                    });

                    if (data && data.data) {
                        if (specialSet.type === "spot") {
                            if (data && data.data && data.data.length > 0) {
                                this.dotLocationInfo = {
                                    location: {
                                        lng: data.data[0].ptX,
                                        lat: data.data[0].ptY,
                                    }
                                }
                            }
                            this.dotLocationDialogObj = {
                                title: fieldId.showName,
                                dotLocationInfo: this.dotLocationInfo,
                                type: specialSet.type
                            }
                        } else if (specialSet.type === "regionalContour") {
                            if (data && data.data && data.data.length > 0) {
                                this.regionalContourInfo = data.data[0].ptArea;
                            }
                            this.regionalContourDialogObj = {
                                title: fieldId.showName, //标题
                                ptArea: this.regionalContourInfo,
                                type: specialSet.type,
                                color: specialSet.color,
                                fillColor: specialSet.fillColor,
                                operate: this.regionalContourInfo ? 'update' : "add",
                            };
                        }
                    }
                }
            }
        },
        //选择自定义导出功能全选
        checkalldiyexport(value) {
            if (this.expDialogObj.isLegend) {
                (this.expDialogObj.legendColArr || []).forEach(item => {
                    (item.colArr || []).forEach(each => {
                        // each["checked"] = value;
                        this.$set(each, "checked", value);
                    })
                })
            } else {
                (this.expDialogObj.defineColArr || []).forEach(item => {
                    // item["checked"] = value;
                    this.$set(item, "checked", value);
                })
            }
        },
        async exportLocalData(type) {
            //导出
            let vm = this;
            let expDatas = [];
            let expExcelColumns = [];
            vm.showFieldArr.forEach(showField => {
                if (showField.hiddenCol != '1' && showField.forbidden != '1') {
                    let width = Number(showField.width) / 5;
                    if (width > 100) {
                        width = 100;
                    }
                    expExcelColumns.push(showField.fieldName + "_" + showField.useFormId + ";" + showField.showName + ";" + width);
                }
            });
            if (expExcelColumns.length == 0) {
                vm.$message("无可导出列,导出结束！");
                return false;
            }
            if (type == "local") {
                //导出当前数据
                if ((this.dataRows || []).length == 0) {
                    this.$message("无可导出数据,导出结束！");
                    return false;
                }
                expDatas = this.batchFomratterContent(this.dataRows);
            } else if (type == "select") {
                //导出选中
                if (vm.viewDefinData.isShowCard == '1') {//卡片模式导出
                    if ((vm.cardClickArr || []).length == 0) {
                        vm.$message("未选中行数据,导出结束！");
                        return false;
                    } else {
                        expDatas = vm.batchFomratterContent(vm.cardClickArr);
                    }
                } else {
                    this.allCheckedDataArr = this.allCheckedDataArr.filter(item => {
                        let flag = false;
                        if (this.allCheckedArr.includes(item["ID_" + this.formDefineKey])) {
                            flag = true;
                        }
                        return flag;
                    });
                    if ((this.allCheckedDataArr || []).length === 0) {
                        vm.$message("未选中行数据,导出结束！");
                        return false;
                    } else {
                        expDatas = vm.batchFomratterContent(this.allCheckedDataArr);
                    }
                }
            } else if (type == "all") {
                //导出所有
                if ((vm.dataRows || []).length == 0) {
                    vm.$message("无可导出数据,导出结束！");
                    return false;
                }
                let paramArr = this.dealSearchParam();
                let res = await this.spcpFormAxios.post(this.api.plCommonmethod.find,
                    {
                        listViewId: this.listViewId,
                        conditionId: this.conditionId,
                        queryParams: JSON.stringify(paramArr),
                        currentPage: 0,
                        rows: 0
                    });
                if (res && res.data) {
                    let dataObj = res.data.operateObj;
                    expDatas = vm.batchFomratterContent(dataObj);
                } else {
                    vm.$message("无可导出数据,导出结束！");
                    return false;
                }
            }
            const formAxios = axios.create({
                baseURL: vm.api.plCommonmethod.exportListData,
                headers: {'Content-Type': 'multipart/form-data'},
                transformRequest: [
                    function (data) {
                        return data;
                    }
                ],
            });
            let formData = new FormData();
            formData.append('title', vm.expTitle);
            formData.append('fields', JSON.stringify(expExcelColumns));
            formData.append('datas', JSON.stringify(expDatas));
            formAxios.post(vm.api.plCommonmethod.exportListData,
                formData).then(res => {
                if (res && res.data) {
                    if (!(res.data || {}).operateSuccess) {
                        vm.$message({
                            duration: 1500,
                            message: res.data.operateMessage,
                            type: "warning"
                        });
                        return;
                    }
                    location.href = vm.api.plCommonmethod.loadfile + "?filename="
                        + encodeURI(encodeURI(vm.expTitle)) + '.xlsx&fileUrl=' + res.data.operateMessage;
                    setTimeout(() => {
                        vm.spcpFormAxios.post(vm.api.plCommonmethod.deletefile, {"filename": res.data.operateMessage});
                    }, 5000);
                }
            });
        },
        async beginExp() {
            // OBJ_FORMDATA => vm.listModel
            let vm = this;
            vm.expLoading = true;
            let expCol = vm.expDialogObj.activeColName;
            let expRow = vm.expDialogObj.activeRowName;
            let expExcelColumns = [];
            let expDatas = [];
            let paramArr = this.dealSearchParam();
            //导出自定义,获取需要导出的字段信息
            let searchFields = "";
            let changeType = {};
            if (expCol == "defineCol") {
                if (vm.expDialogObj.isLegend) { // 多表
                    vm.expDialogObj.legendColArr.forEach(item => {
                        item.colArr.forEach(each => {
                            if (each["checked"]) {
                                let tmpfiled = each.field.split(".")[1] + ":" + each.fieldFormId;
                                searchFields += "," + tmpfiled;
                                if (each.dataChangeType && each.dataChangeType != "无") {
                                    changeType[tmpfiled.replace(":", "_")] = each.dataChangeType + ":" + each.dataChangeDetail;
                                }
                                let width = Number(each.fieldWidth) / 5;
                                if (width > 100) {
                                    width = 100;
                                }
                                expExcelColumns.push(tmpfiled.replace(":", "_") + ";" + each.showName + ";" + Math.ceil(width));
                            }
                        })
                    });
                } else { // 单表
                    vm.expDialogObj.defineColArr.forEach(item => {
                        if (item["checked"]) {
                            let tmpfiled = item.field.split(".")[1] + ":" + item.fieldFormId;
                            searchFields += "," + tmpfiled;
                            if (item.dataChangeType && item.dataChangeType != "无") {
                                changeType[tmpfiled.replace(":", "_")] = item.dataChangeType + ":" + item.dataChangeDetail;
                            }
                            let width = Number(item.fieldWidth) / 5;
                            if (width > 100) {
                                width = 100;
                            }
                            expExcelColumns.push(tmpfiled.replace(":", "_") + ";" + item.showName + ";" + Math.ceil(width));
                        }
                    });
                }
                if (searchFields) {
                    searchFields = searchFields.substring(1);
                } else {
                    vm.$message("未选中导出列,导出结束！");
                    vm.expLoading = false;
                    vm.expDialogObj.showDialog = false;
                    return false;
                }
            }
            //当前显示行
            if (expRow == "showRow") {
                if ((vm.dataRows || []).length == 0) {
                    vm.$message("无可导出数据,导出结束！");
                    vm.expLoading = false;
                    vm.expDialogObj.showDialog = false;
                    return false;
                }
                if (expCol == "showCol") {
                    expDatas = vm.batchFomratterContent(vm.dataRows);
                } else {
                    if (!this.isShowPage()) {
                        this.currentPage = 0;
                    }
                    let res = await this.spcpFormAxios.post(this.api.plCommonmethod.find,
                        {
                            listViewId: this.listViewId,
                            conditionId: this.conditionId,
                            searchFields: searchFields,
                            queryParams: JSON.stringify(paramArr),
                            currentPage: this.currentPage,
                            rows: this.pageSize
                        });
                    if (res && res.data) {
                        let dataObj = [];
                        if (this.currentPage) {
                            dataObj = (res.data.operateObj || {}).records || [];
                        } else {
                            dataObj = res.data.operateObj || [];
                        }
                        expDatas = vm.batchFomratterContent(dataObj);
                    } else {
                        vm.$message("无可导出数据,导出结束！");
                        vm.expLoading = false;
                        vm.expDialogObj.showDialog = false;
                        return false;
                    }
                }
            } else if (expRow == "checkedRow") {
                if ((vm.$refs.listViewPreViewRef.selection || []).length == 0) {
                    vm.$message("未选中行数据,导出结束！");
                    vm.expLoading = false;
                    vm.expDialogObj.showDialog = false;
                    return false;
                } else {
                    if (expCol == "showCol") {
                        expDatas = vm.batchFomratterContent(this.$refs.listViewPreViewRef.selection);
                    } else {
                        let fieldIds = "";
                        let tmpId = "";
                        this.$refs.listViewPreViewRef.selection.forEach(item => {
                            tmpId += "," + item["ID_" + this.formDefineKey];
                        });
                        if (tmpId) {
                            tmpId = tmpId.substring(1);
                        }
                        paramArr.push({'key': 'TB.ID', controlType: 'defaultField', value: tmpId, 'operate': 'in'});
                        let res = await this.spcpFormAxios.post(this.api.plCommonmethod.find,
                            {
                                listViewId: this.listViewId,
                                conditionId: this.conditionId,
                                searchFields: searchFields,
                                queryParams: JSON.stringify(paramArr),
                                currentPage: 0,
                                rows: 0
                            });
                        if (res && res.data) {
                            let dataObj = res.data.operateObj;
                            expDatas = vm.batchFomratterContent(dataObj);
                        } else {
                            vm.$message("无可导出数据,导出结束！");
                            vm.expLoading = false;
                            vm.expDialogObj.showDialog = false;
                            return false;
                        }
                    }
                }
            } else if (expRow == "allRow") {
                if ((vm.dataRows || []).length == 0) {
                    vm.$message("无可导出数据,导出结束！");
                    vm.expLoading = false;
                    vm.expDialogObj.showDialog = false;
                    return false;
                }
                if (expCol == "showCol") {
                    let res = await this.spcpFormAxios.post(this.api.plCommonmethod.find,
                        {
                            listViewId: this.listViewId,
                            conditionId: this.conditionId,
                            queryParams: JSON.stringify(paramArr),
                            currentPage: 0,
                            rows: 0
                        });
                    if (res && res.data) {
                        let dataObj = res.data.operateObj;
                        expDatas = vm.batchFomratterContent(dataObj);
                    } else {
                        vm.$message("无可导出数据,导出结束！");
                        vm.expLoading = false;
                        vm.expDialogObj.showDialog = false;
                        return false;
                    }
                } else {
                    let res = await this.spcpFormAxios.post(this.api.plCommonmethod.find,
                        {
                            listViewId: this.listViewId,
                            conditionId: this.conditionId,
                            searchFields: searchFields,
                            queryParams: JSON.stringify(paramArr),
                            currentPage: 0,
                            rows: 0
                        });
                    if (res && res.data) {
                        let dataObj = res.data.operateObj;
                        expDatas = vm.batchFomratterContent(dataObj);
                    } else {
                        vm.$message("无可导出数据,导出结束！");
                        vm.expLoading = false;
                        vm.expDialogObj.showDialog = false;
                        return false;
                    }
                }
            }
            if (expCol == "showCol") { // 当前显示列
                vm.showFieldArr.forEach(showField => {
                    if (showField.hiddenCol != '1' && showField.forbidden != '1') {
                        let width = Number(showField.width) / 5;
                        if (width > 100) {
                            width = 100;
                        }
                        expExcelColumns.push(showField.fieldName + "_" + showField.useFormId + ";" + showField.showName + ";" + width);
                    }
                });
                if (expExcelColumns.length == 0) {
                    vm.$message("无可导出列,导出结束！");
                    vm.expLoading = false;
                    vm.expDialogObj.showDialog = false;
                    return false;
                }
                const formAxios = axios.create({
                    baseURL: vm.api.plCommonmethod.exportListData,
                    headers: {'Content-Type': 'multipart/form-data'},
                    transformRequest: [
                        function (data) {
                            return data;
                        }
                    ],
                });
                let formData = new FormData();
                formData.append('title', vm.expTitle);
                formData.append('fields', JSON.stringify(expExcelColumns));
                formData.append('datas', JSON.stringify(expDatas));
                formAxios.post(vm.api.plCommonmethod.exportListData,
                    formData).then(res => {
                    vm.expLoading = false;
                    vm.expDialogObj.showDialog = false;
                    if (res && res.data) {
                        if (!(res.data || {}).operateSuccess) {
                            vm.$message({
                                duration: 1500,
                                message: res.data.operateMessage,
                                type: "warning"
                            });
                            return;
                        }
                        location.href = vm.api.plCommonmethod.loadfile + "?filename="
                            + encodeURI(encodeURI(vm.expTitle)) + '.xlsx&fileUrl=' + res.data.operateMessage;
                        setTimeout(() => {
                            vm.spcpFormAxios.post(vm.api.plCommonmethod.deletefile, {"filename": res.data.operateMessage});
                        }, 5000);
                    }
                });
            } else { // 自定义列
                if (expExcelColumns.length == 0) {
                    vm.$message("无可导出列,导出结束！");
                    vm.expLoading = false;
                    vm.expDialogObj.showDialog = false;
                    return false;
                }

                vm.spcpFormAxios.post(vm.api.plCommonmethod.exportDiyData,
                    {
                        title: vm.expTitle,
                        fields: JSON.stringify(expExcelColumns),
                        datas: JSON.stringify(expDatas),
                        changeType: JSON.stringify(changeType)
                    }).then(res => {
                    vm.expLoading = false;
                    vm.expDialogObj.showDialog = false;
                    if (res && res.data) {
                        if (!(res.data || {}).operateSuccess) {
                            vm.$message({
                                duration: 1500,
                                message: res.data.operateMessage,
                                type: "warning"
                            });
                            return;
                        }
                        location.href = vm.api.plCommonmethod.loadfile + "?filename="
                            + encodeURI(encodeURI(vm.expTitle)) + '.xlsx&fileUrl=' + res.data.operateMessage;
                        setTimeout(() => {
                            vm.spcpFormAxios.post(vm.api.plCommonmethod.deletefile, {"filename": res.data.operateMessage});
                        }, 5000);
                    }
                });
            }
        },
        /**
         * 关闭弹窗
         */
        closeDialog() {
            this.$refs.formDataRef.closeDialog();  //关闭
            this.$set(this.openDialogData,'paramObj',{});
        },

        submitUpload() {
            if (this.impotFileCount == 0) {
                this.$message("请先选取导入文件！");
            } else {
                this.$confirm('是否确定导入数据？', '确认信息', {
                    distinguishCancelAndClose: true,
                    confirmButtonText: '确定',
                    cancelButtonText: '取消'
                }).then(() => {
                    this.$refs.impxlsupload[0].submit();
                    this.importDataVisible = false;
                });
            }
        },
        onExceedimportData() {
            this.$message("最大上传文件个数为：1 ，无法继续上传！");
        },
        onchangeimport() {
            this.impotFileCount = 1;
        },
        onremoveimport() {
            this.impotFileCount = 0;
        },
        beforeImport(file) {
            let fileSuffix = file.name.substring(file.name.lastIndexOf("."), file.name.length);
            if (this.acceptImportFileType.indexOf(fileSuffix) == -1) {
                this.$message.error('数据导入目前仅支持EXECL文件！');
                return false;
            } else {
                return true;
            }
        },
        /*
        * 保存按钮隐藏条件
        * */
        saveBtnConfing(index) {
            return !this.isShowRedact[index];
        },
        /*
        * 查看按钮隐藏条件
        * */
        viewBtnConfing(buttonInfo, index) {
            let show = true;
            if (this.switchTable) {
                return !this.isShowSaveBtn[index];
            }
            return show;
        },
        /**
         * 按钮隐藏条件
         */
        showButtonConfigtion(buttonInfo, row) {
            let show = false;
            if (this.diyButtonShow && this.diyButtonShow[buttonInfo.id]) {//自定义按钮显示隐藏,不再走配置的隐藏条件
                if (this.diyButtonShow[buttonInfo.id] == '0') {
                    return false;
                } else if (this.diyButtonShow[buttonInfo.id] == '1') {
                    return true;
                }
            }
            if (!buttonInfo.hideCondition) {
                return !show
            }
            let hideConditionArr = JSON.parse(buttonInfo.hideCondition || "[]");
            if (row) {
                let dataId = "";
                let filedArr = Object.keys(row);
                filedArr.some(rowField => {
                    let field = rowField.split("_")[0];
                    if (field == 'ID') {
                        dataId = row[rowField];
                    }
                });
                let dataObj = {};
                let dataArr = Object.values(this.currentPageDataObj);
                dataArr.some(item => {
                    if (item['ID'] == dataId) {
                        dataObj = item;
                    }
                });
                if (dataId && dataObj) {
                    show = this.executConfigtion(hideConditionArr, dataObj);
                }
                if (!dataId && this.isShowDiyButton == '1') {//行可编辑下，如果数据没有id 就不显示自定义按钮
                    show = true;
                }
            } else { //头部按钮
                show = this.executConfigtion(hideConditionArr);

            }
            return !show;
        },

        /**
         *  执行隐藏条件判断
         *  buttonInfo 按钮信息
         *
         */
        executConfigtion(hideConditionArr, rowData) {
            let funcStr = "";
            let detailArr = hideConditionArr || [];
            let reultFunc = ""; //逻辑条件拼接
            detailArr.forEach(item => {
                let condition = "";
                //符号左边的值
                let param = ""; //左侧值
                if (rowData) { //行按钮
                    param = rowData[item.fieldId] || "";
                } else if (item.fieldId.indexOf('LOGINUSER') > -1) {
                    //头部按钮
                    param = Replace.def(this.loginUser, item.fieldId) || "";
                }
                //左侧值
                let connectSignLeft = item.connectSignLeft; //左连接符号
                if (connectSignLeft) {
                    reultFunc += connectSignLeft;
                }
                //操作
                let operaSign = item.operaSign;
                //操作符右边的值
                let value = item.value || "";
                //if(value){
                //处理值
                if (item.valType == "default") {
                    if (value.indexOf("LOGINUSERDEPT") > -1) {
                        value = Replace.def(this.userDept, value) || "";
                    } else if (value.indexOf("LOGINUSER") > -1) {
                        value = Replace.def(this.loginUser, value) || "";
                    }
                } else if (item.valType == 'constant') { //常数
                    value = item.value;
                } else if (item.valType == 'sysData') { //数据字典
                    if (item.value) {
                        let valDataArr = item.value;
                        value = valDataArr[valDataArr.length - 1] || '';
                    }
                } else if (item.valType == 'sysTime') { //当前系统时间
                    if (item.value) {
                        value = this.viewDateFormat(new Date(), item.value);
                    }
                } else if (item.valType == 'equilibrium') { //外部参数
                    value = this.listOutParam[item.value || ''] || '';
                }
                //执行语句
                if (operaSign == "eq") {
                    condition = (param == value);
                } else if (operaSign == ">" || operaSign == "<" || operaSign == ">=" || operaSign == "<=") {
                    let ret = this.transType(param, value);
                    param = ret.param;
                    value = ret.value;
                    if (operaSign == ">") {
                        condition = (param > value);
                    } else if (operaSign == "<") {
                        condition = (param < value);
                    } else if (operaSign == ">=") {
                        condition = (param >= value);
                    } else if (operaSign == "<=") {
                        condition = (param <= value);
                    }
                } else if (operaSign == "ne") {
                    condition = (param != value);
                } else if (operaSign == "in") {
                    if (value.includes(",")) {
                        let arr = value.split(",") || [];
                        condition = arr.includes(param);
                    } else {
                        condition = (param.indexOf(value) > -1);
                    }
                } else if (operaSign == "not in") {
                    if (value.includes(",")) {
                        let arr = value.split(",") || [];
                        condition = !arr.includes(param)
                    } else {
                        condition = (param.indexOf(value) > -1);
                    }
                    condition = (param.indexOf(value) == -1);
                } else if (operaSign == "be in") {// 被包含
                    if (param.includes(",")) {
                        let arr = param.split(",") || [];
                        condition = arr.includes(value);
                    } else {
                        condition = (value.indexOf(param) > -1);
                    }
                } else if (operaSign == "be not in") { //不被包含
                    if (param.includes(",")) {
                        let arr = param.split(",") || [];
                        condition = !arr.includes(value)
                    } else {
                        condition = (value.indexOf(param) > -1);
                    }
                    condition = (value.indexOf(param) == -1);
                } else if (operaSign == "is null") {
                    condition = (!param);
                } else if (operaSign == "is not null") {
                    condition = (!!param);
                }
                reultFunc += condition;
                if (item.connectSignRight) {
                    reultFunc += item.connectSignRight;
                }
            });
            if (!reultFunc) {
                return false;
            }
            let funcBody = "let result = " + reultFunc + ";" + "\n";
            funcBody += "return result;";
            let result = false;
            try {
                let serviceName = (window.SERVICE_NAME || {});
                let adminServeName = serviceName.admin || "/admin/";
                let formServeName = serviceName.form || "/form/";
                let flowServeName = serviceName.flow || "/flow/";
                let oaServeName = serviceName.oa || "/oaproject/";
                // funcBody = this.platStringUtil.replaceAll(funcBody, "/admin/", adminServeName);
                // funcBody = this.platStringUtil.replaceAll(funcBody, "/form/", formServeName);
                // funcBody = this.platStringUtil.replaceAll(funcBody, "/flow/", flowServeName);
                // funcBody = this.platStringUtil.replaceAll(funcBody, "/oaproject/", oaServeName);
                // funcBody = this.platStringUtil.replaceAll(funcBody, "/oaadmin/", adminServeName);
                // funcBody = this.platStringUtil.replaceAll(funcBody, "/oaform/", formServeName);
                // funcBody = this.platStringUtil.replaceAll(funcBody, "/oaflow/", flowServeName);
                funcBody = this.replaceUrlPrefix(funcBody);

                result = new Function(funcBody)();
            } catch (e) {
                result = false;
                console.log("隐藏条件条件脚本执行错误！", e);
            }
            return result;

        },

        //默认按钮操作方法
        async defaultButtonFunc(buttonType) {
            // let controlRef = await this.spcpFormAxios.post(this.api.plControlConfig.find,
            //     {"tviewId":this.viewDefinData.tableViewId,"order":"FIELD_ORDER ASC"});
            // if(controlRef && controlRef.data){
            //     controlRef.data.forEach(item => {
            //         item.specialSet = JSON.parse(item.specialSet || "{}");
            //     });
            //     this.contentArr = controlRef.data || [];
            // }
            // this.dealTableViewData();

            let tableviewData = this.tableViewData;
            if (buttonType == "view" && this.multiTableViewId) {
                tableviewData = this.tableViewMultiData;
            }
            let obj = {"add": "添加", "update": "修改", "view": "查看"};
            if (Object.keys(obj).indexOf(buttonType) > -1) {
                this.formOperate = buttonType;
                this.dialogTitle = obj[buttonType] + tableviewData.viewName
                    + (tableviewData.viewName.indexOf("信息") ? "" : "信息");
                if (tableviewData.dialogTitleText) {
                    this.dialogTitle = obj[buttonType] + tableviewData.dialogTitleText
                        + (tableviewData.dialogTitleText.indexOf("信息") ? "" : "信息");
                }
            }
            let styleObj = {};
            (tableviewData.dialogTitleStyle || "").split(";").forEach(item => {
                let tempArr = item.split(":");
                if (tempArr.length == 2) {
                    styleObj[tempArr[0]] = tempArr[1];
                }
            });
            this.$set(this.tableviewsData, 'dialog-title-style', styleObj);
            let messageInfo = this.buttonReminderObj[buttonType] || {};
            if (messageInfo.headerName) {
                this.dialogTitle = messageInfo.headerName;
            }

            if (tableviewData.viewOpenWidth) {
                this.dialogWidth = tableviewData.viewOpenWidth;
            }
            if (tableviewData.viewOpenHeight) {
                this.dialogHeight = tableviewData.viewOpenHeight;
            }
            if (tableviewData.viewTopSpace) {
                this.dialogTop = tableviewData.viewTopSpace.replace("%", "vh");
            }
        },

        /**
         * 处理表单数据
         */
        dealTableViewData() {
            let fieldInclue = 0;
            let rowNumber = 1;
            let rowspanObj = {};
            let obj = {tds: []};
            this.renderArr = [obj];
            this.contentAllObj = {};
            let hideArr = [];
            let notTitleArr = ['titleBox', 'dividingLine', 'blankLine', 'hyperlink'];
            this.contentArr.forEach(td => {
                Object.keys(td.specialSet || {}).forEach(specialSetKey => {
                    this.$set(td, specialSetKey, td.specialSet[specialSetKey]);
                });
                this.contentAllObj[td.fieldId] = td;
                if (td.tdType == "controlTitle" || td.specialSet.isCupJoint) {//控件嵌套不显示
                    return;
                }
                if (td.visible == "true") {
                    if (fieldInclue + Number(td.fieldInclue || 0) > (24 - Number(rowspanObj[rowNumber] || 0))) {
                        obj = {tds: []};
                        fieldInclue = 0;
                        this.renderArr.push(obj);
                        rowNumber++;
                    }
                    if (Number(td.rowspan || 0) > 1) { // 根据跨行数为下行计算已被占据的列数
                        for (let i = 1; i < Number(td.rowspan || 0); i++) {
                            rowspanObj[rowNumber + i] = Number(rowspanObj[rowNumber + i] || 0) + Number(td.fieldInclue || 0);
                        }
                    }
                    let fieldInclueTmp = td.fieldInclue;
                    if (td.hideShowName != "是" && this.tableViewData.elementStyle == "tradition"
                        && notTitleArr.indexOf(td.controlType) == -1) {
                        let controlTtileObj =
                            {
                                "tdType": "controlTitle", "label": td.showName, "rowspan": td.rowspan,
                                "fieldInclue": td.specialSet.fieldTitleInclue ? td.specialSet.fieldTitleInclue : (this.tableViewData.titleInclue),
                                "visible": "true"
                            };
                        td.titleWidth = controlTtileObj.fieldInclue;
                        obj.tds.push(controlTtileObj);
                    } else {
                        td.titleWidth = 0;
                    }
                    obj.tds.push(td);
                    fieldInclue += Number(fieldInclueTmp || 0);
                } else {
                    hideArr.push({tds: [td]});
                }
            });
            this.renderArr = this.renderArr.concat(hideArr);
        },
        /*
        * 卡片标题点击事件
        * */
        clickCard(data, index) {
            let show = document.getElementById("checkCard_" + index).style.visibility;
            if (show == "hidden") {
                this.$set(data, "idIndex", index)
                this.cardClickArr.push(data);
                document.getElementById("checkCard_" + index).style.visibility = "visible";
            } else {
                let beforeIndex = this.cardClickArr.findIndex(val => {
                    if (val['DATA_ID'] == data['DATA_ID']) {
                        return true;
                    }
                });
                if (beforeIndex >= 0) {
                    this.cardClickArr.splice(beforeIndex, 1);
                }
                document.getElementById("checkCard_" + index).style.visibility = "hidden";
            }
        },
        /**
         *卡片模式删除
         */
        cardDelete() {
            let selection = this.cardClickArr || [];
            if ((selection || []).length == 0) {
                this.$message("请至少选择一条需要删除的数据！");
                return;
            }
            //编辑列表仅能维护自身数据
            if (this.isEditTable == "1" && this.optOwnData == "1") {
                let flag = true;
                (selection || []).forEach(row => {
                    if (row["CREATED_" + this.formDefineKey] != this.loginUser.id) {
                        flag = false;
                        return;
                    }
                });
                if (!flag) {
                    this.$message({type: 'warning', message: "仅能维护自身数据！"});
                    return;
                }
            }

            this.$confirm('是否确定删除选择的“' + selection.length + '”条数据?', '警告', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
            }).then(async () => {
                //执行逻辑删除
                let delteIdArr = this.getSelectionIds(selection);
                let res = await this.spcpFormAxios.post(this.api.plCommonmethod.delete,
                    {formId: this.formId, dataIds: delteIdArr.join(",")});

                if (res && res.data) {
                    let type = "success";
                    let msg = "删除成功！";
                    if (!res.data.operateSuccess) {
                        type = "danger";
                        msg = "删除失败！";
                    }
                    if (delteIdArr.length > 0 && this.editTableIdArr.length > 0) {
                        let ids = "";
                        delteIdArr.forEach(delteId => {
                            ids += ",'" + delteId + "'";
                        });
                        let searchSql = "RELATION_ID IN (" + ids.substring(1) + ")";
                        this.editTableIdArr.forEach(tableId => {
                            this.spcpFormAxios.post(this.api.plCommonmethod.deleteByParam, {
                                formId: tableId,
                                paramSql: searchSql
                            });
                        });
                    }
                    this.$message({message: msg, type: type});
                    if (type == 'success') {
                        this.switchTable = false;
                        selection.forEach((item, index) => {
                            document.getElementById("checkCard_" + item["idIndex"]).style.visibility = "hidden";
                        });
                        this.cardClickArr = [];
                    }
                    this.optDataDialog = false;
                    this.getDataRows();
                }
            })

        },
        /**
         * 删除数据
         */
        excutDelete() {
            let selection = this.$refs.listViewPreViewRef.selection || [];
            if ((selection || []).length == 0) {
                this.$message("请至少选择一条需要删除的数据！");
                return;
            }
            //编辑列表仅能维护自身数据
            if (this.isEditTable == "1" && this.optOwnData == "1") {
                let flag = true;
                (selection || []).forEach(row => {
                    if (row["CREATED_" + this.formDefineKey] != this.loginUser.id) {
                        flag = false;
                        return;
                    }
                });
                if (!flag) {
                    this.$message({type: 'warning', message: "仅能维护自身数据！"});
                    return;
                }
            }
            this.$confirm('是否确定删除选择的“' + selection.length + '”条数据?', '警告', {
                confirmButtonText: '确定',
                cancelButtonText: '取消',
            }).then(async () => {
                //执行逻辑删除
                let delteIdArr = this.getSelectionIds(selection);
                let tempDeleteArr = [];
                if (this.isTempEdit) {
                    delteIdArr.forEach(item => {
                        let tempKey = 'tempEdit_' + item;
                        if (this.tempEditObj[tempKey]['CREATED']) {
                            tempDeleteArr.push(item);
                        }
                        delete this.tempEditObj[tempKey];
                    });
                    if(tempDeleteArr.length > 0) {
                        await this.spcpFormAxios.post(this.api.plCommonmethod.delete,
                            {formId: this.formId, dataIds: tempDeleteArr.join(",")});
                    }
                    await this.getDataRows();
                    return;
                }
                // let res = await this.spcpFormAxios.post("plCommonMethodController/logicDelete",
                //     {formId:this.formId,dataIds:delteIdArr.join(",")});
                let res = await this.spcpFormAxios.post(this.api.plCommonmethod.delete,
                    {formId: this.formId, dataIds: delteIdArr.join(",")});

                if (res && res.data) {
                    let type = "success";
                    let msg = "删除成功！";
                    if (!res.data.operateSuccess) {
                        type = "danger";
                        msg = "删除失败！";
                    }
                    if (delteIdArr.length > 0 && this.editTableIdArr.length > 0) {
                        let ids = "";
                        delteIdArr.forEach(delteId => {
                            ids += ",'" + delteId + "'";
                        });
                        let searchSql = "RELATION_ID IN (" + ids.substring(1) + ")";
                        this.editTableIdArr.forEach(tableId => {
                            this.spcpFormAxios.post(this.api.plCommonmethod.deleteByParam, {
                                formId: tableId,
                                paramSql: searchSql
                            });
                        });
                    }
                    this.$message({message: msg, type: type});
                    if (type == 'success') {
                        this.switchTable = false;
                    }
                    this.optDataDialog = false;
                    if (this.viewDefinData.isOpenTotal === '1') {
                        this.findOpenTotal();
                    }
                    this.getDataRows();
                }
            })
        },

        /**
         * 保存数据
         * @param buttonType
         * @returns {Promise<void>}
         */
        saveData() {
            this.$refs.formDataRef.validate((valid) => {
                if (!valid) {
                    return;
                }
                let contentForm = this.$refs.formDataRef.contentForm || {};
                let optType = "add";
                if (contentForm.ID) {
                    optType = "update";
                }
                let saveMessage = this.buttonReminderObj[optType].saveMessage;
                delete contentForm["CREATE_TIME"];
                delete contentForm["UPDATE_TIME"];
                //修改
                if (contentForm.ID) {
                    let paramObj = {
                        formId: this.formId,
                        dataId: contentForm.ID,
                        updateParams: JSON.stringify(contentForm)
                    };
                    this.spcpFormAxios.post(this.api.plCommonmethod.updateById, paramObj).then(res => {
                        if (res && res.data) {
                            let type = "success";
                            let msg = "保存成功！";
                            if (!res.data.operateSuccess) {
                                type = "danger";
                                msg = "保存失败！";
                            } else {
                                if (saveMessage) {
                                    msg = saveMessage;
                                }
                            }
                            this.$message({message: msg, type: type});
                            this.optDataDialog = false;
                            this.initData2();
                        }
                    });
                } else {//新增
                    let paramObj = {formId: this.formId, params: JSON.stringify(contentForm)};
                    this.spcpFormAxios.post(this.api.plCommonmethod.insert, paramObj).then(res => {
                        if (res && res.data) {
                            let type = "danger";
                            let msg = "保存失败！";
                            if (res.data.operateSuccess) {
                                type = "success";
                                msg = "保存成功！";
                                if (saveMessage) {
                                    msg = saveMessage;
                                }
                                this.currentPage = 1;
                                this.getDataRows();
                                this.optDataDialog = false;
                            }
                            this.$message({message: msg, type: type});
                            this.initData2();
                        }
                    });
                }
            });
        },

        changeValue() {
            this.optDataDialog = false;
            this.currentButtonType = "";
        },

        /**
         * 导入模板
         */
        impData(item) {
            let vm = this;
            // if (!vm.impModelId) {
            //     vm.$message("导入失败！模板未定义！");
            //     return false;
            // }
            let formData = new FormData();
            formData.append("file", item.file);
            formData.append("modelId", vm.impModelId);
            formData.append("sourceKey", this.sourceKey);
            formData.append("user", JSON.stringify(vm.CACHE_GLOBAL.getLoginUser()));
            formData.append("listViewId",vm.listViewId);
            //创建axios实例
            const axiosInstance = axios.create({
                baseURL: vm.api.plCommonmethod.importData,
                headers: {'Content-Type': 'multipart/form-data'},
                transformRequest: [
                    function (data) {
                        return data;
                    }
                ],
            });
            //上传文件
            axiosInstance.post(vm.api.plCommonmethod.importData, formData).then(function (res) {
                if (res && res.data) {
                    if (res.data.operateSuccess) {
                        vm.importDataVisible = false;
                        if (res.data.operateMessage != "导入成功！") {
                            vm.$message.error({message: res.data.operateMessage, showClose: true, duration: 0});
                        } else {
                            vm.$message(res.data.operateMessage);
                        }
                        vm.getDataRows();
                    } else {
                        vm.$message.error(res.data.operateMessage);
                    }
                }

            });
        },

        /**
         * 执行脚本字符串
         */
        executeJsStr(buttonContent) {
            if (buttonContent) {
                try {
                    let serviceName = (window.SERVICE_NAME || {});
                    let adminServeName = serviceName.admin || "/admin/";
                    let formServeName = serviceName.form || "/form/";
                    let flowServeName = serviceName.flow || "/flow/";
                    let oaServeName = serviceName.oa || "/oaproject/";
                    // buttonContent = this.platStringUtil.replaceAll(buttonContent, "/admin/", adminServeName);
                    // buttonContent = this.platStringUtil.replaceAll(buttonContent, "/form/", formServeName);
                    // buttonContent = this.platStringUtil.replaceAll(buttonContent, "/flow/", flowServeName);
                    // buttonContent = this.platStringUtil.replaceAll(buttonContent, "/oaproject/", oaServeName);
                    // buttonContent = this.platStringUtil.replaceAll(buttonContent, "/oaadmin/", adminServeName);
                    // buttonContent = this.platStringUtil.replaceAll(buttonContent, "/oaform/", formServeName);
                    // buttonContent = this.platStringUtil.replaceAll(buttonContent, "/oaflow/", flowServeName);
                    buttonContent = this.replaceUrlPrefix(buttonContent);
                    let diyfunc = new Function('vm', 'parentVm', buttonContent);
                    diyfunc(this.$refs.formDataRef, this);
                } catch (e) {
                    console.log("脚本执行失败", e);
                }
            }
        },

        /**
         *  自定义按钮点击
         * @param buttonInfo
         * @param rowData 当前行数据
         */
        executeDiyButtonClick(buttonInfo, rowData) {
            if (buttonInfo.eventType == 'sys') { //执行自定义动作配置
                this.execDiyBtnActOrder(buttonInfo, rowData);
            } else if (buttonInfo.eventType == 'diy' && buttonInfo.funcBody) { //执行自定义事件脚本
                //对于脚本中的字段进行处理
                if (buttonInfo.openMode == 'top') { //顶部按钮
                    //获取选中行数据
                    this.execDiyBtnTopScripts(buttonInfo.funcBody); //执行顶部按钮事件
                } else if (buttonInfo.openMode == 'self') {  //行按钮
                    this.execDiyBtnSelfScripts(buttonInfo.funcBody, rowData);
                }

            }

        },


        /**
         * 执行自定义事件动作
         * @param buttonInfo
         * @param rowData 当前行数据
         */
        execDiyBtnActOrder(buttonInfo, rowData) {
            let actOrderList = buttonInfo.plBtnActOrderList || [];
            if (actOrderList.length > 0) {
                let act = actOrderList[0];
                this.logicSetBtnAct(act, actOrderList, rowData).then(() => {
                });
            }

        },


        /**
         * 回调函数（为解决confrim 提示框异步执行问题）
         * 执行动作前进行逻辑条件判断
         * @param act 动作参数
         * @param resultMap 动作结果
         */
        logicSetBtnAct(act, actOrderList, rowData, resultMap) {
            return new Promise(resolve => {
                if (!resultMap) {
                    resultMap = {} //动作执行结果
                }
                let maxIndex = actOrderList.length;
                if (act && act.actOrder <= maxIndex) {
                    let actIdArr = act.actId.split(",");
                    let logicCondition = JSON.parse(act.logicCondition || "{}"); //逻辑条件
                    let logicSetArr = logicCondition.logicSetArr || [];
                    if (this.logicIsCorrect(logicSetArr, rowData, resultMap)) { //逻辑校验通过
                        //运行指定动作
                        switch (actIdArr[0]) {
                            case 'commonMethod': //常用方法  openDialog  openNewPage
                                this.executDiyBtnMethod(act, actIdArr, actOrderList, rowData, resultMap); //常用方法
                                break;
                            case 'check': //校验 remoteCheck  basicCheck
                                this.executDiyBtnCheck(act, actIdArr, actOrderList, rowData, resultMap); //执行自定义方法校验
                                break;
                            case 'variableAssignment': //临时变量赋值  remoteBinding  localBinding
                                this.executDiyBtnBing(act, actIdArr, actOrderList, rowData, resultMap); //数据绑定
                                break;

                            case 'information': //提示信息 confirm alert  message
                                this.executDiyBtnInfo(act, actIdArr, actOrderList, rowData, resultMap);
                                break;

                            case 'dataOperate' :  //数据操作 formUpdate formAdd  formRemove
                                this.executDiyBtnDataOperate(act, actIdArr, actOrderList, rowData, resultMap); //执行数据操作 表修改、新增、删除
                                break;

                            case 'sysMethod': //系统方法 openAddPage openUpdatePage  sysRemoveMethod sysCallbackMethod
                                this.executDiyBtnSysMethod(act, actIdArr, actOrderList, rowData, resultMap);
                                break;
                            default:
                                break;
                        }
                    }
                }
                resolve();
            });

        },

        /**
         * 逻辑条件是否通过判断
         * 判断当前动作是否可执行
         * @param logicSetArr 当前动作逻辑条件
         * @param rowData 当前行数据
         * @param resultMap 现有动作执行结果
         */
        logicIsCorrect(logicSetArr, rowData, resultMap) {
            let result = true;
            logicSetArr.forEach(logicSet => {
                let preValue = resultMap[logicSet.stepNumber]; //上一步值
                if (logicSet.operaSign == 'is true' || logicSet.operaSign == 'is false') {
                    if (logicSet.operaSign != preValue) {
                        result = false;
                    }
                } else { //其他类型
                    if (logicSet.valType == 'constant' || logicSet.valType == 'sysData') { //值类型为常数或者数据字典
                        let value = logicSet.value;
                        if (logicSet.valType == 'sysData') { //处理数据字典类型
                            let valDataArr = logicSet.value;
                            value = valDataArr[valDataArr.length - 1] || '';
                        }
                        if (logicSet.operaSign == 'includes') { //包含
                            result = preValue.indexOf(value) > -1;
                        } else if (logicSet.operaSign == 'not includes') { //不包含
                            result = preValue.indexOf(value) == -1;
                        } else if (logicSet.operaSign == '==') { //等于
                            result = preValue == value;
                        } else if (logicSet.operaSign == '!=') { //不等于
                            result = preValue != value;
                        } else if (logicSet.operaSign == 'included') { //被包含
                            result = value.indexOf(preValue) > -1;
                        } else if (logicSet.operaSign == 'not included') { //不被包含
                            result = value.indexOf(preValue) == -1;
                        }
                    } else if (logicSet.valType == 'formField') { //值类型为表单字段值 - 如果是头部按钮则没意义
                        if (this.isEmptyObject(rowData)) { //当前按钮没有行数据
                            return false;
                        }
                        //解析表单数据
                        if (this.getValTypeByOperSignType(logicSet.operaSign)) { //多选情况(包含或者不包含)
                            let valueArr = [];
                            (logicSet.value || []).forEach(item => {
                                if (rowData[item]) {
                                    valueArr.push(rowData[item]);
                                }
                            });
                            if (logicSet.operaSign == 'includes') {
                                result = preValue.includes(valueArr);
                            } else if (logicSet.operaSign == 'not includes') {
                                result = !preValue.includes(valueArr);
                            }
                        } else {
                            let value = '';
                            if (rowData[logicSet.value]) {
                                value = rowData[logicSet.value];
                            }
                            if (!value) {
                                return false;
                            }
                            if (logicSet.operaSign == '==') { //等于
                                result = preValue == value;
                            } else if (logicSet.operaSign == '!=') { //不等于
                                result = preValue != value;
                            } else if (logicSet.operaSign == 'included') { //被包含
                                result = value.indexOf(preValue) > -1;
                            } else if (logicSet.operaSign == 'not included') { //不被包含
                                result = value.indexOf(preValue) == -1;
                            }
                        }
                    } else if (logicSet.valType == 'default') { //缺省值 解析
                        if (this.getValTypeByOperSignType(logicSet.operaSign)) { //多选情况
                            let valueArr = [];
                            (logicSet.value || []).forEach(item => {
                                if (item.indexOf("LOGINUSERDEPT") > -1) {
                                    valueArr.push(Replace.def(this.loginDept, item));
                                } else if (item.indexOf("LOGINUSER") > -1) {
                                    valueArr.push(Replace.def(this.loginUser, item));
                                } else {
                                    let val = this.viewDateFormat(new Date(), 'yyyy-MM-dd');
                                    valueArr.push(val);
                                }
                            });
                            if (logicSet.operaSign == 'includes') { //包含
                                result = preValue.includes(valueArr);
                            } else if (logicSet.operaSign == 'not includes') {
                                result = !preValue.includes(valueArr);
                            }
                        } else {  //单选情况
                            let value = "";
                            if (logicSet.value.indexOf("LOGINUSERDEPT") > -1) {
                                value = Replace.def(this.loginDept, logicSet.value);
                            } else if (logicSet.value.indexOf("LOGINUSER") > -1) {
                                value = Replace.def(this.loginUser, logicSet.value);
                            } else {
                                value = this.viewDateFormat(new Date(), 'yyyy-MM-dd');
                            }
                            if (!value) {
                                return false
                            }
                            if (logicSet.operaSign == '==') { //等于
                                result = preValue == value;
                            } else if (logicSet.operaSign == '!=') { //不等于
                                result = preValue != value;
                            } else if (logicSet.operaSign == 'included') { //被包含
                                result = value.indexOf(preValue) > -1;
                            } else if (logicSet.operaSign == 'not included') { //不被包含
                                result = value.indexOf(preValue) == -1;
                            }
                        }
                    }
                }
            });
            return result;
        },


        /**
         * 顶部按钮执行自定义事件
         * @param fnBody
         * @param params
         * @param args
         */
        async execDiyBtnTopScripts(fnBody) {
            try {
                let serviceName = (window.SERVICE_NAME || {});
                let adminServeName = serviceName.admin || "/admin/";
                let formServeName = serviceName.form || "/form/";
                let flowServeName = serviceName.flow || "/flow/";
                let oaServeName = serviceName.oa || "/oaproject/";
                // fnBody = this.platStringUtil.replaceAll(fnBody, "/admin/", adminServeName);
                // fnBody = this.platStringUtil.replaceAll(fnBody, "/form/", formServeName);
                // fnBody = this.platStringUtil.replaceAll(fnBody, "/flow/", flowServeName);
                // fnBody = this.platStringUtil.replaceAll(fnBody, "/oaproject/", oaServeName);
                // fnBody = this.platStringUtil.replaceAll(fnBody, "/oaadmin/", adminServeName);
                // fnBody = this.platStringUtil.replaceAll(fnBody, "/oaform/", formServeName);
                // fnBody = this.platStringUtil.replaceAll(fnBody, "/oaflow/", flowServeName);
                // if(window.ADMIN_URL && (fnBody.startsWith("/admin/") || fnBody.startsWith("/oaadmin/"))){
                //     fnBody = this.platStringUtil.replaceAll(fnBody,"/admin/", window.ADMIN_URL + "/");
                //     fnBody = this.platStringUtil.replaceAll(fnBody,"/oaadmin/",window.ADMIN_URL + "/");
                // }
                // if(window.FLOW_URL && (fnBody.startsWith("/flow/") || fnBody.startsWith("/oaflow/"))){
                //     fnBody = this.platStringUtil.replaceAll(fnBody,"/flow/", window.FLOW_URL + "/");
                //     fnBody = this.platStringUtil.replaceAll(fnBody,"/oaflow/",window.FLOW_URL + "/");
                // }
                // if(window.FORM_RENDER_URL && (fnBody.startsWith("/form/") || fnBody.startsWith("/oaform/"))){
                //     fnBody = this.platStringUtil.replaceAll(fnBody,"/form/", window.FORM_RENDER_URL + "/");
                //     fnBody = this.platStringUtil.replaceAll(fnBody,"/oaform/",window.FORM_RENDER_URL + "/");
                // }
                fnBody = this.replaceUrlPrefix(fnBody);
                fnBody = fnBody.replace(/\\'/g, "'").replace(/&quot;/g, "\"");
                await new Function('vm,Ajax', fnBody)(this, AjaxUtil);
            } catch (e) {
                console.log("顶部自定义按钮事件执行错误！", e);
            }
        },

        /**extraCondition
         * 行按钮执行自定义事件
         * @param rowData
         */
        async execDiyBtnSelfScripts(fnBody, rowData) {
            try {
                let serviceName = (window.SERVICE_NAME || {});
                let adminServeName = serviceName.admin || "/admin/";
                let formServeName = serviceName.form || "/form/";
                let flowServeName = serviceName.flow || "/flow/";
                let oaServeName = serviceName.oa || "/oaproject/";
                fnBody = this.replaceUrlPrefix(fnBody);
                fnBody = fnBody.replace(/\\'/g, "'").replace(/&quot;/g, "\"");
                await new Function("vm,formData,Ajax,CTX", fnBody)(this, rowData, AjaxUtil, '');
            } catch (e) {
                console.log("行自定义按钮事件执行错误！", e);
            }
        },


        /**
         *  判断pageUrl表单类型
         * @param pageUrl
         * @param type  'tableView'表单 ‘complex'复合视图 'diyPage'自定义页面
         */
        isShow(pageUrl, type) {
            let result = false;
            if (pageUrl) {
                let urlType = pageUrl[0];
                result = urlType == type;
            }
            return result;
        },


        /**
         * 执行自定义按钮 - 常用方法 (openDialog  openNewPage executScript rowCoyOpenTable)
         * @param act 当前动作参数
         * @param actIdArr 动作标志
         * @param actOrderList 动作数据集
         * @param rowData 当前行数据
         * @param resultMap 动作返回值  is true 、 is false
         */
        executDiyBtnMethod(act, actIdArr, actOrderList, rowData, resultMap) {
            let actSetJson = JSON.parse(act.actSetJson || "{}"); //动作
            if (actIdArr[1] == 'openDialog') { //弹出对话框
                let actSetForm = actSetJson.actSetForm;
                if (actSetForm.pageUrl) { //查询表单数据
                    this.openDialogData["pageUrl"] = actSetForm.pageUrl;
                    this.loadViewsData(actSetForm.pageUrl).then(() => {
                        //页面地址
                        this.openDialogData["title"] = actSetForm.headerShowName || '对话框标题';
                        this.openDialogData["dialogHeight"] = actSetForm.dialogHeight || '90%';
                        this.openDialogData["dialogWidth"] = actSetForm.dialogWidth || '90%';

                        //单位
                        if (actSetForm.dialogHeightUnit && this.openDialogData["dialogHeight"].indexOf('%') == -1) {
                            this.openDialogData["dialogHeight"] = this.openDialogData["dialogHeight"] + actSetForm.dialogHeightUnit;
                        }
                        if (actSetForm.dialogWidthUnit && this.openDialogData["dialogWidth"].indexOf('%') == -1) {
                            this.openDialogData["dialogWidth"] = this.openDialogData["dialogWidth"] + actSetForm.dialogWidthUnit;
                        }
                        this.openDialogData["topSpace"] = actSetForm.topSpace || '5vh';
                        this.openDialogData["needCloseBtn"] = actSetForm.needCloseBtn || '0'; //是否显示关闭
                        this.openDialogData["needSaveBtn"] = actSetForm.needSaveBtn || '0'; //是否显示保存按钮
                        if (this.openDialogData["needSaveBtn"] == '1') { //显示保存按钮
                            this.openDialogData["funcBody"] = actSetForm.funcBody || '';
                            this.openDialogData["needSaveBtnName"] = actSetForm.needSaveBtnName || '保存'; //保存按钮名称
                            this.openDialogData["saveRefresh"] = actSetForm.saveRefresh || '0'; //保存后是否刷新
                        }
                        if (this.openDialogData["needCloseBtn"] == '1') { //显示关闭按钮
                            this.openDialogData["needCloseBtnName"] = actSetForm.needCloseBtnName || '关闭'; //关闭按钮名称
                            this.openDialogData["colseRefresh"] = actSetForm.colseRefresh || '0'; //保存后是否刷新
                        }

                        //解析 paramDataArr
                        if (actSetForm.paramDataArr) {
                            let paramObj = {};
                            (actSetForm.paramDataArr || []).forEach(param => {
                                let value = "";
                                if (param.paramKey) {
                                    if (param.paramType == 'default') {
                                        if (param.paramVal.indexOf('loginuser') > -1) {
                                            value = Replace.def(this.loginUser, param.paramVal);
                                        } else if (param.paramVal.indexOf('loginDept') > -1) {
                                            value = Replace.def(this.loginDept, param.paramVal);
                                        }
                                    } else if (param.paramType == 'selectRowId') {
                                        let selection = this.$refs.listViewPreViewRef.selection;
                                        let idArr = this.getSelectionIds(selection);
                                        value = idArr.join(",");
                                    } else if (param.paramType == 'diy') { //自定义
                                        value = param.paramVal || '';
                                        if (value.indexOf("${listOutParam.") > -1) {
                                            value = value.replace("${listOutParam.", ""); // 去除${listOutParam.
                                            value = value.substring(0, value.length - 1); // 去除}
                                            value = (this.listOutParam || {})[value] || "";
                                        }
                                        if (value.indexOf("${parentFormData.") > -1) { //主表单数据
                                            value = value.replace("${parentFormData.", ""); // 去除${listOutParam.
                                            value = value.substring(0, value.length - 1); // 去除}
                                            value = (this.parentFormData || {})[value] || "";
                                        }
                                    } else if (param.paramType == 'sysData' && (param.paramVal || []).length > 1) { //数据字典
                                        value = (this.sysDataObj[param.paramVal[param.paramVal.length - 1]] || {}).id || "";
                                    } else if (param.paramType == 'rowData' && rowData[param.paramVal || '']) { //行数据
                                        value = rowData[param.paramVal || ''];
                                    } else if (param.paramType == 'returnKey') { //返回值key
                                        value = this.tempObj[param.paramVal || ''];
                                    } else if (param.paramType == 'windowData') { //window对象
                                        value = window[param.paramVal];
                                    }
                                    paramObj[param.paramKey] = value;
                                }
                            });
                            //添加内置外部参数
                            if (!rowData) {
                                //将当前选中行最为外部参数
                                paramObj['SELECTION_ARR'] = this.$refs.listViewPreViewRef.selection || []; //默认当前行选中数据
                                this.$set(this.listOutParam, 'SELECTION_ARR', paramObj['SELECTION_ARR']);
                            }
                            this.openDialogData["paramObj"] = paramObj;
                        }

                        if (actSetForm.conditionId) { // 需要过滤条件，设置外部条件过滤
                            this.openDialogData["equilibriumData"] = {"conditionId": actSetForm.conditionId};
                            Object.assign(this.openDialogData["equilibriumData"],
                                this.openDialogData["paramObj"] || {},
                                this.openDialogData["equilibriumData"]);
                        }
                        // 自定义按钮打开弹框 表单里的编辑列表头部按钮 isEditData来控制
                        this.isUpdateData = true;
                        this.logicOpenDialogVisible = true;
                        resultMap[act.actOrder] = "is true";//执行结果赋值
                        this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                    });
                }
            } else if (actIdArr[1] == 'openNewPage') { //执行打开新页面动作
                //打开新页面
                let pageUrl = actSetJson.actSetForm.pageUrl;
                window.open(pageUrl);
                resultMap[act.actOrder] = "is true";//执行结果赋值
                this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
            } else if (actIdArr[1] == 'executScript') { //执行脚本
                let fnBody = actSetJson.actSetForm.executFuncBody;
                let returnKey = actSetJson.actSetForm.returnKey;
                try {
                    let serviceName = (window.SERVICE_NAME || {});
                    let adminServeName = serviceName.admin || "/admin/";
                    let formServeName = serviceName.form || "/form/";
                    let flowServeName = serviceName.flow || "/flow/";
                    let oaServeName = serviceName.oa || "/oaproject/";
                    // fnBody = this.platStringUtil.replaceAll(fnBody, "/admin/", adminServeName);
                    // fnBody = this.platStringUtil.replaceAll(fnBody, "/form/", formServeName);
                    // fnBody = this.platStringUtil.replaceAll(fnBody, "/flow/", flowServeName);
                    // fnBody = this.platStringUtil.replaceAll(fnBody, "/oaproject/", oaServeName);
                    // fnBody = this.platStringUtil.replaceAll(fnBody, "/oaadmin/", adminServeName);
                    // fnBody = this.platStringUtil.replaceAll(fnBody, "/oaform/", formServeName);
                    // fnBody = this.platStringUtil.replaceAll(fnBody, "/oaflow/", flowServeName);

                    fnBody = this.replaceUrlPrefix(fnBody);

                    fnBody = fnBody.replace(/\\'/g, "'").replace(/&quot;/g, "\"");
                    let result = true;
                    if (fnBody.indexOf('return new Promise') == '-1') {
                        result = new Function("vm,formData,Ajax,CTX", fnBody)(this, rowData, AjaxUtil, '');
                        resultMap[act.actOrder] = "is true";//执行结果赋值
                        if (result === false) {
                            resultMap[act.actOrder] = "is false";//执行结果赋值
                            return;
                        }
                        if(result) {
                            this.$set(this.tempObj, returnKey, result);
                        }
                        this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                    } else {
                        new Function("vm,formData,Ajax,CTX", fnBody)(this, rowData, AjaxUtil, '').then(res => {
                            resultMap[act.actOrder] = "is true";//执行结果赋值
                            if (!res) {
                                resultMap[act.actOrder] = "is false";//执行结果赋值
                                return;
                            } else {
                                this.$set(this.tempObj, returnKey, res);
                            }
                            this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                        })
                    }
                } catch (e) {
                    console.log("自定义按钮执行脚本失败！", e);
                }
            } else if (actIdArr[1] == 'rowCoyOpenTable') { //行拷贝打开表单
                let actSetForm = actSetJson.actSetForm;
                let buttonInfo = {buttonType: "update"};
                this.buttonOpt(buttonInfo, this.clickRowData, this.clickRowIndex, "isCopy");
                if (actSetForm.paramDataArr) {
                    this.noCopyArr = [];
                    actSetForm.paramDataArr.forEach(item => {
                        if (item.paramType == "rowData") {
                            this.noCopyArr.push(item.paramVal);
                        }
                    })
                }
                this.dialogTitle = actSetForm.headerShowName || '对话框标题';
                this.isCopyOperate = true;
            } else if (actIdArr[1] === 'switchLoading') { // 遮罩层渲染
                let flag = actSetJson.actSetForm.loadingSwitch === '0';
                this.loadingSwitch = this.diySwitch();
                this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap);
                if(flag) {
                    this.loadingSwitch && this.loadingSwitch.close();
                }
            }

        },

        diySwitch() {
            if (this.loadingSwitch && Object.keys(this.loadingSwitch).length > 0) {
                this.loadingSwitch.close();
            } else {
                this.loadingSwitch = this.$loading({
                    lock: true,
                    text: '正在加载请稍后....',
                    spinner: 'el-icon-loading',
                    background: 'rgba(0, 0, 0, 0.7)'
                });
                return this.loadingSwitch;
            }
        },

        closeLoadingSwitch() {
            this.loadingSwitch && this.loadingSwitch.close();
        },

        /**
         * 执行自定义按钮 - 校验 (远程数据校验，基础数据校验)
         * @param act 当前动作参数
         * @param actIdArr 动作标志
         * @param actOrderList 动作数据集
         * @param rowData 当前行数据
         * @param resultMap 动作返回值
         */
        executDiyBtnCheck(act, actIdArr, actOrderList, rowData, resultMap) {
            let result = "is false";
            let actSetJson = JSON.parse(act.actSetJson || "{}"); //动作
            let actSetForm = actSetJson.actSetForm;
            let actSetArr = actSetJson.actSetArr || [];
            if (actIdArr[1] == 'remoteCheck') { //执行远程数据校验
                if (!actSetForm.reqUrl) {
                    resultMap[act.actOrder] = result;//执行结果赋值
                    this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                    return;
                }
                let paramArr = actSetForm.paramSetting || [];//参数
                let reqUrl = actSetForm.reqUrl; //请求路径
                let reqParam = {};
                paramArr.forEach(param => {
                    if (param.paramName) {
                        if (param.paramValType == 'default') {  //系统默认值
                            if (param.value.indexOf("LOGINUSERDEPT") > -1) {
                                param.value = Replace.def(this.loginDept, param.value);
                            } else if (param.value.indexOf("LOGINUSER") > -1) {
                                param.value = Replace.def(this.loginUser, param.value);
                            } else {
                                param.value = this.viewDateFormat(new Date(), 'yyyy-MM-dd');
                            }
                        } else if (param.paramValType == 'rowData') { //行数据
                            if (rowData[param.value]) {
                                param.value = rowData[param.value]; //行数据值
                            }
                        } else if (param.paramValType == 'stepVal' && resultMap[param.value]) { //多少步的值
                            //获取多少步的值
                            if (resultMap[param.value] == 'is true') {
                                param.value = true;
                            } else if (resultMap[param.value] == 'is false') {
                                param.value = false;
                            } else {
                                param.value = resultMap[param.value]; //行数据值
                            }
                        }
                        reqParam[param.paramName] = param.value;
                    }
                });
                //加载远程数据链接
                this.executRemoteUrl(reqUrl, reqParam).then(res => {
                    if (res && res.data) {
                        if (actSetJson.valueParse == 'sys') {
                            result = this.compareSysCheck(res.data, actSetForm, rowData);
                        } else if (actSetJson.valueParse == 'manual') { //执行手动解析
                            let scriptResult = this.compareManualCheck(res.data, rowData, actSetForm.manualScript);
                            if (scriptResult) {
                                result = "is true";
                            } else {
                                result = "is false";
                            }
                        }
                        resultMap[act.actOrder] = result;//执行结果赋值
                        this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                    }
                }, error => {
                    console.log("接口请求异常", error);
                    this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                });
            } else if (actIdArr[1] == 'basicCheck') { //执行基础数据校验
                this.compareBasicCheck(rowData, actSetForm, actSetArr, actOrderList, act, resultMap);
            }
        },


        /**
         * 远程数据校验 - 执行系统校验
         * @param resData 返回值
         * @param actSetForm 动作配置
         * @param rowData 行数据
         */
        compareSysCheck(resData, actSetForm, rowData) {
            let result = "is false";
            //值类型
            if (resData.constructor == Array) { //返回值类型为数组
                if (actSetForm.retValType == 'array') { //返回值类型为数组
                    if (actSetForm.checkRule == 'notEmpty') { //非空校验
                        result = resData.length == 0 ? 'is false' : 'is true';
                    } else if (actSetForm.checkRule == 'arraySize') { //数组长度校验
                        result = resData.length == actSetForm.arraySize ? 'is true' : 'is false';
                    } else if (actSetForm.checkRule == 'include' || actSetForm.checkRule == 'notInclude') {
                        if (actSetForm.valType == 'default' || actSetForm.valType == 'formField') { //缺省值或者表单字段
                            //根据值类型进行解析
                            let valueArr = [];
                            if (actSetForm.valType == 'default') { //缺省值
                                (actSetForm.value || []).forEach(value => {
                                    if (actSetForm.value.indexOf("LOGINUSERDEPT") > -1) {
                                        valueArr.push(Replace.def(this.loginDept, value));
                                    } else if (actSetForm.value.indexOf("LOGINUSER") > -1) {
                                        valueArr.push(Replace.def(this.loginUser, value));
                                    } else {
                                        let val = this.viewDateFormat(new Date(), 'yyyy-MM-dd');
                                        valueArr.push(val);
                                    }
                                });
                            } else if (actSetForm.valType == 'formField' && !this.isEmptyObject(rowData)) { //表单字段
                                (actSetForm.value || []).forEach(value => {
                                    if (rowData[value]) {
                                        valueArr.push(rowData[value]);
                                    }
                                });
                            }
                            if (actSetForm.checkRule == 'include') {
                                result = resData.includes(valueArr) ? 'is true' : 'is false';
                            } else {
                                result = !resData.includes(valueArr) ? 'is true' : 'is false';
                            }
                        } else { //数据字典和常数
                            if (actSetForm.checkRule == 'include') {
                                result = resData.includes(actSetForm.value) ? 'is true' : 'is false';
                            } else {
                                result = !resData.includes(actSetForm.value) ? 'is true' : 'is false';
                            }
                        }
                    }
                }
            } else if (resData.constructor == Object) { //返回值类型是对象
                if (actSetForm.retValType == 'object') {
                    let keyArr = Object.keys(resData || {});
                    if (actSetForm.checkRule == 'notEmpty') { //非空校验
                        result = keyArr.length == 0 ? 'is false' : 'is true';
                    } else if (actSetForm.checkRule == 'keySize') {
                        result = keyArr.length == actSetForm.keySize ? 'is false' : 'is true';
                    } else if (actSetForm.checkRule == 'keyInclude' || actSetForm.checkRule == 'keyNotInclude') {
                        if (actSetForm.valType == 'default' || actSetForm.valType == 'formField') { //缺省值或者表单字段
                            //根据值类型进行解析
                            let valueArr = [];
                            if (actSetForm.valType == 'default') { //缺省值
                                (actSetForm.value || []).forEach(value => {
                                    if (actSetForm.value.indexOf("LOGINUSERDEPT") > -1) {
                                        valueArr.push(Replace.def(this.loginDept, value));
                                    } else if (actSetForm.value.indexOf("LOGINUSER") > -1) {
                                        valueArr.push(Replace.def(this.loginUser, value));
                                    } else {
                                        let val = this.viewDateFormat(new Date(), 'yyyy-MM-dd');
                                        valueArr.push(val);
                                    }
                                });
                            } else if (actSetForm.valType == 'formField' && !this.isEmptyObject(rowData)) { //表单字段
                                (actSetForm.value || []).forEach(value => {
                                    if (rowData[value]) {
                                        valueArr.push(rowData[value]);
                                    }
                                });
                            }
                            if (actSetForm.checkRule == 'keyInclude') {
                                result = keyArr.includes(valueArr) ? 'is true' : 'is false';
                            } else {
                                result = !keyArr.includes(valueArr) ? 'is true' : 'is false';
                            }
                        } else { //数据字典和常数
                            if (actSetForm.checkRule == 'keyInclude') {
                                result = keyArr.includes(actSetForm.value) ? 'is true' : 'is false';
                            } else {
                                result = !keyArr.includes(actSetForm.value) ? 'is true' : 'is false';
                            }
                        }
                    }
                }
            } else if (resData.constructor == String && actSetForm.retValType == 'constant') { //返回值类型是常数
                //返回值类型为数组
                if (actSetForm.checkRule == 'notEmpty') { //非空校验
                    result = resData.length == 0 ? 'is false' : 'is true';
                } else if (actSetForm.checkRule == 'include') {
                    result = resData.includes(actSetForm.value) ? 'is true' : 'is false';
                } else if (actSetForm.checkRule == 'notInclude') {
                    result = !resData.includes(actSetForm.value) ? 'is true' : 'is false';
                } else if (actSetForm.checkRule == 'equal') {
                    result = resData == actSetForm.value ? 'is true' : 'is false';
                } else if (actSetForm.checkRule == 'notEqual') {
                    result = resData != actSetForm.value ? 'is true' : 'is false';
                }
            }
            return result;
        },

        /**
         * 远程数据校验 - 执行手动校验
         * @param resData 返回值
         * @param rowData 行数据
         * @param manualScript 脚本
         */
        compareManualCheck(resData, rowData, manualScript) {
            let result = false;
            try {
                let serviceName = (window.SERVICE_NAME || {});
                let adminServeName = serviceName.admin || "/admin/";
                let formServeName = serviceName.form || "/form/";
                let flowServeName = serviceName.flow || "/flow/";
                let oaServeName = serviceName.oa || "/oaproject/";
                // manualScript = this.platStringUtil.replaceAll(manualScript, "/admin/", adminServeName);
                // manualScript = this.platStringUtil.replaceAll(manualScript, "/form/", formServeName);
                // manualScript = this.platStringUtil.replaceAll(manualScript, "/flow/", flowServeName);
                // manualScript = this.platStringUtil.replaceAll(manualScript, "/oaproject/", oaServeName);
                // manualScript = this.platStringUtil.replaceAll(manualScript, "/oaadmin/", adminServeName);
                // manualScript = this.platStringUtil.replaceAll(manualScript, "/oaform/", formServeName);
                // manualScript = this.platStringUtil.replaceAll(manualScript, "/oaflow/", flowServeName);

                manualScript = this.replaceUrlPrefix(manualScript);

                manualScript = manualScript.replace(/\\'/g, "'").replace(/&quot;/g, "\"");
                let diyfunc = new Function("vm,formData,resData", manualScript);
                result = diyfunc(this, rowData, resData);
            } catch (e) {
                console.log("执行手动校验失败！", e);
            }
            return result;
        },

        /**
         * 基础数据校验 (解析条件,执行脚本)
         *
         */
        async compareBasicCheck(rowData, actSetForm, actSetArr, actOrderList, act, resultMap) {
            let result = "is false";
            let funcStr = "";
            let selection = [];
            let selectValArr = [];
            let operSignArr = ["==", "!=", "includes"]; //操作符
            let falg = true;
            if (this.isEmptyObject(rowData)) {
                //当前行为空
                //获取当前选中数据
                selection = this.$refs.listViewPreViewRef.selection || [];  //获取当前选中行数据
                if ((selection || []).length == 0) {
                    this.$message("请至少选择一条数据！");
                    falg = false;
                }
                let idArr = [];
                selection.forEach(select => {
                    let keyArr = Object.keys(select);
                    keyArr.forEach(key => {
                        let field = key.split("_")[0];
                        if (field == 'ID') {
                            idArr.push(select[key]);
                        }
                    });
                });
                for (const id of idArr) {
                    let res = await this.spcpFormAxios.post(this.api.plCommonmethod.getById, {
                        formId: this.formId,
                        dataId: id,
                        listViewId: this.listViewId
                    });
                    if (res && res.data) {
                        let row = {};
                        res.data.operateObj.forEach(obj => {
                            row = Object.assign(row, obj);
                        });
                        selectValArr.push(row);
                    }
                }
            }
            if (!falg) {
                // resultMap[act.actOrder] = result;//执行结果赋值
                // this.logicSetBtnAct(actOrderList[act.actOrder],actOrderList,rowData,resultMap); //回调执行
                return;
            }
            actSetArr.forEach(setItem => {
                //左链接符解析
                if (setItem.connectSignLeft == "AND") {
                    funcStr += " && ";
                } else if (setItem.connectSignLeft == "OR") {
                    funcStr += " || ";
                } else if (setItem.connectSignLeft == '(') {
                    funcStr += " ( ";
                } else if (setItem.connectSignLeft == 'AND (') {
                    funcStr += "  && ( ";
                } else if (setItem.connectSignLeft == 'OR (') {
                    funcStr += "  || ( ";
                }
                //解析表单字段 解析
                if (setItem.operaSign != 'included' && setItem.operaSign != 'not included') { //被包含和不被包含
                    funcStr = this.spliceFunField(selectValArr, rowData, setItem, funcStr);
                }
                //解析操作符 和 值
                if (setItem.operaSign == '==' || setItem.operaSign == '!=') { //操作符
                    funcStr += setItem.operaSign + " ";
                    funcStr = this.spliceFunValue(selectValArr, rowData, setItem, funcStr);
                } else if (setItem.operaSign == 'includes' || setItem.operaSign == 'not includes') {//包含与不包含
                    funcStr += ".includes( ";
                    funcStr = this.spliceFunValue(selectValArr, rowData, setItem, funcStr);
                    funcStr += " ) ";
                    if (setItem.operaSign == 'includes') {
                        funcStr += " == true "; //包含
                    } else {
                        funcStr += " == false "; //被包含
                    }
                } else if (setItem.operaSign == 'included' || setItem.operaSign == 'not included') {//被包含与不被包含
                    funcStr = this.spliceFunValue(selectValArr, rowData, setItem, funcStr); //值
                    funcStr += ".includes( ";
                    funcStr = this.spliceFunField(selectValArr, rowData, setItem, funcStr);
                    if (setItem.operaSign == 'included') {
                        funcStr += " == true "; //被包含
                    } else {
                        funcStr += " == false "; //不被包含
                    }
                }

                //解析右括号
                if (setItem.connectSignRight) {
                    funcStr += " " + setItem.connectSignRight + " ";
                }
            });
            let funcScript = "let result = false;" + "\n";
            funcScript += "result = " + funcStr + "\n";
            funcScript += "return result;";

            //判断 funcScript 是否存在操作符
            let funcFlag = false;
            operSignArr.some(operSign => {
                if (funcScript.indexOf(operSign) > -1) {
                    funcFlag = true;
                    return;
                }
            });
            console.log("校验脚本", funcScript);
            if (funcFlag && funcScript) {
                try {
                    if (new Function(funcScript)()) {
                        result = "is true";
                    }
                } catch (e) {
                    console.log("校验脚本执行失败！", e);
                }
            }
            resultMap[act.actOrder] = result;//执行结果赋值
            this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
        },


        /**
         * 拼接字段
         */
        spliceFunField(selectValArr, rowData, setItem, funcStr) {
            if (!this.isEmptyObject(rowData)) { //行按钮
                if (rowData[setItem.fieldId]) {
                    funcStr += " '" + rowData[setItem.fieldId] + "' ";
                }
            } else {  //头部数据用逗号拼接
                let fieldValue = [];
                selectValArr.forEach(item => {
                    if (item[setItem.fieldId]) {
                        fieldValue.push(item[setItem.fieldId]);
                    }
                });
                if (fieldValue.length > 0) {
                    funcStr += " '" + fieldValue.join(",") + "' ";
                }
            }
            return funcStr;
        },

        /**
         * 拼接值
         */
        spliceFunValue(selectValArr, rowData, setItem, funcStr) {
            //值类型判断
            if (setItem.valType == 'default') { //缺省值
                if (setItem.value) {
                    if (setItem.value.indexOf("LOGINUSERDEPT") > -1) {
                        funcStr += " '" + Replace.def(this.loginDept, setItem.value) + "' ";
                    } else if (setItem.value.indexOf("LOGINUSER") > -1) {
                        funcStr += " '" + Replace.def(this.loginUser, setItem.value) + "' ";
                    } else {
                        funcStr += " '" + this.viewDateFormat(new Date(), 'yyyy-MM-dd') + "' ";
                    }
                }
            } else if (setItem.valType == 'constant' || setItem.valType == 'sysData') { //常数或者数据字典
                let value = setItem.value;
                if (setItem.valType == 'sysData' && setItem.value) { //处理数据字典类型
                    let valDataArr = setItem.value || [];
                    value = valDataArr[valDataArr.length - 1] || '';
                }
                funcStr += " '" + value + "' ";
            } else if (setItem.valType == 'formField') { //表单字段
                //解析字段
                if (!this.isEmptyObject(rowData)) {
                    if (rowData[setItem.value]) {
                        funcStr += " '" + rowData[setItem.value] + "' ";
                    }
                } else {
                    let valueArr = [];
                    selectValArr.forEach(item => {
                        if (item[setItem.value]) {
                            valueArr.push(item[setItem.value]);
                        }
                    });
                    if (valueArr.length > 0) {
                        funcStr += " '" + valueArr.join(",") + "' ";
                    }

                }

            }

            return funcStr;
        },


        /**
         * 执行自定义按钮 - 数据绑定 (远程数据校验，基础数据校验)
         * @param act 当前动作参数
         * @param actIdArr 动作标志
         * @param actOrderList 动作数据集
         * @param rowData 当前行数据
         * @param resultMap 动作返回值
         */
        async executDiyBtnBing(act, actIdArr, actOrderList, rowData, resultMap) {
            let actSetJson = JSON.parse(act.actSetJson || "{}"); //动作
            let actSetForm = actSetJson.actSetForm || {};
            resultMap[act.actOrder] = null;
            if (actIdArr[1] == 'remoteBinding') { //执行远程数据绑定
                let actSetForm = actSetJson.actSetForm;
                let paramArr = actSetForm.paramSetting || [];//参数
                let reqUrl = actSetForm.reqUrl; //请求路径
                let reqParam = {};
                paramArr.forEach(param => {
                    if (param.paramName) {
                        if (param.paramValType == 'default') {  //系统默认值
                            if (param.value.indexOf("LOGINUSERDEPT") > -1) {
                                param.value = Replace.def(this.loginDept, param.value);
                            } else if (param.value.indexOf("LOGINUSER") > -1) {
                                param.value = Replace.def(this.loginUser, param.value);
                            }
                        } else if (param.paramValType == 'rowData') { //行数据
                            if (rowData[param.value]) {
                                param.value = rowData[param.value]; //行数据值
                            }
                        } else if (param.paramValType == 'stepVal' && resultMap[param.value]) { //多少步的值
                            //获取多少步的值
                            if (resultMap[param.value] == 'is true') {
                                param.value = true;
                            } else if (resultMap[param.value] == 'is false') {
                                param.value = false;
                            } else {
                                param.value = resultMap[param.value]; //行数据值
                            }
                        }
                        reqParam[param.paramName] = param.value;
                    }
                });
                if (reqUrl) {
                    this.executRemoteUrl(reqUrl, reqParam).then(ret => { //执行请求地址
                        if (ret && ret.data) {
                            resultMap[act.actOrder] = ret.data; //返回值赋值
                        }
                        this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap);
                    }, error => {
                        console.log("接口请求异常", error);
                    });
                }
            } else if (actIdArr[1] == 'localBinding') { //执行本地数据绑定
                if (actSetForm.value) {
                    //判断当前
                    if (this.isEmptyObject(rowData)) { //头部按钮
                        if (actSetForm.value.indexOf("LOGINUSERDEPT") > -1) {
                            resultMap[act.actOrder] = Replace.def(this.loginDept, actSetForm.value); //赋值
                        } else if (actSetForm.value.indexOf("LOGINUSER") > -1) {
                            resultMap[act.actOrder] = Replace.def(this.loginUser, actSetForm.value); //赋值
                        } else {
                            let selection = this.$refs.listViewPreViewRef.selection || [];  //获取当前选中行数据
                            if ((selection || []).length == 0) {
                                this.$message("请至少选择一条数据！");
                            }
                            let idArr = [];
                            let valueArr = []; //选中行数据
                            selection.forEach(item => {
                                let keyArr = Object.keys(item);
                                keyArr.forEach(key => {
                                    let field = key.split("_")[0];
                                    if (field == 'ID') {
                                        idArr.push(item[key]);
                                    }
                                });
                            });
                            for (const id of idArr) {
                                let res = await this.spcpFormAxios.post(this.api.plCommonmethod.getById, {
                                    formId: this.formId,
                                    dataId: id,
                                    listViewId: this.listViewId
                                });
                                if (res && res.data) {
                                    let rowData = {};
                                    res.data.operateObj.forEach(obj => {
                                        rowData = {...rowData, ...obj};
                                    });
                                    if (rowData[actSetForm.value]) {
                                        valueArr.push(rowData[actSetForm.value]);
                                    }
                                }

                            }
                            resultMap[act.actOrder] = valueArr; //赋值当前动作的值
                        }
                    } else {
                        if (actSetForm.value.indexOf("LOGINUSERDEPT") > -1) {
                            resultMap[act.actOrder] = Replace.def(this.loginDept, actSetForm.value); //赋值
                        } else if (actSetForm.value.indexOf("LOGINUSER") > -1) {
                            resultMap[act.actOrder] = Replace.def(this.loginUser, actSetForm.value); //赋值
                        } else {
                            resultMap[act.actOrder] = rowData[actSetForm.value];
                        }
                    }
                }
                this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
            }


        },

        /**
         * 执行自定义按钮 - 提示信息 (系统新增，修改，删除)
         * @param act 当前动作参数
         * @param actIdArr 动作标志
         * @param actOrderList 动作数据集
         * @param rowData 当前行数据
         * @param resultMap 动作返回值
         */
        executDiyBtnInfo(act, actIdArr, actOrderList, rowData, resultMap) {
            let actSetJson = JSON.parse(act.actSetJson || "{}"); //动作
            let confirmText = actSetJson.actSetForm.confirmText; //显示文本
            let messageType = actSetJson.actSetForm.messageType; //类型
            resultMap[act.actOrder] = "is false";//执行结果默认值
            if (actIdArr[1] == 'confirm') {
                this.$confirm(confirmText, '警告', {
                    confirmButtonText: '确定',
                    cancelButtonText: '取消',
                    type: messageType
                }).then(async () => {
                    resultMap[act.actOrder] = "is true"; //取消返回值为false
                    this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                }).catch(async () => {
                    resultMap[act.actOrder] = "is false"; //取消返回值为false
                    this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                });
            } else if (actIdArr[1] == 'alert') {
                this.$notify({
                    message: confirmText
                });
                resultMap[act.actOrder] = "is true";//执行结果赋值
                this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
            } else if (actIdArr[1] == 'message') {
                this.$message({
                    message: confirmText,
                    type: messageType
                });
                resultMap[act.actOrder] = "is true";//执行结果赋值
                this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
            }
        },


        /**
         * 执行自定义按钮 - 数据表操作 (表修改，新增，删除)
         * @param act 当前动作参数
         * @param actIdArr 动作标志
         * @param actOrderList 动作数据集
         * @param rowData 当前行数据
         * @param resultMap 动作返回值
         */
        async executDiyBtnDataOperate(act, actIdArr, actOrderList, rowData, resultMap) {
            let actSetJson = JSON.parse(act.actSetJson || "{}"); //动作
            let actSetForm = actSetJson.actSetForm;
            let formId = actSetForm.formId;
            resultMap[act.actOrder] = "is false";//执行结果默认值
            if (!formId) {
                this.$message({
                    message: "视图名称不能为空！",
                    type: 'error',
                    duration: 1000
                });
                return;
            }
            //根据 formId查询 formBase 和 formField
            let fieldRes = await this.spcpFormAxios.post(this.api.plFormField.find, {
                formId: formId,
                status: '1',
                order: 'FIELD_ORDER'
            });
            if (fieldRes && fieldRes.data) {
                fieldRes.data.forEach(item => {
                    this.formListFiledObj[item.id] = {
                        chfieldName: item.chfieldName,
                        phyfieldName: item.phyfieldName,
                        id: item.id
                    };
                });
            }
            if (actIdArr[1] == 'formUpdate') { //表数据更新
                let whereConditionArr = actSetForm.whereConditionArr || []; //where条件
                let setConditionArr = actSetForm.setConditionArr || [];
                let param = this.parsDiyButtonDataOperate("update", whereConditionArr, setConditionArr, rowData);
                let res = await this.spcpFormAxios.post(this.api.plCommonmethod.update, {
                    formId: formId,
                    paramSql: param["whereSql"],
                    updateParams: JSON.stringify(param["setParam"])
                });
                if (res.data && res.data.operateSuccess) {
                    this.$message({
                        duration: 1000,
                        type: "success",
                        message: "修改数据成功!"
                    });
                    resultMap[act.actOrder] = "is true"; //添加成功
                }
            } else if (actIdArr[1] == 'formAdd') { //表数据新增
                let setConditionArr = actSetForm.setConditionArr || [];
                let params = this.parsDiyButtonDataOperate("insert", null, setConditionArr, rowData);
                let res = await this.spcpFormAxios.post(this.api.plCommonmethod.insert, {
                    formId: formId,
                    params: JSON.stringify(params)
                });
                if (res.data && res.data.operateSuccess) {
                    this.$message({
                        duration: 1000,
                        type: "success",
                        message: "新增数据成功!"
                    });
                    resultMap[act.actOrder] = "is true"; //添加成功
                }
            } else if (actIdArr[1] == 'formRemove') { //删除表数据
                let whereConditionArr = actSetForm.whereConditionArr || []; //where条件
                let whereSql = this.parsDiyButtonDataOperate("delete", whereConditionArr, null, rowData);
                let res = await this.spcpFormAxios.post(this.api.plCommonmethod.deleteByParam, {
                    formId: formId,
                    paramSql: whereSql
                });
                if (res.data && res.data.operateSuccess) {
                    this.$message({
                        duration: 1000,
                        type: "success",
                        message: "删除数据成功!"
                    });
                    resultMap[act.actOrder] = "is true"; //添加成功

                }
            }
            this.search();
            this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行下一步
        },

        /**
         * 执行自定义按钮 - 系统类型事件 (系统新增，修改，删除，回调方法)
         * @param act 当前动作参数
         * @param actIdArr 动作标志
         * @param actOrderList 动作数据集
         * @param rowData 当前行数据
         * @param resultMap 动作返回值
         */
        async executDiyBtnSysMethod(act, actIdArr, actOrderList, rowData, resultMap) {
            let actSetJson = JSON.parse(act.actSetJson || "{}"); //动作
            let actSetForm = actSetJson.actSetForm;
            let rowId = '';
            if (!this.isEmptyObject(rowData)) {
                rowId = rowData["ID"];
            }
            if (actIdArr[1] == 'openAddPage' || actIdArr[1] == 'openUpdatePage') { //打开系统添加页面
                this.currentButtonType = actIdArr[1] == 'openAddPage' ? 'add' : 'update'; //判断当前执行类型
                this.dialogTitle = this.currentButtonType == 'add' ? '添加' : '修改';
                await this.defaultButtonFunc(this.currentButtonType); //数据预处理
                if (this.currentButtonType == 'update') { //根据id查询当前行数据
                    this.contentForm = rowData;
                    this.isUpdateData = true;
                }
                if (actSetForm && actSetForm.headerShowName) {
                    this.dialogTitle = actSetForm.headerShowName;
                }

                //解析 paramDataArr
                if (actSetForm.paramDataArr) {
                    let paramObj = {};
                    (actSetForm.paramDataArr || []).forEach(param => {
                        let value = "";
                        if (param.paramKey) {
                            if (param.paramType == 'default') {
                                if (param.paramVal.indexOf('loginuser') > -1) {
                                    value = Replace.def(this.loginUser, param.paramVal);
                                } else if (param.paramVal.indexOf('loginDept') > -1) {
                                    value = Replace.def(this.loginDept, param.paramVal);
                                }
                            } else if (param.paramType == 'selectRowId') {
                                let selection = this.$refs.listViewPreViewRef.selection;
                                let idArr = this.getSelectionIds(selection);
                                value = idArr.join(",");
                            } else if (param.paramType == 'diy') { //自定义
                                value = param.paramVal || '';
                                if (value.indexOf("${listOutParam.") > -1) {
                                    value = value.replace("${listOutParam.", ""); // 去除${listOutParam.
                                    value = value.substring(0, value.length - 1); // 去除}
                                    value = (this.listOutParam || {})[value] || "";
                                }
                                if (value.indexOf("${parentFormData.") > -1) { //主表单数据
                                    value = value.replace("${parentFormData.", ""); // 去除${listOutParam.
                                    value = value.substring(0, value.length - 1); // 去除}
                                    value = (this.parentFormData || {})[value] || "";
                                }
                            } else if (param.paramType == 'sysData' && (param.paramVal || []).length > 1) { //数据字典
                                value = (this.sysDataObj[param.paramVal[param.paramVal.length - 1]] || {}).id || "";
                            } else if (param.paramType == 'rowData' && rowData[param.paramVal || '']) { //行数据
                                value = rowData[param.paramVal || ''];
                            }
                            paramObj[param.paramKey] = value;
                        }
                    });
                    // if (Object.keys(paramObj).length>0) {
                    this.$set(this.openDialogData,'paramObj',paramObj);
                        // this.openDialogData["paramObj"] = paramObj;
                    // }
                }
                this.optDataDialog = true;
                resultMap[act.actOrder] = "is true"; //取消返回值为false
                this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
            } else if (actIdArr[1] == 'sysRemoveMethod') { //执行系统删除 (顶部获取选中列,行指定数据)
                resultMap[act.actOrder] = "is false";//执行结果赋值
                if (!rowId) { //行数据为空
                    let selection = this.$refs.listViewPreViewRef.selection || [];
                    if ((selection || []).length == 0) {
                        this.$message("请至少选择一条需要删除的数据！");
                        this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                        return;
                    }
                    this.$confirm('是否确定删除选择的“' + selection.length + '”条数据?', '警告', {
                        confirmButtonText: '确定',
                        cancelButtonText: '取消',
                    }).then(async () => {
                        //执行逻辑删除
                        let delteIdArr = this.getSelectionIds(selection);
                        // let dataRes = await this.spcpFormAxios.post("plCommonMethodController/logicDelete",
                        //     {formId:this.formId,dataIds:delteIdArr.join(",")});
                        let dataRes = await this.spcpFormAxios.post(this.api.plCommonmethod.delete,
                            {formId: this.formId, dataIds: delteIdArr.join(",")});
                        if (dataRes && dataRes.data) {
                            this.$message({
                                duration: 1000,
                                type: "success",
                                message: "删除成功!"
                            });
                            resultMap[act.actOrder] = "is true"; //取消返回值为false
                        }
                        this.initData2();
                        this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                    }).catch(async () => {
                        resultMap[act.actOrder] = "is false"; //取消返回值为false
                        this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                    });

                } else { //根据行数据删除
                    this.$confirm('是否确定删除当前行数据', '警告', {
                        confirmButtonText: '确定',
                        cancelButtonText: '取消',
                    }).then(async () => {
                        // let dataRes = await this.spcpFormAxios.post("plCommonMethodController/logicDelete",
                        //     {formId:this.formId,dataIds:rowId});
                        let dataRes = await this.spcpFormAxios.post(this.api.plCommonmethod.delete,
                            {formId: this.formId, dataIds: rowId});
                        if (dataRes && dataRes.data) {
                            this.$message({
                                duration: 1000,
                                type: "success",
                                message: "删除成功!"
                            });
                            resultMap[act.actOrder] = "is true"; //取消返回值为false
                        }
                        this.initData2();
                        this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                    }).catch(async () => {
                        resultMap[act.actOrder] = "is false"; //取消返回值为false
                        this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
                    });

                }
            } else if (actIdArr[1] == 'sysCallbackMethod') { //执行系统回调方法
                resultMap[act.actOrder] = "is false";//执行结果赋值
                //获取配置信息
                if (actSetForm.callbackMethodName && this[actSetForm.callbackMethodName]) {
                    this[actSetForm.callbackMethodName](this);
                }
                resultMap[act.actOrder] = "is true";//执行结果赋值
                this.logicSetBtnAct(actOrderList[act.actOrder], actOrderList, rowData, resultMap); //回调执行
            }
        },

        /**
         * 查询表单数据
         * @param pageUrlArr
         * @returns {Promise<void>}
         */
        async loadViewsData(pageUrlArr) {
            this.contentArr = [];
            this.contentAllObj = {};
            let length = pageUrlArr.length;
            let viewId = pageUrlArr[length - 1];
            let formId = pageUrlArr[length - 2];
            this.oldTableViewData = JSON.parse(JSON.stringify(this.tableViewData)); //原表单对象备用
            if (pageUrlArr[0] == 'tableView') { //自定义表单
                let tableViewRef = await this.spcpFormAxios.post(this.api.plTableviews.getById, {id: viewId});
                if (tableViewRef && tableViewRef.data) {
                    this.tableViewData = tableViewRef.data;
                    let controlRef = await this.spcpFormAxios.post(this.api.plControlConfig.find,
                        {"tviewId": this.tableViewData.id, "order": "FIELD_ORDER ASC"});
                    if (controlRef && controlRef.data) {
                        controlRef.data.forEach(item => {
                            item.specialSet = JSON.parse(item.specialSet || "{}");
                        });
                        this.contentArr = controlRef.data || [];
                        this.dealTableViewData();
                    }
                    this.openDialogData["formId"] = formId;
                    this.openDialogData["tableViewId"] = viewId;
                }
            } else if (pageUrlArr[0] == 'diyPage') { //自定义页面
                //查询复合视图
                let res = null;
                // await this.spcpFormAxios.post(this.api.sysFunction.getById,{id:viewId});
                res = await this.spcpFormAxios.post(this.api.resources.findResources, {id: viewId});
                let componentUrl = '';
                if (res.data && res.data.operateObj && res.data.operateObj.length > 0) {
                    componentUrl = res.data.operateObj[0].ragentUrl;
                }
                if (componentUrl) {
                    this.getIndex(componentUrl); //格式化获取  componentUrl
                }
                //
            } else if (pageUrlArr[0] == 'complex') { //复合视图
                let res = null;
                res = await this.spcpFormAxios.post(this.api.resources.findResources, {
                    'rSource': 'cview',
                    'rStatus': '1',
                    'rKey': viewId
                }); //获取绑定资源数据
                if (res.data && res.data.operateObj && res.data.operateObj.length > 0) {
                    let obj = res.data.operateObj[0];
                    let operatePermisArr = obj.operatePermisList || [];
                    let dataPermisArr = obj.dataPermisList || [];
                    let operateIdArr = [];
                    let dataIdArr = [];
                    operatePermisArr.forEach(item => {
                        operateIdArr.push(item.id);
                    });
                    dataPermisArr.forEach(item => {
                        dataIdArr.push(item.id);
                    })
                    //解析 operatePermis 和 dataPermis
                    this.openDialogData["resouceId"] = obj.id;
                    this.openDialogData["operatePermis"] = operateIdArr.join(",");
                    this.openDialogData["dataPermis"] = dataIdArr.join(",");
                }
            } else if (pageUrlArr[0] == 'listView') { //表单
                let res = null;
                res = await this.spcpFormAxios.post(this.api.plListCondition.find, {formId: formId, listViewId: viewId});
                if (res && res.data) {
                    let conditionArr = res.data || [];
                    let arr = [];
                    conditionArr.forEach(item => {
                        arr.push(item.id);
                    });
                    //解析 operatePermis 和 dataPermis
                    this.openDialogData["conditionId"] = arr.join(","); //数据权限
                }
                this.openDialogData["formId"] = formId;
                this.openDialogData["listViewId"] = viewId;
            }
        },


        /**
         * 获取自定义页面路径
         */
        getIndex(componentUrl) {
            if (!componentUrl) {
                return;
            }
            let index = componentUrl.indexOf(".vue");
            if (index > -1) {
                componentUrl = componentUrl.substring(0, index);
            }
            if (componentUrl.indexOf("/") == 0) {
                componentUrl = componentUrl.substring(1);
            }
            let urlArr = componentUrl.split("/");
            let allRouterArr = this.$router.options.routes || [];
            this.eachRouterSet(allRouterArr, urlArr, -1);
        },

        /**
         * 遍历
         * @param allRouterArr
         * @param urlArr
         * @param index
         */
        eachRouterSet(allRouterArr, urlArr, index) {
            allRouterArr.forEach(item => {
                if (urlArr[index + 1] && ((urlArr[index + 1] == (item.name ? item.name : item.path)) || ((item.name ? item.name : item.path)).indexOf(urlArr[index + 1] + "/:") > -1)) {
                    //当前匹配
                    //判断 urlArr是否存在下级
                    if (item.children && item.children.length > 0) {
                        //如果存在下级
                        allRouterArr = item.children || [];
                        index = index + 1;
                        this.eachRouterSet(allRouterArr, urlArr, index);
                    } else {
                        this.componentIndex = item.component;
                    }
                }
            })
        },

        /**
         *  执行url 和参数
         * @param url 参数url
         * @param param 请求参数
         */
        executRemoteUrl(url, param) {
            return new Promise(resolve => {
                let res = this.spcpFormAxios.post(url, param);
                resolve(res);
            });
        },

        /**
         * 根据操作符类型判断值类型是否多选
         */
        getValTypeByOperSignType(operSign) {
            let isMuilti = false;
            if (operSign == 'includes' || operSign == 'not includes') { //包含
                isMuilti = true;
            }
            return isMuilti;
        },

        /**
         * 判断obj对象是否为空
         * @param obj
         * @returns {boolean}
         */
        isEmptyObject(obj) {
            for (let key in obj) {
                if (obj.hasOwnProperty(key)) {
                    return false;//返回false，不为空对象
                }
            }
            return true;//返回true，为空对象
        },

        /**
         *  根据行数据获取ids
         * @param rowDataArr 选中的行数据
         */
        getSelectionIds(rowDataArr) {
            let idArr = [];
            rowDataArr.forEach(row => {
                let keyArr = Object.keys(row);
                keyArr.forEach(key => {
                    let field = key.split("_")[0];
                    if (field == 'ID') {
                        idArr.push(row[key]);
                    }
                });
            });
            return idArr;
        },


        /**
         * 解析
         * 根据  previewSql 和 rowData解析
         * @param type 类型 inset update delete
         * @param  whereConditionArr where 条件
         * @param  setConditionArr set值
         * @param rowData  行数据
         *
         */
        parsDiyButtonDataOperate(type, whereConditionArr, setConditionArr, rowData) {
            if (type == "update") {
                let param = {setParam: {}, whereSql: ''};
                setConditionArr.forEach((setCondition, index) => { //set赋值
                    let value = '';
                    if (setCondition.valType != 'formField' && setCondition.valType != 'sysData') {
                        value = setCondition.value;
                    }
                    if (setCondition.valType == 'default') { //根据值类型进行转化
                        if (value.indexOf('LOGINUSERDEPT') > -1) {
                            value = Replace.def(this.loginDept, setCondition.value);
                        } else if (value.indexOf('LOGINUSER') > -1) {
                            value = Replace.def(this.loginUser, value);
                        } else {
                            value = this.viewDateFormat(new Date(), 'yyyy-MM-dd HH:mm:ss');
                        }
                    } else if (setCondition.value && setCondition.valType == 'sysData') {
                        let valDataArr = setCondition.value || [];
                        value = valDataArr[valDataArr.length - 1] || ''; //数据字典
                    } else if (setCondition.valType == 'formField' && setCondition.value && rowData[setCondition.value]) {
                        value = rowData[setCondition.value];
                    }
                    param["setParam"][setCondition.field] = value; //赋值
                });
                let sql = "";
                whereConditionArr.forEach((whereCondition, index) => { //拼接条件
                    if (whereCondition.connectSignLeft) { //链接符
                        sql += whereCondition.connectSignLeft + " ";
                    }
                    if (whereCondition.field) {
                        if (this.formListFiledObj[whereCondition.field]) {
                            sql += this.formListFiledObj[whereCondition.field].phyfieldName + " "; //字段
                        } else {
                            sql += whereCondition.field + " ";
                        }
                    }
                    sql += whereCondition.operaSign + " "; //操作符
                    let valArr = [];
                    if (this.isMulitSelect(whereCondition)) {   //值类型判断
                        valArr = whereCondition.value; //单选
                    } else {
                        valArr.push(whereCondition.value); //多选
                    }
                    let val = "";
                    if (whereCondition.valType == 'default') { //缺省值
                        valArr.forEach(item => {
                            if (item.indexOf("LOGINUSERDEPT") > -1) {
                                val += ",'" + Replace.def(this.loginDept, item) + "'";
                            } else if (item.indexOf("LOGINUSER") > -1) {
                                val += ",'" + Replace.def(this.loginUser, item) + "'";
                            } else {
                                val += ",'" + this.viewDateFormat(new Date(), 'yyyy-MM-dd HH:mm:ss') + "'";
                            }
                        });
                        val = this.splitVal(val.substring(1), whereCondition.operaSign);
                    } else if (whereCondition.valType == 'constant' || whereCondition.valType == 'sysParam') { //常数和系统参数
                        val = this.splitVal("'" + whereCondition.value + "'", whereCondition.operaSign);
                    } else if (whereCondition.valType == 'formField') { //表单字段
                        valArr.forEach(item => {
                            if (item) {
                                val += ",'" + rowData[item] + "'";
                            }
                        });
                        val = this.splitVal(val.substring(1), whereCondition.operaSign);
                    } else if (whereCondition.valType == 'sysData') { //数据字段
                        valArr.forEach(item => {
                            if (item) {
                                let valDataArr = item || [];
                                let value = valDataArr[valDataArr.length - 1] || '';
                                val += ",'" + value + "'";
                            }
                        });
                        val = this.splitVal(val.substring(1), whereCondition.operaSign);
                    }
                    sql += val + " ";
                    //右连接符
                    if (whereCondition.connectSignRight) {
                        sql += whereCondition.connectSignRight + " ";
                    }
                    param["whereSql"] = sql;
                });
                return param;
            } else if (type == 'insert') {
                let param = {};
                setConditionArr.forEach((setCondition, index) => { //值赋值
                    let value = null;
                    if (setCondition.valType != 'formField' && setCondition.valType != 'sysData') {
                        value = setCondition.value || '';
                    }
                    if (setCondition.valType == 'default') { //根据值类型进行转化
                        if (value.indexOf('LOGINUSERDEPT') > -1) {
                            value = Replace.def(this.loginDept, setCondition.value);
                        } else if (value.indexOf('LOGINUSER') > -1) {
                            value = Replace.def(this.loginUser, value);
                        } else {
                            value = this.viewDateFormat(new Date(), 'yyyy-MM-dd');
                        }
                    } else if (setCondition.valType == 'sysData' && setCondition.value) {
                        let valDataArr = setCondition.value || [];
                        value = valDataArr[valDataArr.length - 1] || ''; //数据字典
                    } else if (setCondition.valType == 'formField' && setCondition.value && rowData[setCondition.value]) {
                        value = rowData[setCondition.value] || '';
                    }
                    param[setCondition.field] = value || ''; //赋值
                });
                return param;
            } else if (type == 'delete') {
                let sql = "";
                whereConditionArr.forEach((whereCondition, index) => { //拼接条件
                    if (whereCondition.connectSignLeft) { //链接符
                        sql += whereCondition.connectSignLeft + " ";
                    }
                    if (whereCondition.field) {
                        if (this.formListFiledObj[whereCondition.field]) {
                            sql += this.formListFiledObj[whereCondition.field].phyfieldName + " "; //字段
                        } else {
                            sql += whereCondition.field + " "; //字段
                        }
                    }
                    sql += whereCondition.operaSign + " "; //操作符
                    let valArr = [];
                    if (this.isMulitSelect(whereCondition)) {   //值类型判断
                        valArr = whereCondition.value; //单选
                    } else {
                        valArr.push(whereCondition.value); //多选
                    }
                    let val = "";
                    if (whereCondition.valType == 'default') { //缺省值
                        valArr.forEach(item => {
                            if (item.indexOf('LOGINUSERDEPT') > -1) {
                                val += ",'" + Replace.def(this.loginDept, item) + "'";
                            } else if (item.indexOf("LOGINUSER") > -1) {
                                val += ",'" + Replace.def(this.loginUser, item) + "'";
                            } else {
                                val += ",'" + this.viewDateFormat(new Date(), 'yyyy-MM-dd') + "'";
                            }
                        });
                        val = this.splitVal(val.substring(1), whereCondition.operaSign);
                    } else if (whereCondition.valType == 'constant' || whereCondition.valType == 'sysParam') { //常数和系统参数
                        val = this.splitVal("'" + whereCondition.value + "'", whereCondition.operaSign);
                    } else if (whereCondition.valType == 'formField') { //表单字段
                        valArr.forEach(item => {
                            if (item) {
                                val += ",'" + rowData[item] + "'";
                            }
                        });
                        val = this.splitVal(val.substring(1), whereCondition.operaSign);
                    } else if (whereCondition.valType == 'sysData') { //数据字段
                        valArr.forEach(item => {
                            if (item) {
                                let valDataArr = item || [];
                                let value = valDataArr[valDataArr.length - 1] || '';
                                val += ",'" + value + "'";
                            }
                        });
                        val = this.splitVal(val.substring(1), whereCondition.operaSign);
                    }
                    sql += val + " ";
                    //右连接符
                    if (whereCondition.connectSignRight) {
                        sql += whereCondition.connectSignRight + " ";
                    }
                });
                return sql;
            }
        },

        /**
         * 拼接值
         */
        splitVal(value, operaSign, valType) {
            value = value + " ";
            if (operaSign == "LIKE CONCAT") {
                value = "('%'," + value + ",'%') ";
            } else if ((operaSign == "IN" || operaSign == "NOT IN") && valType != "diy") {
                value = "(" + value + ") ";
            }
            return value;
        },

        /**
         * 下拉框是否多选
         */
        isMulitSelect(row) {
            return (row.operaSign == 'IN' || row.operaSign == 'NOT IN') ? true : false;
        },

        setColumn(showField) {
            let props = {};
            if (showField.fixed == "1") {
                props["width"] = showField.width;
            } else {
                props["min-width"] = showField.width;
            }
            if (showField.locked == "1") {
                props["fixed"] = true;
            } else {
                props["fixed"] = false;
            }
            return props;
        },

        /**
         * 是否需要分页
         * @returns {boolean}
         */
        isShowPage() {
            let flag = true;
            if ((this.isViewTable == '1' || this.isEditTable == '1') && this.isNeedPage == '1') {
                flag = true;
            } else if ((this.isViewTable == '0' && this.isEditTable == '0') && this.viewDefinData.pagination == '1') {
                flag = true;
            } else {
                flag = false;
            }
            return flag;
        },

        /**
         * 仅能添加一条数据时，是否已经存在数据
         */
        async isAddOnlyData() {
            this.onlyDataHasExist = false;
            if (this.isEditTable == "1" && this.onlyData == "1") {
                let paramArr = [
                    {controlType: "defaultField", key: "CREATED", operate: "=", value: this.loginUser.id},
                    {controlType: "defaultField", key: "RELATION_ID", operate: "=", value: this.relationId},
                ];
                let res = await this.spcpFormAxios.post(this.api.plCommonmethod.find,
                    {listViewId: this.listViewId, queryParams: JSON.stringify(paramArr), currentPage: 0});
                if (res && res.data && res.data.operateObj && res.data.operateObj.length > 0) {
                    this.onlyDataHasExist = true;
                }
            }
        },


        getConditionSql() {
            let fieldIdArr = [];
            (this.conditionFormArr || []).forEach(row => {
                fieldIdArr.push(row.fieldId);
            });

            let sql = "";
            (this.conditionFormArr || []).forEach(row => {
                if (row.connectSignLeft) {
                    sql += row.connectSignLeft + " ";
                }
                let fieldName = "";
                //字段名
                if (this.defaultFieldArr.indexOf(row.fieldId) > -1) {
                    fieldName = row.fieldId;
                } else {
                    fieldName = this.formFieldObj[row.fieldId] && this.formFieldObj[row.fieldId].phyfieldName;
                }
                sql += "TB." + fieldName + " ";
                //操作符
                sql += row.operaSign + " ";
                //值
                let valArr = [];
                if (this.isMulitSelect(row)) {
                    if (typeof row.linkFieldId == "string") {
                        valArr = (row.linkFieldId || '').split(",");
                    } else {
                        valArr = row.linkFieldId;
                    }
                } else {
                    valArr.push(row.linkFieldId);
                }
                let val = "";
                valArr.forEach(fieldId => {
                    if (!row.valType) {
                        row.valType = "formField";
                    }
                    if (row.valType == 'default') { //缺省值
                        if (fieldId.indexOf("LOGINUSERDEPT") > -1) {
                            val += ",'" + (Replace.def(this.loginDept, fieldId) || "") + "'";
                        } else if (fieldId.indexOf("LOGINUSER") > -1) {
                            val += ",'" + (Replace.def(this.loginUser, fieldId) || "") + "'";
                        }
                    } else if (row.valType == 'formField') {
                        if (row.value && typeof row.value == "string") {
                            if ((row.operaSign == 'IN' || row.operaSign == 'NOT IN') &&
                                (this.mainFormData[row.value] || "").indexOf(",") > -1) {
                                let tempArr = this.mainFormData[row.value].split(',');
                                tempArr.forEach(tempVal => {
                                    val += ",'" + tempVal + "'";
                                })
                            } else {
                                if (fieldName === 'RELATION_ID' && row.value === 'ID') {
                                    val += ",'" + (this.mainFormData[row.value] || this.relationId) + "'";
                                } else {
                                    val += ",'" + (this.mainFormData[row.value] || "") + "'";
                                }
                            }
                        } else {
                            let arr = (this.mainFormData[fieldId] || "").split(",");
                            if (arr.length > 0) {
                                arr.forEach(va => {
                                    val += ",'" + (va || "") + "'";
                                });
                            } else {
                                val += ",''";
                            }
                        }
                    } else if (row.valType == 'constant') {
                        val += ",'" + (fieldId || "") + "'";
                    } else if (row.valType == 'diy') {
                        val += ",'" + (fieldId || "") + "'";
                    } else if (row.valType == 'sysData') {//数据字典 row
                        val += ",'" + (row.value || "") + "'";
                    } else if (row.valType == 'sysParam') {//系统参数
                        val += ",'" + (row.value || "") + "'";
                    }
                });
                if (val) {
                    val = val.substring(1);
                }
                if (this.isMulitSelect(row)) {
                    sql += "(" + val + ") ";
                } else if (row.operaSign == "LIKE") {
                    if (val.includes("'")) {//处理有单引号的数据
                        val = val.split("'").join("");
                    }
                    sql += "'%" + val + "%' ";
                } else {
                    sql += val + " ";
                }
                //右连接符
                if (row.connectSignRight) {
                    sql += row.connectSignRight + " ";
                }
            });
            return sql;
        },

        /**
         * 列格式化方法
         */
        // formatterColumn(row, column,cellValue, index){
        //     let showField = this.showFieldArr[column.property];
        //     this.fieldColumn[showField.fieldId] = column;
        //     //值
        //     let result = row[showField.fieldName + "_" + showField.formId];
        //     //合并列
        //     if(showField.combine == '1' && showField.combineType == '1' && showField.allFieldIdArr){
        //         result = "";
        //         showField.allFieldIdArr.forEach((fieldId,idIndex) => {
        //             let fieldObj = this.showFieldObj[fieldId];
        //             if(row[fieldObj.fieldName + '_' + fieldObj.formId]){
        //                 result += " " + row[fieldObj.fieldName + '_' + fieldObj.formId];
        //             }
        //         });
        //         result = result.substring(1);
        //     }
        //
        //     if(Number(showField.dataCode)){ // 是元数据，开始转换
        //         // this.sysDataObj
        //         let templateValue = row[showField.fieldName + "_" + showField.formId];
        //         let templateArr = [];
        //         let valueArr = [];
        //         if(templateValue){
        //             templateArr = templateValue.split(",");
        //         }
        //         templateArr.forEach(value => {
        //             if(!this.sysDataObj[value]){
        //                 console.log("列表配置的元数据列并未匹配到元数据！");
        //                 valueArr.push(value);
        //             }else{
        //                 valueArr.push((this.sysDataObj[value] || {}).dataName);
        //             }
        //         });
        //         result = valueArr.join(",");
        //     }
        //
        //     //列格式化-自定义
        //     let formatObj = this.columnFormatObj[showField.fieldId] || {};
        //     if(formatObj&&formatObj.formatType&&!Number(formatObj.formatType)){
        //         result = "";
        //         const fn = new Function(...['vm','row','column','index'],formatObj.funcBody);
        //         let jsData = eval(fn(...[this,row,column,index]));
        //         if(typeof jsData == "object"){
        //             result = this.$createElement(jsData.tagName,{
        //                 domProps:{'innerHTML':jsData.innerHtml},
        //                 attrs:{"style":jsData.style},
        //                 on:jsData.event
        //             });
        //             // result = <jsData.tagName domProps={{'innerHTML':jsData.innerHtml}} attrs={{"style":jsData.style}} on={jsData.event}></jsData.tagName>;
        //         }else{
        //             result = jsData;
        //         }
        //     }
        //
        //     if(formatObj&&formatObj.formatType&&Number(formatObj.formatType)){
        //         let val = row[showField.fieldName + "_" + showField.formId];
        //         let labelName = showField.showName;
        //         result = this.executeSysColumnFormat(formatObj,val,index,labelName);
        //     }
        //     cellValue = result;
        //     if(this.showFieldArr[column.property].textShowType=='light'){
        //         return this.$createElement(marquee,{
        //                 domProps:{'innerHTML':cellValue},
        //                 attrs:{"direction":"left"}
        //             },[cellValue]);
        //         // return <marquee direction="left" domProps={{'innerHTML':cellValue}}>cellValue</marquee>
        //     }
        //     return cellValue;
        // },

        /**
         * 列格式化方法
         */
        formatterColumn(row, column, cellValue, index) {
            let rowFieldIdData = this.currentPageDataObj[index];
            let showField = this.showFieldArr[column.property];
            this.fieldColumn[showField.fieldId] = column;
            let formatObj = this.columnFormatObj[showField.fieldId];
            let idValue = row["ID_" + showField.formDefineKey] + "_" + column.property;
            if (this.isTempEdit) {
                return rowFieldIdData[showField.fieldId];
            }
            if (this.loadAfterCompSuccess && this.cacheFormatVal[idValue]) {
                return this.cacheFormatVal[idValue];
            }
            // 附件单独渲染
            if (!Number(showField.dataCode) && (!formatObj || !Number(formatObj.open)) && !(showField.specialField === "upload")) {
                let value = row[showField.fieldName + "_" + showField.formDefineKey];
                let allFieldIdArr = showField.allFieldIdArr || [];
                if (allFieldIdArr.length > 0) {
                    let valArr = [];
                    allFieldIdArr.forEach(fieldId => {
                        if (rowFieldIdData[fieldId]) {
                            valArr.push(rowFieldIdData[fieldId]);
                        }
                    });
                    if (showField.linkSign) {
                        value = valArr.join(showField.linkSign);
                    } else {
                        value = valArr.join("-");
                    }
                }
                if (!(value instanceof Array) && value) {
                    value = Replace.text(null, value);
                }
                // 判断数据类型是否是currency, 如果是将其渲染
                if (this.showFieldType[showField.fieldId] === "currency" && value) {
                    let type = this.timeSpecialSet[showField.fieldId]["currencyType"];
                    if (type === "yuan") {
                        value = "¥" + PlDataCurrency.methods.formater(value);
                    } else {
                        value = "$" + PlDataCurrency.methods.formater(value)
                    }
                }
                if (this.showFieldType[showField.fieldId] === 'cascadeSelectOne') {
                    let specialSetObj = JSON.parse(this.showContentField[showField.fieldId].specialSet || "{}");
                    if (specialSetObj.cascadeSelectOneType === 'cascadeOne') {
                        let arr = [];
                        let currOption = specialSetObj.optionSetting;
                        (value || "").split(",").forEach(diyId => {
                            let obj = currOption.find(item => item.id === diyId) || {};
                            arr.push(obj.label || "");
                            currOption = obj.children || [];
                        });
                        value = arr.filter(key => key).join(specialSetObj.linkSign || "/");
                    }
                }
                if (showField.textShowType === 'light') {
                    this.cacheFormatVal[idValue] = this.$createElement("marquee", {
                        domProps: {'innerHTML': value},
                        attrs: {'direction': 'left'},
                    });
                    return this.cacheFormatVal[idValue];
                } else {
                    this.cacheFormatVal[idValue] = value;
                    return value;
                }
            }
            //自定义脚本
            if (formatObj && ((!formatObj["isNewData"] && formatObj["chooseFunc"] == 'diyScript') ||
                (formatObj["isNewData"] == '1' && formatObj['resource'] == 'diyScript' && formatObj["leadFunc"] != '1'))
            ) {
                let arr = ['rowData', 'vm', 'value', 'Ajax', 'CTX', 'rowFieldIdData'];
                let CTX = "";
                let value = (row[showField.fieldName + "_" + showField.formDefineKey]) || "";

                let serviceName = (window.SERVICE_NAME || {});
                let adminServeName = serviceName.admin || "/admin/";
                let formServeName = serviceName.form || "/form/";
                let flowServeName = serviceName.flow || "/flow/";
                let oaServeName = serviceName.oa || "/oaproject/";
                if (!formatObj.funcBody) {
                    console.log("自定义脚本为空，异常！");
                    return "";
                }
                let bodyValue = formatObj.funcBody;
                bodyValue = this.platStringUtil.replaceAll(bodyValue, "window.ADMIN_NAME", "'admin'");
                bodyValue = this.platStringUtil.replaceAll(bodyValue, "window.FORM_NAME", "'form'");
                bodyValue = this.platStringUtil.replaceAll(bodyValue, "window.FLOW_NAME", "'flow'");
                bodyValue = this.platStringUtil.replaceAll(bodyValue, "window.OA_NAME", "'project'");
                bodyValue = this.replaceUrlPrefix(bodyValue);
                let val = new Function(...arr, bodyValue)(row, this, value, AjaxUtil, CTX, rowFieldIdData);
                if (typeof val == 'object' && val.renderValClean) {
                    delete val["renderValClean"];
                    this.cacheFormatVal[idValue] = val;
                    return val;
                } else {
                    if (showField.textShowType == 'light') {
                        this.cacheFormatVal[idValue] = this.$createElement("marquee", {
                            domProps: {'innerHTML': val},
                            attrs: {'direction': 'left'},
                        });
                    } else if (typeof val == 'object' && val["isPlTagElement"]) {
                        this.cacheFormatVal[idValue] = this.$createElement(val["tagName"], {
                            domProps: val["domProps"],
                            attrs: val["attrs"],
                            on: val["on"],
                        })
                    } else if (typeof val == 'object') {
                        this.cacheFormatVal[idValue] = this.$createElement(val["tagName"], {
                            domProps: val["domProps"],
                            attrs: val["attrs"],
                            on: val["on"],
                        })
                    } else {
                        this.cacheFormatVal[idValue] = val;
                    }
                    return this.cacheFormatVal[idValue];
                }
            }

            let beforeRenderComp = null;
            let afterRenderComp = null;
            let isNewData = "0";
            if (formatObj && (formatObj || {}).chooseFunc && formatObj.resource == 'event') {
                if (!formatObj["isNewData"] && this.FORM_PLUGIN['listColumnFormatters'][formatObj.chooseFunc]) {
                    if (this.FORM_PLUGIN['listColumnFormatters'][formatObj.chooseFunc]["reqBefore"]) {
                        beforeRenderComp = this.$refs[this.FORM_PLUGIN['listColumnFormatters'][formatObj.chooseFunc].id + "_beforeRef"][0];
                    }
                    if (this.FORM_PLUGIN['listColumnFormatters'][formatObj.chooseFunc]["reqAfter"]) {
                        afterRenderComp = this.$refs[this.FORM_PLUGIN['listColumnFormatters'][formatObj.chooseFunc].id + "_afterRef"][0];
                    }
                } else if (formatObj["isNewData"] == '1' && this.EVENT_PLUGIN['installEventObj'][formatObj.chooseFunc]) {
                    isNewData = "1";
                    if (this.EVENT_PLUGIN['installEventObj'][formatObj.chooseFunc]["reqBefore"]) {
                        beforeRenderComp = this.$refs[this.EVENT_PLUGIN['installEventObj'][formatObj.chooseFunc].id + "_beforeRef"][0];
                    }
                    if (this.EVENT_PLUGIN['installEventObj'][formatObj.chooseFunc]["reqAfter"]) {
                        afterRenderComp = this.$refs[this.EVENT_PLUGIN['installEventObj'][formatObj.chooseFunc].id + "_afterRef"][0];
                    }
                }
            }
            this.cacheFormatVal[idValue] = this.$createElement("formatRender", {
                props: {
                    columnFormatObj: this.columnFormatObj,
                    formFieldObj: this.formFieldObj,
                    showField: showField,
                    rowData: row,
                    column: column,
                    sysDataObj: this.sysDataObj,
                    rowFieldIdData: rowFieldIdData,
                    beforeRenderComp: beforeRenderComp,
                    afterRenderComp: afterRenderComp,
                    loadAfterCompSuccess: this.loadAfterCompSuccess,
                    isNewData: isNewData,
                    rowIndex: index + '',
                    columnFormatDialogObj: this.columnFormatDialogObj,
                    pRefs: this.pRefs,
                    showFieldType:this.showFieldType,
                    loadSysDataSuccess: this.loadSysDataSuccess
                }
            });
            // console.log('this.cacheFormatVal = ', this.cacheFormatVal);
            return this.cacheFormatVal[idValue];
            // return <formatRender columnFormatObj={this.columnFormatObj} formFieldObj={this.formFieldObj} showField={showField}
            //                      rowData={row} column={column} sysDataObj={this.sysDataObj}
            //                      rowFieldIdData={rowFieldIdData}
            //                      beforeRenderComp={beforeRenderComp} afterRenderComp={afterRenderComp}
            //        />;
        },

        dealColumnContent(formateObj, val, beforeObj, rowData) {
            //执行文本内容渲染逻辑 contentCondition
            let contentCondition = formateObj.contentCondition;
            let content = ""; //文本
            (formateObj.content || []).forEach(item => {
                if (contentCondition[item.order]) {
                    let result = true;
                    try {
                        result = this.exeCuteColumnCondition(contentCondition[item.order], beforeObj, rowData);
                    } catch (e) {
                        console.log(e);
                        console.log("执行内容条件时异常了！");
                    }
                    if (result) {
                        content = item;
                    }
                } else {
                    content = item;
                }
            });
            //文本内容
            //渲染文本内容
            if (content && content["events"]) {
                (content["events"] || []).forEach(cItem => {
                    switch (cItem.type) {
                        case "1": //远程替换 remoteReplace
                            //数据字典替换
                            if (cItem.repType == 'data') { //数据替换
                                let formatValArr = val.split(",") || [];
                                let valArr = [];
                                formatValArr.some(vl => {
                                    if (this.sysDataObj[vl] && this.sysDataObj[vl].typeId == cItem.dataDic) {
                                        valArr.unshift(this.sysDataObj[vl].dataName);
                                    }
                                });
                                if (valArr.length > 0) {
                                    val = valArr.join(",");
                                }
                            } else if (cItem.repType == 'url' && cItem.reqUrl) { //自定义替换
                                let reqParam = {}; //请求param
                                (cItem.optionSetting || []).forEach(param => {
                                    if (param.name) {
                                        //参数类型
                                        if (param.vType == 'diy') { //自定义
                                            reqParam[param.name] = param.val ? param.val : '';
                                        } else if (param.vType == 'user') { //用户信息
                                            reqParam[param.name] = param.val ? this.loginUser[param.val[1]] : '';
                                        } else if (param.vType == 'row') { //行数据s
                                            let rowVal = '';
                                            if (rowData && param.val && param.val.split(",")) {
                                                let vl = param.val.split(",")[0];
                                                if (defaultValObj[vl]) {
                                                    rowVal = rowData[defaultValObj[vl]];
                                                } else {
                                                    rowVal = rowData[param.val];
                                                }
                                            }
                                            reqParam[param.name] = rowVal;// 行数据
                                        }
                                    }
                                });
                                let result = this.ayncMethodUrl(cItem.reqUrl, reqParam);
                                if (result) {
                                    try {
                                        result = JSON.parse(result);
                                    } catch (e) {
                                    }
                                    let sysVal = '';
                                    if (cItem.valueParse == 'sys') { //系统替换
                                        //判断返回值类型
                                        if (cItem.retValType == 'constant') { //常数
                                            if (result.constructor === String) {
                                                sysVal = result;
                                            } else {
                                                sysVal = JSON.stringify(result);
                                            }
                                        } else if (cItem.retValType == 'array') { //数组
                                            if (result.constructor != Array || !cItem.arrIndex || Number(cItem.arrIndex) > (result.length)) {
                                                return
                                            }
                                            if (cItem.isArrObject == '0') { //常数
                                                sysVal = result[cItem.arrIndex];
                                            } else if (cItem.isArrObject == '1' && result[cItem.arrIndex] && cItem.arrObjKey && result[cItem.arrIndex][cItem.arrObjKey]) { //下标为对象
                                                //获取key
                                                sysVal = result[cItem.arrIndex][cItem.arrObjKey];
                                            }
                                        } else if (cItem.retValType == 'object') { //对象
                                            if (result.constructor != Object || !cItem.objectKey) {
                                                return
                                            }
                                            if (result[cItem.objectKey]) {
                                                sysVal = result[cItem.objectKey];
                                            }
                                        }
                                        //替换
                                        if (sysVal) {
                                            val = sysVal;
                                        }
                                    } else if (cItem.valueParse == 'manual') { //手动替换
                                        //根据返回值脚本替换
                                        try {
                                            let ret = new Function('data', cItem.replManuaScript)(result);
                                            if (ret) {
                                                val = ret;
                                            }
                                        } catch (e) {
                                            console.log("远程替换手动脚本执行失败！", e);
                                        }
                                    }
                                }
                            }
                            break;
                        case "2": //内容替换 contentReplace
                            if (cItem.replaceType == '1') { //全局替换
                                val = val.replace(new RegExp(cItem.replaceText, 'g'), cItem.replaceVal);
                            } else if (cItem.replaceType == '0') { //首个位置替换
                                val = val.replace(cItem.replaceText || '', cItem.replaceVal || '');
                            }
                            break;

                        case "3": //文本截取
                            if (cItem.endType == '1') { //自定义位置
                                val = val.substr(cItem.begin, cItem.end);
                            } else if (cItem.endType == '0') { //根据字符串长度
                                let length = val.length;
                                let end = length - Number(cItem.CutLeng);
                                val = val.substr(cItem.begin, end);
                            }
                            break;

                        case "4": //文本追加
                            if (cItem.appendType == '1') { //向前追加
                                val = (cItem.appendText || '') + val;
                            } else if (cItem.appendType == '0') { //向后追加
                                val += cItem.appendText;
                            }
                            break;

                        case "5": //转换大小写
                            if (cItem.transType == '1') { //转化为大写
                                val = val.toUpperCase();
                            } else if (cItem.transType == '0') { //全部转化为小写
                                val = val.toLowerCase();
                            }
                            break;

                        case "6": //去除文本空格 contentTrim
                            val = val.trim();
                            break;

                        case "7": //按照指定字符分割
                            let valArr = val.split(cItem.splitCode) || [];
                            if (valArr.length >= Number(cItem.valNum) + 1) {
                                val = valArr[cItem.valNum];
                            }
                            break;
                        default:
                            break;
                    }
                })
            }

            return val;
        },

        /**
         * 批量转换列格式化文本内容
         */
        batchFomratterContent(rowDataAll) {
            let dataAll = JSON.parse(JSON.stringify(rowDataAll));
            // 获取需要转换的数据列
            let transColObj = {};
            this.showFieldArr.forEach(item => {
                if (item.combine == '1' && item.combineType == '1' && item.allFieldIdArr) {
                    transColObj[item.fieldName + "_" + item.formDefineKey] = {"method": "combine"};
                }
                if (Number(item.dataCode)) { // 是否是元数据
                    transColObj[item.fieldName + "_" + item.formDefineKey] = {"method": "code"};
                }
                let formatObj = this.columnFormatObj[item.fieldId] || {};
                if (formatObj && formatObj.resource && (formatObj.resource == "diyScript")) { // 自定义格式化
                    transColObj[item.fieldName + "_" + item.formDefineKey] = {"method": "diy"};
                }

                let objTemp = transColObj[item.fieldName + "_" + item.formDefineKey];
                if (objTemp) {
                    objTemp['fieldId'] = item.fieldId;
                }
            });
            (dataAll || []).forEach((row, index) => {
                Object.keys(transColObj).forEach(key => {
                    let fieldId = transColObj[key].fieldId;
                    let formatObj = this.columnFormatObj[fieldId] || {};
                    let val = row[key] || "";
                    switch (transColObj[key].method) {
                        case "combine":
                            let result = "";
                            let id = transColObj[key].fieldId;
                            this.allFiledObj[id]["allFieldIdArr"].forEach(fieldId => {
                                let fieldObj = this.allFiledObj[fieldId];
                                if (row[fieldObj.fieldName + '_' + fieldObj.formDefineKey]) {
                                    result += "-" + row[fieldObj.fieldName + '_' + fieldObj.formDefineKey];
                                }
                            });
                            row[key] = result.substring(1);
                            break;
                        case "code":
                            let templateValue = row[key];
                            let templateArr = [];
                            let valueArr = [];
                            if (templateValue) {
                                templateArr = templateValue.split(",");
                            }
                            templateArr.forEach(value => {
                                if (!this.sysDataObj[value]) {
                                    console.log("列表配置的元数据列并未匹配到元数据！");
                                    valueArr.push(value);
                                } else {
                                    valueArr.push((this.sysDataObj[value] || {}).dataName);
                                }
                            });
                            //处理和并列的数据
                            let fieldId = transColObj[key].fieldId;
                            if (this.allFiledObj[fieldId].allFieldIdArr && this.allFiledObj[fieldId].allFieldIdArr.length > 0) {//合并列单独赋值
                                (this.allFiledObj[fieldId].allFieldIdArr || []).forEach(data => {
                                    if (data != fieldId) {
                                        let obj = this.allFiledObj[data];
                                        let name = obj.fieldName + "_" + obj.formDefineKey;
                                        if (row[name]) {
                                            if (!this.sysDataObj[row[name]]) {
                                                console.log("列表配置的元数据列并未匹配到元数据！");
                                                valueArr.push(row[name]);
                                            } else {
                                                valueArr.push((this.sysDataObj[row[name]] || {}).dataName);
                                            }
                                        }

                                    }
                                })
                            }
                            row[key] = valueArr.join("-");
                            break;
                        case "diy":
                            let templateFieldId = transColObj[key].fieldId;
                            let templateColumn = this.fieldColumn[templateFieldId];
                            let showField = this.showFieldArr[templateColumn.property];
                            const fn = new Function(...['rowData', 'vm', 'value', 'Ajax', 'CTX', 'rowFieldIdData'], formatObj.funcBody);
                            try {
                                let value = (row[showField.fieldName + "_" + showField.formDefineKey]) || "";
                                let jsData = eval(fn(...[row, this, value, AjaxUtil, '', row]));
                                if (typeof jsData == "object") {
                                    row[key] = jsData.innerHTML || (jsData.domProps || {}).innerHTML;
                                } else {
                                    row[key] = jsData;
                                }
                            } catch (e) {
                                console.log(e);
                                console.log("此行数据在执行自定义格式化方法时出现了异常！");
                            }
                            break;
                        default:
                            break;
                    }
                })
            });
            return dataAll;
        },

        executClickFunc(event, index, val, labelName) {
            let rowData = this.currentPageDataObj[index + 1] || {}; //当前行数据
            let defaultValObj = {
                "id": "id",
                "CREATE_TIME": "createTime",
                "UPDATE_TIME": "updateTime",
                "CREATED": "created",
                "UPDATED": "updated"
            };
            let propParam = {};
            //读取参数
            (event.param || []).forEach(param => {
                if (param.name) {
                    //参数类型
                    if (param.paramType == 'diy') { //自定义
                        propParam[param.name] = param.val ? param.val : '';
                    } else if (param.paramType == 'user') { //用户信息
                        propParam[param.name] = param.val ? this.loginUser[param.val[1]] : '';
                    } else if (param.paramType == 'row') { //行数据
                        // propParam[param.name] = rowData[param.val] || '';
                        let rowVal = '';
                        if (rowData && param.val && param.val.split(",")) {
                            let vl = param.val.split(",")[0];
                            if (defaultValObj[vl]) {
                                rowVal = rowData[defaultValObj[vl]];
                            } else {
                                rowVal = rowData[param.val];
                            }
                        }
                        propParam[param.name] = rowVal;
                    }
                }
            });

            if (event.func == 'newPage') {
                if (event.url.indexOf("http://") > -1) { //外部地址
                    let data = '';
                    Object.keys(propParam || {}).forEach((key, index) => {
                        if (index == 0) {
                            data += "?" + key + "=" + propParam[key];
                        } else {
                            data += "&" + key + "=" + propParam[key];
                        }
                    });
                    window.open(event.url + data);
                } else {  //内部页面
                    this.routerPush(event, propParam); //router跳转组件
                }
            } else if (event.func == 'dialog') {
                this.formatEvetDilogObj.title = event.title || '查看';
                this.formatEvetDilogObj.height = event.height || '90%';
                this.formatEvetDilogObj.width = event.width || '90%';
                this.formatEvetDilogObj.top = "5vh";
                this.formatEvetDilogObj.type = 'page'; //内部页面
                if (event.url.indexOf("http://") > -1) { //外部地址
                    this.formatEvetDilogObj.type = 'url'; //外部地址
                    this.formatEvetDilogObj.url = event.url;
                } else {
                    //根据url获取组件注册地址
                    this.getFormatterEventIndex(event.url);
                    //传递参数
                    this.formatEvetDilogObj.param = propParam;
                }
                this.formatterEventDialog = true; //开启
            } else if (event.func == 'viewDetail') { //查看当前列数据
                let title = event.title || labelName;
                this.$alert(val, title, {
                    showConfirmButton: false
                });
            }

        },

        /**
         * 执行逻辑判断
         * @param val
         * @param beforeObj
         * @param index 当前格式化行号
         * @returns {*}
         */
        exeCuteColumnCondition(val, beforeObj, rowData) {
            if (val.length == 0) {
                return true;
            }
            let currentRow = rowData || {}; //当前行数据
            let defaultValObj = {
                "id": "id",
                "CREATE_TIME": "createTime",
                "UPDATE_TIME": "updateTime",
                "CREATED": "created",
                "UPDATED": "updated"
            };
            let result = false;
            let funcStr = "if( ";
            let operSignArr = ["==", "indexOf", "beContain", "!=", ">", "<", ">=", "<="]; //操作符
            (val || []).forEach(item => {
                let beforeVal = beforeObj[item.compare]; //前置变量值
                //左链接符解析
                funcStr += " " + item.link + " ";
                //解析操作符 和 值
                if (item.operator != 'indexOf' && item.operator != 'beContain') {   //不是 包含与被包含
                    funcStr += "'" + beforeVal + "' " + item.operator + " "; //操作符
                    //解析具体操作符号
                    let value = "";
                    if (item.valType == "diy") { // 加载自定义值
                        value = item.val;
                    } else if (item.valType == 'data') { //数据字典
                        let valDataArr = item.value || [];
                        value = valDataArr[valDataArr.length - 1];
                    } else if (item.valType == 'row') { //行数据
                        let rowVal = '';
                        if (currentRow && item.val && item.val.split(",")) {
                            let vl = item.val.split(",")[0];
                            if (defaultValObj[vl]) {
                                rowVal = currentRow[defaultValObj[vl]];
                            } else {
                                rowVal = currentRow[item.val];
                            }
                        }
                        value = rowVal;
                    } else if (item.valType == 'user' && item.val) { //用户信息
                        value = this.loginUser[item.val];
                    }
                    funcStr += " '" + value + "' ";
                } else {//被包含与不被包含
                    //如果是包含和被包含的拼接
                    funcStr += "'" + beforeVal + "' " + ".includes( "; //操作符
                    //解析具体操作符号
                    let value = "";
                    if (item.valType == "diy") { // 加载自定义值
                        value = item.val;
                    } else if (item.valType == 'data') { //数据字典
                        let valDataArr = item.value || [];
                        value = valDataArr[valDataArr.length - 1] || '';
                    } else if (item.valType == 'row') { //行数据
                        let valArr = [];
                        (item.val || []).forEach(vl => {
                            let rowVal = '';
                            if (currentRow && vl && vl.split(",")) {
                                vl = vl.split(",")[0];
                                if (defaultValObj[vl]) {
                                    rowVal = currentRow[defaultValObj[vl]];
                                } else {
                                    rowVal = currentRow[vl];
                                }
                            }
                            valArr.push(rowVal);
                        });
                        value = valArr.join(",") || '';
                    } else if (item.valType == 'user') { //用户信息
                        let valArr = [];
                        (item.val || []).forEach(vl => {
                            valArr.push(this.loginUser[vl] || '');
                        });
                        value = valArr.join(",");
                    }
                    funcStr += " '" + value + "' " + " ) ";
                    if (item.operator == 'indexOf') {
                        funcStr += " == true "; //被包含
                    } else {
                        funcStr += " == false "; //不被包含
                    }
                }
            });
            funcStr += " ){return true}else{return false;}";
            //判断 funcScript 是否存在操作符
            let funcFlag = false;
            operSignArr.some(operSign => {
                if (funcStr.includes(operSign)) {
                    funcFlag = true;
                    return;
                }
            });
            result = funcFlag && Function(funcStr)();
            return result;
        },

        /**
         * 判断是否时String类型，转换对应类型
         * @param type 需要转换的类型 array object
         */
        formattrObjStrToArr(val, type) {
            if (val && val.constructor === String) {
                if (type == 'array') {
                    val = JSON.parse(val || "[]");
                } else if (type == 'object') {
                    val = JSON.parse(val || "{}");
                }
            }
            return val;
        },

        /**
         * ajax 同步请求
         * @param url
         * @param params
         * @returns {Promise<any> | Promise}
         */
        ayncMethodUrl(url, params) {
            if (url.indexOf("http://") == -1 && url.indexOf("https://") == -1) {
                url = window.FORM_RENDER_URL + url;
            }
            let data = '';
            Object.keys(params || {}).forEach(key => {
                data += "&" + key + "=" + params[key];
            });
            if (data) {
                data = data.substring(1);
            }

            const xmlhttp = new XMLHttpRequest();

            let result = null;
            xmlhttp.open("POST", url, false);
            xmlhttp.setRequestHeader("Authorization", this.CACHE_GLOBAL.getLoginToken() || "");
            xmlhttp.setRequestHeader('Content-Type',
                'application/x-www-form-urlencoded');
            xmlhttp.onreadystatechange = function () {
                if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
                    // 同步请求成功
                    result = xmlhttp.responseText;
                }
            };
            xmlhttp.send(data);

            return result;

        },

        /**
         * 请求跳转
         */
        routerPush(event, param) {
            this.menuIsIfm = (event.url && (event.url.indexOf(".jsp") > -1 || event.url.indexOf(".html") > -1));
            if (this.menuIsIfm) {
                this.$nextTick(() => {
                    this.$router.push({
                        name: "ifmPage", query: param
                    });
                });
            } else {
                if (event.url.indexOf("/") == -1) {
                    event.url = "/" + event.url;
                }
                this.$router.push({
                    path: event.url, query: param
                });
            }
        },

        /**
         * 获取组件注册地址
         */
        getFormatterEventIndex(url) {
            if (!url) {
                return;
            }
            let index = url.indexOf(".vue");
            if (index > -1) {
                url = url.substring(0, index);
            }
            if (url.indexOf("/") == 0) {
                url = url.substring(1);
            }
            //注册组件地址
            this.formatEvetDilogObj.componentIndex = () => Promise.resolve(require('@/' + url + '.vue').default);
            // this.formatEvetDilogObj.componentIndex = () => import('@/' + url +'.vue');
        },

        /**
         * 为多选框表头单元格设置一个固定的 className
         */
        cellClass(row) {
            if ((this.viewDefinData.selectionType == "0") && (row.columnIndex === 0)) {
                return 'disabledCheck';
            }
        },
        /**
         * 当选择项发生变化时会触发
         */
        handleSelectionChange(val) {
            if (this.viewDefinData.selectionType == "0") {
                if (val.length > 1) {
                    this.$refs.listViewPreViewRef.clearSelection();
                    this.$refs.listViewPreViewRef.toggleRowSelection(val[val.length - 1]);
                }
                this.multipleSelection = val[val.length - 1];
            } else {
                this.multipleSelection = val;
            }
            let noSelection = this.getCurrentNoSelect();
            this.allCheckedArr = this.allCheckedArr.filter(item => { // 移除已选择用户但是当前行并没有再选中的
                let flag = true;
                for (let elem of noSelection) {
                    if (elem["ID_" + this.formDefineKey] == item) {
                        flag = false;
                        break;
                    }
                }
                return flag;
            });
            let ejectSelectChooseRowIdArr = Array.from(this.ejectSelectChooseRowIds);
            if (this.isEjectTableShowSelect) {
                ejectSelectChooseRowIdArr = ejectSelectChooseRowIdArr.filter(item => { // 移除已选择行但是当前行并没有再选中的
                    let flag = true;
                    for (let elem of noSelection) {
                        if (elem["ID_" + this.formDefineKey] == item) {
                            flag = false;
                            break;
                        }
                    }
                    return flag;
                });
            }
            (val || []).forEach(select => { // 新增当前table中选中的但是已选择中没有的数据
                let flag = true;
                for (let elem of this.allCheckedArr) {
                    if (elem == select["ID_" + this.formDefineKey]) {
                        flag = false;
                        break;
                    }
                }
                if (flag) {
                    this.allCheckedArr.push(select["ID_" + this.formDefineKey]);
                }
                let dataFlag = true;
                for (let elem of this.allCheckedDataArr) {
                    if (elem["ID_" + this.formDefineKey] === select["ID_" + this.formDefineKey]) {
                        dataFlag = false;
                        break;
                    }
                }
                if (dataFlag) {
                    this.allCheckedDataArr.push(select);
                }
                if (this.isEjectTableShowSelect) {
                    let ejectFlag = true;
                    for (let elem of ejectSelectChooseRowIdArr) {
                        if (elem == select["ID_" + this.formDefineKey]) {
                            ejectFlag = false;
                            break;
                        }
                    }
                    if (ejectFlag) {
                        ejectSelectChooseRowIdArr.push(select["ID_" + this.formDefineKey]);
                    }
                }
            });
            this.ejectSelectChooseRowIds = new Set(ejectSelectChooseRowIdArr);
        },

        /**
         * 获取当前页未选中的
         */
        getCurrentNoSelect() {
            let vm = this;
            let selection = vm.$refs["listViewPreViewRef"] && vm.$refs["listViewPreViewRef"].selection;
            let data = vm.$refs["listViewPreViewRef"] && vm.$refs["listViewPreViewRef"].data;
            if (vm.switchTable) {
                selection = vm.$refs["listViewPreViewRef2"].selection;
                data = vm.$refs["listViewPreViewRef2"].data;
            }
            let arr = [];
            arr = data.filter(item => {
                let flag = true;
                for (let elem of selection) {
                    if (elem["ID_" + this.formDefineKey] == item["ID_" + this.formDefineKey]) {
                        flag = false;
                        break;
                    }
                }
                return flag;
            });
            return arr;
        },

        /**
         * 初始化 allCheckUser
         */
        initAllUserChecked() {
            this.allCheckedArr = [];
            if (this.listOutParam["zzqId"]) { //著作权
                //当前行选中
                this.allCheckedArr = this.listOutParam["zzqId"].split(",") || [];
            } else if (this.listOutParam["zlzsId"]) { //专利证书
                //选中当前行
                this.allCheckedArr = this.listOutParam["zlzsId"].split(",") || [];
            }
        },

        /**
         * 时间格式化方法（查看表单视图时用到）
         * @param d
         * @param fmt
         * @return {string|void}
         */
        viewDateFormat(d, fmt) {
            if (d) {
                let date = new Date(d);
                let o = {
                    "M+": date.getMonth() + 1,                 //月份
                    "d+": date.getDate(),                    //日
                    "H+": date.getHours(),                   //小时
                    "m+": date.getMinutes(),                 //分
                    "s+": date.getSeconds(),                 //秒
                    "q+": Math.floor((date.getMonth() + 3) / 3), //季度
                    "S": date.getMilliseconds()             //毫秒
                };
                if (/(y+)/.test(fmt)) {
                    fmt = fmt.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
                }
                for (let k in o) {
                    if (new RegExp("(" + k + ")").test(fmt)) {
                        fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
                    }
                }
            } else {
                fmt = '';
            }
            return fmt;
        },

        /*
            关闭自定义按钮
         */
        closeDiyDialog() {
            this.logicOpenDialogVisible = false;
            this.search();
        },

        /**
         * 执行自定义弹窗保存脚本
         */
        saveDiyDialog() {
            if (this.openDialogData.funcBody) {
                let arr = ['vm', 'axios', 'CTX', 'Ajax', 'vmParent'];
                let CTX = "";
                let serviceName = (window.SERVICE_NAME || {});
                let adminServeName = serviceName.admin || "/admin/";
                let formServeName = serviceName.form || "/form/";
                let flowServeName = serviceName.flow || "/flow/";
                let oaServeName = serviceName.oa || "/oaproject/";
                if (this.openDialogData.funcBody) {
                    let value = this.openDialogData.funcBody;
                    // value = this.platStringUtil.replaceAll(value, "/admin/", adminServeName);
                    // value = this.platStringUtil.replaceAll(value, "/form/", formServeName);
                    // value = this.platStringUtil.replaceAll(value, "/flow/", flowServeName);
                    // value = this.platStringUtil.replaceAll(value, "/oaproject/", oaServeName);
                    // value = this.platStringUtil.replaceAll(value, "/oaadmin/", adminServeName);
                    // value = this.platStringUtil.replaceAll(value, "/oaform/", formServeName);
                    // value = this.platStringUtil.replaceAll(value, "/oaflow/", flowServeName);

                    value = this.replaceUrlPrefix(value);

                    this.openDialogData.funcBody = value;
                }
                try {
                    if (this.openDialogData.funcBody.indexOf('return new Promise') == '-1') { //
                        let val = new Function(...arr, this.openDialogData.funcBody)(this.$refs.buttonFormDataRef, this.spcpFormAxios, CTX, AjaxUtil, this);
                        if (val == false) {
                            return;
                        }

                        this.logicOpenDialogVisible = false;
                        if (this.openDialogData.saveRefresh == '1') {
                            this.search();
                        }

                    } else {
                        new Function(...arr, this.openDialogData.funcBody)(this.$refs.buttonFormDataRef, this.spcpFormAxios, CTX, AjaxUtil, this).then(res => {
                            if (!res) {
                                return;
                            }
                            this.logicOpenDialogVisible = false;
                            if (this.openDialogData.saveRefresh == '1') {
                                this.search();
                            }
                        });
                    }
                } catch (e) {
                    console.log("保存脚本执行是失败！", e);
                }
            }
        },

        /**
         * 自定义按钮dialog回调方法
         */
        callbackMethod() {
            //关闭当前dialog
            this.logicOpenDialogVisible = false;
            //刷新
            if (this.openDialogData.colseRefresh == '1') {
                this.search();
            }
        },

        /**
         * 格式化树节点
         * @param value
         * @param data
         * @returns {boolean}
         */
        filterNode(value, data) {
            if (!value) {
                return true;
            }
            return data.label.indexOf(value) !== -1;
        },

        /** 树节点点击事件 **/
        async treeNodeClick(data) {
            this.currentPage = 1;
            this.treeClickNode = data;
            this.initSearchForm();
            await this.getDataRows();
            this.$message({
                type: "success",
                message: "查询成功"
            });
        },


        /**
         * 字段格式比较
         * @param leftValue
         * @param rightValue
         */
        transType(leftValue, rightValue) {
            let ret = {};
            ret['param'] = leftValue;
            ret['value'] = rightValue;
            if (!isNaN(Number(leftValue) && !isNaN(Number(rightValue)))) { //比较数字类型
                ret['param'] = Number(leftValue);
                ret['value'] = Number(rightValue);
                //如果是日期类型
            } else if (isNaN(leftValue) && !isNaN(Date.parse(leftValue))
                && isNaN(rightValue) && !isNaN(Date.parse(rightValue))) {//比较日期类型
                ret['param'] = Date.parse(leftValue);
                ret['value'] = Date.parse(rightValue);
            }
            return ret;
        },

        /**
         * 关闭树
         */
        closeTree() {
            this.treeWidth = '0px';
            this.treeUnfold = false;
        },
        /**
         * 显示树
         */
        openTree() {
            this.treeWidth = '250px';
            this.treeUnfold = true;
        },
        /**
         * 默认选中
         */
        checkTableDatas() {
            let checkIdObJ = {};
            this.checkIdArr.forEach(data => {
                this.$set(checkIdObJ, data, "id");
            })
            if (this.dataRows) {
                let resultArr = this.dataRows.filter(item => {
                    if (checkIdObJ[item["ID_" + this.formDefineKey]]) {
                        return item;
                    }
                })
                this.$nextTick(() => {
                    resultArr.forEach(data => {
                        this.$refs['listViewPreViewRef'].toggleRowSelection(data, true);
                    })
                })

            }
        },
        /**
         * 自定义修改编辑列表按钮
         */
        diyHideRowBtn(row) {
            if (row['DIYHIDEUPTBTN_' + this.formDefineKey]) {//用自定义行按钮赋值 diyHideUptBtn个值 即可隐藏
                return false;
            } else {
                return true;
            }

        },
        /**
         * 设置变更记录 --updateContent需手动调用 {'aaa':{"old": "","new": "qqq"}}
         */
        setUpdateRecord(dataId, operate, updateContent) {
            // 设置变更记录

            let updateType = "";
            if (operate == "insert") { // 新增
                updateType = "add";
            }
            if (operate == "updateById") { // 修改
                updateType = "update";
            }
            this.spcpFormAxios.post(this.api.plUpdateRecord.add, {
                "formId": this.formId, "dataId": dataId,
                "updateDataUser": this.loginUser.id, "updateType": updateType,
                "updateContent": JSON.stringify(updateContent || "{}"), "updateDataUserName": this.loginUser.userName
            })
        },

        /**
         * 禁用列表
         * @param row
         */
        selectable(row) {
            let result = true;
            if (row["ID_" + this.formDefineKey] && (this.listOutParam.hasOwnProperty("zzqId") || this.listOutParam.hasOwnProperty("zlzsId"))) {
                result = row["JYZT_" + this.formDefineKey] != '已借';
            }
            if (this.isEditSelf == "1" && row["ID_" + this.formDefineKey] && row["CREATED_" + this.formDefineKey]) {
                result = (row["CREATED_" + this.formDefineKey] == this.loginUser.id);
            }
            return result;
        },

        /**
         * 按键记录赋值
         * buttonName 按键名称
         */
        buttonPush(clickPosition, rowDataId) {
            if (this.viewDefinData.isRecordButton != "1"){
                return;
            }
            let userId;
            let userName;

            if (this.loginUser.id) {
                userId = this.loginUser.id;
                userName = this.loginUser.userName;
            } else {
                userId = this.FORM_USER_GLOBAL.getLoginUser().id;
                userName = this.FORM_USER_GLOBAL.getLoginUser().userName;
            }
            let clickContent;
            switch (clickPosition){
                case "update":
                    clickContent = "点击编辑按钮";
                    break;
                case "add":
                    clickContent = "点击了新增按钮";
                    break;
                case "delete":
                    clickContent = "点击了删除按钮"
                    break;
                case "search":
                    clickContent = "点击查询按钮";
                    break;
                case "clear":
                    clickContent = "点击清空按钮";
                    break;
                case "cancel":
                    clickContent = "点击了取消按钮";
                    break;
                case "view":
                    clickContent = "点击了查看按钮";
                    break;
                default:
                    break;
            }
            buttonRecord.buttonInnerPush(clickPosition,clickContent,userId,userName,this.listViewId,this.formId,rowDataId)
        },

        /**
         * 按键记录赋值
         */
        buttonLastRequest() {
            if (this.viewDefinData.isRecordButton != "1"){
                return;
            }
           buttonRecord.querzRequest();
        },
        /**
         * 清除定时器
         */
        doClearQuerz(){
            buttonRecord.clearTask();
        },
        // 点位信息设置
        setLocation(data, type) {
            if (type === 'spot') {
                this.dotLocationInfo = data;
            } else if (type === 'regionalContour') {
                this.regionalContourInfo = data;
            }
        },
        // 地图关闭
        dotLocationCloseClick() {
            this.dotLocationInfo = {};
            this.dotLocationDialog = false;
        },
        regionalContourCloseClick() {
            this.regionalContourInfo = "";
            this.regionalContourDialog = false;
        },
        // 地图选点确定
        clickDefine(type) {
            let vm = this;
            let rowData = vm.currentRowDataAndSpecialSet.rowData;
            let specialSet = vm.currentRowDataAndSpecialSet.specialSet;
            let ptName = specialSet.ptName;
            if (type === 'spot') {
                if (specialSet.merge === '是') {
                    let locationStr = vm.dotLocationInfo.location.lng + "," + vm.dotLocationInfo.location.lat;
                    let location = specialSet.location;

                    if (location) {
                        rowData[location] = locationStr;
                    }
                } else {
                    let lng = specialSet.lng;
                    let lat = specialSet.lat;
                    if (lng) {
                        rowData[lng] = vm.dotLocationInfo.location.lng;
                    }
                    if (lat) {
                        rowData[lat] = vm.dotLocationInfo.location.lat;
                    }
                }
                let address = specialSet.address;
                if (address) {
                    rowData[address] = vm.dotLocationInfo.address ? vm.dotLocationInfo.address : vm.dotLocationInfo.name;
                }
                let gisInfo = {
                    "ptX": vm.dotLocationInfo.location.lng,
                    "ptY": vm.dotLocationInfo.location.lat,
                    "type": specialSet.type,
                    "ptName": rowData[ptName],
                    "formId": this.formId,
                    "relationId": rowData.ID
                }
                delete rowData["CREATE_TIME"];
                delete rowData["UPDATE_TIME"];
                let paramObj = {
                    formId: this.formId,
                    dataId: rowData.ID,
                    updateParams: JSON.stringify(rowData)
                };
                vm.spcpFormAxios.post(vm.api.plCommonmethod.updateById, paramObj).then(res => {
                    if (res.data && res.data.operateSuccess) {
                        vm.spcpFormAxios.post(vm.api.gisMapDoting.add, gisInfo).then(data => {
                            if (data.data && data.data.operateSuccess) {
                                vm.$message.success("定位修改成功！");
                            } else {
                                vm.$message.error("定位修改失败！");
                            }
                            this.getDataRows();
                        });
                    }
                })
                // this.$set(this.optFormData, this.location, locationStr);
                // if (this.fieldId) {
                //     this.$set(this.optFormData, this.fieldId + "_ptX", this.mapInfo.location.lat);
                //     this.$set(this.optFormData, this.fieldId + "_ptY", this.mapInfo.location.lng);
                // }
                // this.$set(this.optFormData, this.address, this.mapInfo.address ? this.mapInfo.address : this.mapInfo.name);
                vm.dotLocationDialog = false;
            } else if (type === 'regionalContour') {
                let gisInfo = {
                    "ptArea": vm.regionalContourInfo,
                    "type": specialSet.type,
                    "ptName": rowData[ptName],
                    "formId": this.formId,
                    "relationId": rowData.ID
                }
                vm.spcpFormAxios.post(vm.api.gisMapDoting.add, gisInfo).then(data => {
                    if (data.data && data.data.operateSuccess) {
                        vm.$message.success("区域范围设置成功！");
                    } else {
                        vm.$message.error("区域范围设置失败！");
                    }
                    this.getDataRows();
                });
                vm.regionalContourDialog = false;
            }
        },
    },
};
export default formMixins;
